(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.2' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[   1297530,      26527]
NotebookOptionsPosition[    784509,      22962]
NotebookOutlinePosition[   1246982,      26170]
CellTagsIndexPosition[   1246601,      26157]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "@", 
   RowBox[{"FileNameJoin", "@", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"NotebookDirectory", "[", "]"}], ",", 
      "\"\<MarcosFieldEquations.m\>\""}], "}"}]}]}], ";"}]], "Input",
 CellChangeTimes->{{3.875612176412085*^9, 3.875612186031007*^9}, {
   3.875612218583572*^9, 3.8756122628323708`*^9}, 3.87751844120982*^9, {
   3.879062625643471*^9, 3.8790626297516813`*^9}, {3.879573334620831*^9, 
   3.8795733363226233`*^9}, {3.8802655154709682`*^9, 3.880265527863943*^9}, {
   3.885912684863908*^9, 3.885912692011458*^9}, {3.888333063607987*^9, 
   3.8883330675190783`*^9}, {3.889156235824155*^9, 3.889156248095008*^9}},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->"In[1]:=",ExpressionUUID->"b9384e29-ebcf-4d1e-b562-f1587dbf5da2"],

Cell["Marco's field equations", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895082855034227`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontSize->40,
 FontWeight->Bold,
 FontVariations->{"Underline"->True},
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"655f4e1b-1a8e-4d4a-858b-59aa7082063a"],

Cell[BoxData[
 TagBox[GridBox[{
    {Cell["Connection to Part III project",
      FontWeight->Bold,ExpressionUUID->
      "987fc0f7-d9e0-47e4-ae5e-7ae489b9671d"], Cell["\<\
These calculations are designed for your Part III project. Throughout, \
commentary takes the form of green text. Citations, where needed, will be \
managed by direct reference to arXiv numbers. One exception is the source \
referred to throughout as `Blagojevi\[CAcute]'; this pertains to the book \
`Gravitation and Gauge Symmetries'.\
\>",ExpressionUUID->"7428be1d-7e01-4a9f-95e4-5488728c3c53"]}
   },
   AutoDelete->False,
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "TextGrid"]], "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.88950828551973*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 Background->RGBColor[1, 1, 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"e42835ff-d35e-4efe-8f43-5fa8125fbe19"],

Cell["Loading HiGGS and GeoHiGGS", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508285530127*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontSize->20,
 FontVariations->{"Underline"->True},
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"3b809e43-d2f6-4f4a-b810-e1659f4a791b"],

Cell["\<\
For these calculations, we will use the HiGGS and GeoHiGGS packages. Note \
that GeoHiGGS was not developed for public release, and so is not documented. \
The versions of HiGGS and GeoHiGGS used for the computations here are both \
developer-only, and so we include copies of the sources with the tarball.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508285540811*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"26686cf6-295b-456f-8440-5cecf0e696d4"],

Cell[CellGroupData[{

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.889508285621195*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"323b0b43-1933-4a4d-8d67-cc689ab3de7e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xPerm`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.2.3\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2015", ",", "8", ",", "23"}], "}"}]}],
  SequenceForm["Package xAct`xPerm`  version ", "1.2.3", ", ", {2015, 8, 23}],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.889508285622649*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"d6c5f485-5dc5-4431-8543-843bd39d1b58"],

Cell[BoxData["\<\"CopyRight (C) 2003-2020, Jose M. Martin-Garcia, under the \
General Public License.\"\>"], "Print",
 CellChangeTimes->{3.889508285624261*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"b5a8c692-548b-4b15-bc8e-f1606953eb03"],

Cell[BoxData["\<\"Connecting to external linux executable...\"\>"], "Print",
 CellChangeTimes->{3.889508285685277*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"ca3e3494-a5eb-42f9-bf9c-084a6575d0f5"],

Cell[BoxData["\<\"Connection established.\"\>"], "Print",
 CellChangeTimes->{3.889508285733007*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"dce92f5f-0b7b-4832-a094-5a29b828ef4c"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.8895082857345333`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"afc7b575-1f7c-427f-b676-a58e99b54b66"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xTensor`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.2.0\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2021", ",", "10", ",", "17"}], "}"}]}],
  SequenceForm[
  "Package xAct`xTensor`  version ", "1.2.0", ", ", {2021, 10, 17}],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508285736018*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"23de39fb-26b9-4d84-82e3-da0a04a1115f"],

Cell[BoxData["\<\"CopyRight (C) 2002-2021, Jose M. Martin-Garcia, under the \
General Public License.\"\>"], "Print",
 CellChangeTimes->{3.889508285737399*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"574d02c4-4d57-4750-b337-f1c46ac5862c"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.889508285883485*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"48521381-9713-4ce9-864f-2b453436faf0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xPert`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.0.6\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2018", ",", "2", ",", "28"}], "}"}]}],
  SequenceForm["Package xAct`xPert`  version ", "1.0.6", ", ", {2018, 2, 28}],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.889508285885211*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"23024247-584c-4c96-8b6f-c721149f15c5"],

Cell[BoxData["\<\"CopyRight (C) 2005-2020, David Brizuela, Jose M. \
Martin-Garcia and Guillermo A. Mena Marugan, under the General Public \
License.\"\>"], "Print",
 CellChangeTimes->{3.8895082858868093`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"5773044e-1cdd-42e1-957b-023676b56af9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** Variable \"\>", "\[InvisibleSpace]", "$PrePrint", 
   "\[InvisibleSpace]", "\<\" assigned value \"\>", "\[InvisibleSpace]", 
   "ScreenDollarIndices"}],
  SequenceForm[
  "** Variable ", $PrePrint, " assigned value ", 
   xAct`xTensor`ScreenDollarIndices],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508285897978*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"31a3b4d1-3ec0-4321-997b-18407e25a553"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** Variable \"\>", "\[InvisibleSpace]", "$CovDFormat", 
   "\[InvisibleSpace]", "\<\" changed from \"\>", 
   "\[InvisibleSpace]", "\<\"Prefix\"\>", "\[InvisibleSpace]", "\<\" to \"\>",
    "\[InvisibleSpace]", "\<\"Postfix\"\>"}],
  SequenceForm[
  "** Variable ", xAct`xTensor`$CovDFormat, " changed from ", "Prefix", 
   " to ", "Postfix"],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508285899667*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"872a2ace-a03b-45ad-b812-2627df56dad5"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** Option \"\>", "\[InvisibleSpace]", "AllowUpperDerivatives", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "ContractMetric",
    "\[InvisibleSpace]", "\<\" changed from \"\>", "\[InvisibleSpace]", 
   "False", "\[InvisibleSpace]", "\<\" to \"\>", "\[InvisibleSpace]", "True"}],
  SequenceForm[
  "** Option ", xAct`xTensor`AllowUpperDerivatives, " of ", 
   xAct`xTensor`ContractMetric, " changed from ", False, " to ", True],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508285901263*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"1be38cd1-3cc7-44e0-bc52-6df574d1c2b9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** Option \"\>", "\[InvisibleSpace]", "MetricOn", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "MakeRule", 
   "\[InvisibleSpace]", "\<\" changed from \"\>", "\[InvisibleSpace]", "None",
    "\[InvisibleSpace]", "\<\" to \"\>", "\[InvisibleSpace]", "All"}],
  SequenceForm[
  "** Option ", xAct`xTensor`MetricOn, " of ", xAct`xTensor`MakeRule, 
   " changed from ", None, " to ", All],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508285902775*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"7061ace8-a728-4a87-b6e8-c70ed05fdb9c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** Option \"\>", "\[InvisibleSpace]", "ContractMetrics", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "MakeRule", 
   "\[InvisibleSpace]", "\<\" changed from \"\>", "\[InvisibleSpace]", 
   "False", "\[InvisibleSpace]", "\<\" to \"\>", "\[InvisibleSpace]", "True"}],
  SequenceForm[
  "** Option ", xAct`xTensor`ContractMetrics, " of ", xAct`xTensor`MakeRule, 
   " changed from ", False, " to ", True],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508285904158*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"66be857f-bca3-4910-8e8b-bb1965f6d674"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.8895082859183617`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"7aa4e98b-2b90-4a24-b206-6c8dc6252de7"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`Invar`  version \"\>", 
   "\[InvisibleSpace]", "\<\"2.0.5\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2013", ",", "7", ",", "1"}], "}"}]}],
  SequenceForm["Package xAct`Invar`  version ", "2.0.5", ", ", {2013, 7, 1}],
  Editable->False]], "Print",
 CellChangeTimes->{3.8895082859198017`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"01a2dfb3-df3e-4524-923f-193f1ee8f902"],

Cell[BoxData["\<\"CopyRight (C) 2006-2020, J. M. Martin-Garcia, D. Yllanes \
and R. Portugal, under the General Public License.\"\>"], "Print",
 CellChangeTimes->{3.889508285921172*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"e524aae7-d731-4da4-b993-13b51dadae3c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "sigma", "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", "constant symbol ", 
   xAct`Invar`sigma, ". ", ""],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508285934064*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"62a61f68-d160-4d30-8b50-55d247c0e779"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "dim", "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", "constant symbol ", 
   xAct`Invar`dim, ". ", ""],
  Editable->False]], "Print",
 CellChangeTimes->{3.8895082859354687`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"2e9f0da9-6901-493b-b37a-ef1dfe1aec8a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** Option \"\>", "\[InvisibleSpace]", "CurvatureRelations", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\" changed from \"\>", "\[InvisibleSpace]", "True",
    "\[InvisibleSpace]", "\<\" to \"\>", "\[InvisibleSpace]", "False"}],
  SequenceForm[
  "** Option ", xAct`xTensor`CurvatureRelations, " of ", xAct`xTensor`DefCovD,
    " changed from ", True, " to ", False],
  Editable->False]], "Print",
 CellChangeTimes->{3.8895082859368353`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"fd1dd82e-8dcd-48c3-9461-abbbe51137da"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** Variable \"\>", "\[InvisibleSpace]", 
   "$CommuteCovDsOnScalars", "\[InvisibleSpace]", "\<\" changed from \"\>", 
   "\[InvisibleSpace]", "True", "\[InvisibleSpace]", "\<\" to \"\>", 
   "\[InvisibleSpace]", "False"}],
  SequenceForm[
  "** Variable ", xAct`xTensor`$CommuteCovDsOnScalars, " changed from ", True,
    " to ", False],
  Editable->False]], "Print",
 CellChangeTimes->{3.8895082859381723`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"dcf6e6b9-3fe0-4127-98be-ecea4457fed2"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.889508285959552*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"92dfb0cc-4789-482e-b696-12f7352ec09d"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xCoba`  version \"\>", 
   "\[InvisibleSpace]", "\<\"0.8.6\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2021", ",", "2", ",", "28"}], "}"}]}],
  SequenceForm["Package xAct`xCoba`  version ", "0.8.6", ", ", {2021, 2, 28}],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.889508285961441*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"d1cf077f-7149-4890-96bb-cd3adae9d216"],

Cell[BoxData["\<\"CopyRight (C) 2005-2021, David Yllanes and Jose M. \
Martin-Garcia, under the General Public License.\"\>"], "Print",
 CellChangeTimes->{3.889508285963132*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"ea9021ff-5cfd-4155-8028-a1585c035bfd"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.889508286443368*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"4cb132fe-915a-47f8-ba42-3fb34ee0abab"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`SymManipulator`  version \"\>", 
   "\[InvisibleSpace]", "\<\"0.9.5\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2021", ",", "9", ",", "14"}], "}"}]}],
  SequenceForm[
  "Package xAct`SymManipulator`  version ", "0.9.5", ", ", {2021, 9, 14}],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508286445215*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"c13bab9e-02ca-433e-aebc-f78dcdaf592d"],

Cell[BoxData["\<\"CopyRight (C) 2011-2021, Thomas B\[ADoubleDot]ckdahl, under \
the General Public License.\"\>"], "Print",
 CellChangeTimes->{3.88950828644691*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"4f95d5a3-7129-406e-8568-b27ba2b8b59b"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.889508286497303*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"2cd8248f-5158-464d-b269-55c1932871e0"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`xTras`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.4.2\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2014", ",", "10", ",", "30"}], "}"}]}],
  SequenceForm["Package xAct`xTras`  version ", "1.4.2", ", ", {2014, 10, 30}],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508286498863*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"865cb17b-7c96-4fb6-a4d7-b1d2fe214dc9"],

Cell[BoxData["\<\"CopyRight (C) 2012-2014, Teake Nutma, under the General \
Public License.\"\>"], "Print",
 CellChangeTimes->{3.88950828650033*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"6f09edce-f6f6-4d28-9083-cf176e6e82d9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** Variable \"\>", "\[InvisibleSpace]", "$CovDFormat", 
   "\[InvisibleSpace]", "\<\" changed from \"\>", 
   "\[InvisibleSpace]", "\<\"Postfix\"\>", 
   "\[InvisibleSpace]", "\<\" to \"\>", 
   "\[InvisibleSpace]", "\<\"Prefix\"\>"}],
  SequenceForm[
  "** Variable ", xAct`xTensor`$CovDFormat, " changed from ", "Postfix", 
   " to ", "Prefix"],
  Editable->False]], "Print",
 CellChangeTimes->{3.8895082865017443`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"ca7368dd-3f4a-4b30-8b15-7618f53d721e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** Option \"\>", "\[InvisibleSpace]", "CurvatureRelations", 
   "\[InvisibleSpace]", "\<\" of \"\>", "\[InvisibleSpace]", "DefCovD", 
   "\[InvisibleSpace]", "\<\" changed from \"\>", "\[InvisibleSpace]", 
   "False", "\[InvisibleSpace]", "\<\" to \"\>", "\[InvisibleSpace]", "True"}],
  SequenceForm[
  "** Option ", xAct`xTensor`CurvatureRelations, " of ", xAct`xTensor`DefCovD,
    " changed from ", False, " to ", True],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508286503128*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"4420b90e-a632-482d-b04c-c6cc5b4024c1"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.889508286882594*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"0d53df74-4ea0-45c1-bab2-6617740b19f3"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`HiGGS`  version \"\>", 
   "\[InvisibleSpace]", "\<\"2.0.0-developer\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2023", ",", "3", ",", "7"}], "}"}]}],
  SequenceForm[
  "Package xAct`HiGGS`  version ", "2.0.0-developer", ", ", {2023, 3, 7}],
  Editable->False]], "Print",
 CellChangeTimes->{3.8895082868841763`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"a3cb39a0-e8fc-4781-af32-f4418b309b89"],

Cell[BoxData["\<\"CopyRight \[Copyright] 2022, Will E. V. Barker and Manuel \
Hohmann, under the General Public License.\"\>"], "Print",
 CellChangeTimes->{3.889508286885633*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"5a91617f-dbe1-4aee-a2c9-f6a22f3c8c18"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.88950828688699*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"8be6937d-ed63-4de9-94fb-08ec19588479"],

Cell[BoxData["\<\"HiGGS incorporates code by Cyril Pitrou.\"\>"], "Print",
 CellChangeTimes->{3.889508286888233*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"5b413eff-9b52-463e-bdd0-db947ebe7c3e"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.889508298865632*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"f99ae39d-53b8-448a-82ff-7b0faa0ddd7c"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`TexAct`  version \"\>", 
   "\[InvisibleSpace]", "\<\"0.4.3\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2021", ",", "10", ",", "28"}], "}"}]}],
  SequenceForm[
  "Package xAct`TexAct`  version ", "0.4.3", ", ", {2021, 10, 28}],
  Editable->False]], "Print",
 CellChangeTimes->{3.8895082988671618`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"41d159ee-f66b-4ec8-ba2a-989f3f1487f1"],

Cell[BoxData["\<\"CopyRight (C) 2008-2021, Thomas B\[ADoubleDot]ckdahl, Jose \
M. Martin-Garcia and Barry Wardell, under the General Public License.\"\>"], \
"Print",
 CellChangeTimes->{3.889508298868435*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"dd938ca7-6cbf-4871-b2cd-40f5d5e82ad5"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.8895082990510187`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"7c3d6dcd-1bc3-45ce-9428-b4fb990ce33e"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`FieldsX` version \"\>", 
   "\[InvisibleSpace]", "\<\"1.1.4\"\>", "\[InvisibleSpace]", "\<\", \"\>", 
   "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2021", ",", "8", ",", "26"}], "}"}]}],
  SequenceForm["Package xAct`FieldsX` version ", "1.1.4", ", ", {2021, 8, 26}],
  Editable->False]], "Print",
 CellChangeTimes->{3.8895082990526323`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"6cdaf39b-fc2d-48b3-805f-8826f49bb899"],

Cell[BoxData["\<\"Copyright \[Copyright] 2019-2021 Markus B. Fr\[ODoubleDot]b \
under the GNU General Public License.\"\>"], "Print",
 CellChangeTimes->{3.889508299054138*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"65aa0dc6-fa75-4e5a-9e72-bda776caf6f2"],

Cell[BoxData["\<\"FieldsX uses the Multisets package \[Copyright] 2011 David \
Bevan under the Wolfram Library Archive License.\"\>"], "Print",
 CellChangeTimes->{3.8895082990554457`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"244f0ac0-b1fa-4b7f-828a-99eed080d3bb"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** Variable \"\>", "\[InvisibleSpace]", 
   "$CommuteCovDsOnScalars", "\[InvisibleSpace]", "\<\" changed from \"\>", 
   "\[InvisibleSpace]", "False", "\[InvisibleSpace]", "\<\" to \"\>", 
   "\[InvisibleSpace]", "True"}],
  SequenceForm[
  "** Variable ", xAct`xTensor`$CommuteCovDsOnScalars, " changed from ", 
   False, " to ", True],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508299085433*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"77e59c75-0569-4c5b-88f4-8a3bc242ed27"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.8895082991811247`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"6b90bd70-24d1-47bc-8e49-e597a39ba247"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"Package xAct`GeoHiGGS`  version \"\>", 
   "\[InvisibleSpace]", "\<\"1.0.0-developer\"\>", 
   "\[InvisibleSpace]", "\<\", \"\>", "\[InvisibleSpace]", 
   RowBox[{"{", 
    RowBox[{"2023", ",", "3", ",", "13"}], "}"}]}],
  SequenceForm[
  "Package xAct`GeoHiGGS`  version ", "1.0.0-developer", ", ", {2023, 3, 13}],
  
  Editable->False]], "Print",
 CellChangeTimes->{3.889508299182727*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"04e62656-e161-4e61-bda3-7e75717e8c92"],

Cell[BoxData["\<\"CopyRight \[Copyright] 2022, Will E. V. Barker, under the \
General Public License.\"\>"], "Print",
 CellChangeTimes->{3.8895082991841393`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"383567e6-b4a8-4966-8ac9-c0ccaf084a44"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.889508299185401*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"19fd2032-d9b2-47b8-9169-9f457881a9a8"],

Cell[BoxData["\<\"These packages come with ABSOLUTELY NO WARRANTY; for \
details type Disclaimer[]. This is free software, and you are welcome to \
redistribute it under certain conditions. See the General Public License for \
details.\"\>"], "Print",
 CellChangeTimes->{3.889508299186673*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"336ac5be-41b1-4631-ad29-bcd5ef3f3764"],

Cell[BoxData["\<\"------------------------------------------------------------\
\"\>"], "Print",
 CellChangeTimes->{3.889508299188098*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"ed21db18-371d-4c65-8d93-f560c4e43105"]
}, Open  ]],

Cell["\<\
All the requisite packages have now been loaded, so we can proceed with the \
computations.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508299190419*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"7640975b-0fe9-4643-b47c-be5b016d6f9e"],

Cell["1. Deriving the field equations", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508299233378*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontSize->30,
 FontWeight->Bold,
 FontVariations->{"Underline"->True},
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"b84d46a0-8f09-43bb-bc4b-56162b9fcf69"],

Cell["\<\
HiGGS is designed to study the full ten-parameter Poincar\[EAcute] gauge \
theory, including nine extra parameters which activate various Lagrange \
multipliers as defined in arXiv:2205.13534. As a first step, we define the \
most general case of the set of theories we are interested in by constructing \
a rule which constrains the Lagrangian couplings.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508299262761*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"19e9ed3f-c481-497e-afc6-f7da2c4bafe9"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefConstantSymbol", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"constant symbol \"\>", "\[InvisibleSpace]", 
   "MPl", "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm[
  "** ", xAct`xTensor`DefConstantSymbol, ": Defining ", 
   "constant symbol ", $CellContext`MPl, ". ", ""],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508299292267*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"6906580a-4558-4bbe-bf0e-7c16ba99ab3d"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "1"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp1,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "2"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp2,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "3"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp3,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "4"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp4,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "6"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp6,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        RowBox[{
         SuperscriptBox[
          SubscriptBox["\[ScriptCapitalM]", "Pl"], "2"], 
         OverscriptBox["\[Beta]", "^"]}],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "1"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Bet1,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        RowBox[{
         SuperscriptBox[
          SubscriptBox["\[ScriptCapitalM]", "Pl"], "2"], 
         OverscriptBox["\[Beta]", "^"]}],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "2"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Bet2,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        RowBox[{
         SuperscriptBox[
          SubscriptBox["\[ScriptCapitalM]", "Pl"], "2"], 
         OverscriptBox["\[Beta]", "^"]}],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "3"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Bet3,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "_"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "1"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`cAlp1,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "_"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "2"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`cAlp2,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "_"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "3"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`cAlp3,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "_"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "4"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`cAlp4,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "_"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`cAlp5,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "_"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "6"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`cAlp6,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        RowBox[{
         SuperscriptBox[
          SubscriptBox["\[ScriptCapitalM]", "Pl"], "2"], 
         OverscriptBox["\[Beta]", "_"]}],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "1"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`cBet1,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        RowBox[{
         SuperscriptBox[
          SubscriptBox["\[ScriptCapitalM]", "Pl"], "2"], 
         OverscriptBox["\[Beta]", "_"]}],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "2"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`cBet2,
     Editable->False], "\[Rule]", "0"}], ",", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        RowBox[{
         SuperscriptBox[
          SubscriptBox["\[ScriptCapitalM]", "Pl"], "2"], 
         OverscriptBox["\[Beta]", "_"]}],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "3"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`cBet3,
     Editable->False], "\[Rule]", "0"}]}], "}"}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508299299943*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"74aac581-908d-4aa2-b5b2-fef7cc572235"],

Cell["\<\
These rules are used to disable most of the coupling in the general theory. \
The couplings which are not suppressed are those which appear in the \
Lagrangian. Specifically the fifth alpha-hat coupling, which mediates the \
quadratic Riemann-Cartan-Maxwell invariant. These remaining couplings will \
appear in the equations below.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895082993321466`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"494dd010-24a9-45a0-a465-eff3b3de769d"],

Cell["The generalised momenta", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508299358941*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontSize->20,
 FontVariations->{"Underline"->True},
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"d840fcaf-aaa7-4b67-8321-14f0c79c712c"],

Cell["\<\
Having done this, we define the generalised momenta associated with this \
subset of multiplier-constrained Poincar\[EAcute] gauge theory. These \
quantities are defined on p. 50 of Blagojevi\[CAcute].\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508299385015*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"1a6e2d40-ed52-407e-8f50-e0b9455ead24"],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"BGPi", "[", 
    RowBox[{
     RowBox[{"-", "i"}], ",", "k", ",", "l"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`BGPi[-xAct`HiGGS`i, xAct`HiGGS`k, xAct`HiGGS`l], ". ", ""],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508299410334*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"efbc3a1e-25c8-4110-aa87-f4b2c401161a"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"AGPi", "[", 
    RowBox[{
     RowBox[{"-", "i"}], ",", 
     RowBox[{"-", "j"}], ",", "k", ",", "l"}], "]"}], 
   "\[InvisibleSpace]", "\<\". \"\>", "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`AGPi[-xAct`HiGGS`i, -xAct`HiGGS`j, xAct`HiGGS`k, 
    xAct`HiGGS`l], ". ", ""],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508299433522*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"ee72a628-8b2b-4587-ad28-a3b98ad0298c"]
}, Open  ]],

Cell["The translational generalised momenta.", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895082998656883`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"2dcbb549-93f3-44bf-b839-10d5215e6a09"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[
       SubscriptBox["\[Pi]", "\[ScriptB]"],
       FontColor->RGBColor[0., 0., 0.]], 
      StyleBox[GridBox[{
         {" ", "\[GothicK]", "\[GothicL]"},
         {"\[GothicI]", " ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "Rows" -> {{
             Offset[0.]}}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`BGPi[-xAct`HiGGS`i, xAct`HiGGS`k, xAct`HiGGS`l],
  Editable->False]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895082999035587`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"7ae24dfc-66ae-4a53-8f20-5a6022436885"],

Cell[BoxData["0"], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895082999320602`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"eba1453e-4f9a-42e2-8c3f-5e6062f326ff"],

Cell["The rotational generalised momenta.", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895082999598303`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"5f64a805-243d-42e5-bc87-a2782c2cdd0b"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[
       SubscriptBox["\[Pi]", "\[ScriptCapitalA]"],
       FontColor->RGBColor[0., 0., 0.]], 
      StyleBox[GridBox[{
         {" ", " ", "\[GothicK]", "\[GothicL]"},
         {"\[GothicI]", "\[GothicJ]", " ", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "Rows" -> {{
             Offset[0.]}}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`AGPi[-xAct`HiGGS`i, -xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l],
  
  Editable->False]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895082999879293`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"60156e09-a022-4b81-9697-a3e819a5673c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicL]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`i, xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicK]"},
           {"\[GothicJ]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`j, xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False]}], "+", 
  RowBox[{
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      SubscriptBox["\[ScriptCapitalM]", "Pl"],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`MPl,
     Editable->False], "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicK]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`i, xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicL]"},
           {"\[GothicJ]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`j, xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False]}], "-", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "5"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp5,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicL]"},
           {"\[GothicJ]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`j, xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicA]", "\[GothicK]", " "},
           {"\[GothicI]", " ", " ", "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`i, xAct`HiGGS`a, xAct`HiGGS`k, -xAct`HiGGS`a],
    Editable->False]}], "+", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "5"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp5,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicK]"},
           {"\[GothicJ]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`j, xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicA]", "\[GothicL]", " "},
           {"\[GothicI]", " ", " ", "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`i, xAct`HiGGS`a, xAct`HiGGS`l, -xAct`HiGGS`a],
    Editable->False]}], "+", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "5"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp5,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicL]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`i, xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicA]", "\[GothicK]", " "},
           {"\[GothicJ]", " ", " ", "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`a, xAct`HiGGS`k, -xAct`HiGGS`a],
    Editable->False]}], "-", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "5"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp5,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicK]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`i, xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicA]", "\[GothicL]", " "},
           {"\[GothicJ]", " ", " ", "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`a, xAct`HiGGS`l, -xAct`HiGGS`a],
    Editable->False]}], "+", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "5"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp5,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicL]"},
           {"\[GothicJ]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`j, xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicK]", "\[GothicA]", " ", " "},
           {" ", " ", "\[GothicI]", "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[xAct`HiGGS`k, xAct`HiGGS`a, -xAct`HiGGS`i, -xAct`HiGGS`a],
    Editable->False]}], "-", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "5"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp5,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicL]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`i, xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicK]", "\[GothicA]", " ", " "},
           {" ", " ", "\[GothicJ]", "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[xAct`HiGGS`k, xAct`HiGGS`a, -xAct`HiGGS`j, -xAct`HiGGS`a],
    Editable->False]}], "-", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "5"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp5,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicK]"},
           {"\[GothicJ]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`j, xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicL]", "\[GothicA]", " ", " "},
           {" ", " ", "\[GothicI]", "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[xAct`HiGGS`l, xAct`HiGGS`a, -xAct`HiGGS`i, -xAct`HiGGS`a],
    Editable->False]}], "+", 
  RowBox[{"2", " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "5"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp5,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicK]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`i, xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicL]", "\[GothicA]", " ", " "},
           {" ", " ", "\[GothicJ]", "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[xAct`HiGGS`l, xAct`HiGGS`a, -xAct`HiGGS`j, -xAct`HiGGS`a],
    Editable->False]}]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508300055187*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"8cdf4af9-b767-472b-84fc-d82a415ab18b"],

Cell["\<\
These generalised momenta are obtained from the Lagrangian represented in Eq. \
(4) of arXiv:2205.13534, with most of the coupling constants set to zero as \
per the above restrictions. Note that this Lagrangian differs from the most \
general Lagrangian represented in Blagojevi\[CAcute] by the use of so-called \
geometric multiplier fields. These are multipliers which can disable all of \
the Riemann-Cartan or torsion tensors, but which may typically only be used \
piecemeal to disable select portions of said tensors. It is this latter \
use-case which we reaslise in our letter, disabling only the tensor part of \
the torsion.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508300082344*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"69e59fb4-5c2f-4c22-9474-3b397b96e83b"],

Cell["\<\
Another note to be made here is about the caligraphic J and N symbols. Their \
appearance is an unfortunate side-effect of recycling the Hamiltonian-based \
HiGGS package to work on Lagrangian problems: these quantities are the \
measure on the foliation and the Lapse function, respectively, and their \
product is simply the determinant of the translational gauge field, (which is \
equivalent to the square root of the negative metric determinant).\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508300086941*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"9d78e71d-e0fc-47ea-8b40-1f0c35936d2a"],

Cell["The stress-energy tensor", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083001076107`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontSize->20,
 FontVariations->{"Underline"->True},
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"a702087f-7f0a-4a29-afa9-8595374e609c"],

Cell["\<\
Define the stress-energy tensor equation. In general, we will refer to an \
`equation' as an xTensor expression which we understand to vanish on the \
shell, accordingly we do not always make the equality explicit.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083001268673`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"d22212a8-7e21-400c-a7c4-6154d10577ea"],

Cell["\<\
In terms of the generalised momenta, the Riemann-Cartan curvature, the \
torsion, and the gauge fields, and also in terms of projection operators \
which are used to define the various quadratic invariants, the left hand side \
of the stress-energy equation as expressed in the first line of Eq. (3.24b) \
on page 50 of Blagojevi\[CAcute] is as follows.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508300145293*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"fb602348-7013-4bc7-a060-71ecd67a7b1d"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalA]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"\[GothicI]", "\[GothicJ]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`A[-xAct`HiGGS`i, -xAct`HiGGS`j, -xAct`HiGGS`m],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Pi]", "\[ScriptB]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]"},
           {" ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`BGPi[xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicK]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`k, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicM]"},
           {"\[GothicL]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`l, xAct`HiGGS`m],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   SuperscriptBox[
    InterpretationBox[
     StyleBox[
      SubscriptBox["\[ScriptCapitalM]", "Pl"],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`MPl,
     Editable->False], "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Gamma]", 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`G[xAct`HiGGS`j, xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Gamma]", 
        StyleBox[GridBox[{
           {"\[GothicL]", "\[GothicM]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`G[xAct`HiGGS`l, xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicL]", "\[GothicK]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`j, -xAct`HiGGS`l, -xAct`HiGGS`k, -xAct`HiGGS`m],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Pi]", "\[ScriptCapitalA]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicK]", "\[GothicL]", "\[GothicM]", " "},
           {" ", " ", " ", "\[GothicJ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`AGPi[xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, -xAct`HiGGS`j],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicN]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicK]", "\[GothicL]", "\[GothicI]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`k, -xAct`HiGGS`l, -xAct`HiGGS`i, -xAct`HiGGS`m],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "1"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp1,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalR]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"},
           {" ", " ", " ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PR1[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q, xAct`HiGGS`w, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`p, -xAct`HiGGS`q, -xAct`HiGGS`w, -xAct`HiGGS`x],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "2"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp2,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "2"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalR]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"},
           {" ", " ", " ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PR2[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q, xAct`HiGGS`w, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`p, -xAct`HiGGS`q, -xAct`HiGGS`w, -xAct`HiGGS`x],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "3"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp3,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "3"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalR]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"},
           {" ", " ", " ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PR3[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q, xAct`HiGGS`w, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`p, -xAct`HiGGS`q, -xAct`HiGGS`w, -xAct`HiGGS`x],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "4"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp4,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "4"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalR]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"},
           {" ", " ", " ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PR4[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q, xAct`HiGGS`w, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`p, -xAct`HiGGS`q, -xAct`HiGGS`w, -xAct`HiGGS`x],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "5"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp5,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "5"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalR]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"},
           {" ", " ", " ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PR5[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q, xAct`HiGGS`w, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`p, -xAct`HiGGS`q, -xAct`HiGGS`w, -xAct`HiGGS`x],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "^"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "6"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Alp6,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "6"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalR]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"},
           {" ", " ", " ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PR6[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q, xAct`HiGGS`w, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`p, -xAct`HiGGS`q, -xAct`HiGGS`w, -xAct`HiGGS`x],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "_"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "1"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`cAlp1,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalR]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"},
           {" ", " ", " ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PR1[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q, xAct`HiGGS`w, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`p, -xAct`HiGGS`q, -xAct`HiGGS`w, -xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Lambda]", "\[ScriptCapitalR]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`RLambda[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l, -
     xAct`HiGGS`m],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "_"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "2"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`cAlp2,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "2"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalR]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"},
           {" ", " ", " ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PR2[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q, xAct`HiGGS`w, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`p, -xAct`HiGGS`q, -xAct`HiGGS`w, -xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Lambda]", "\[ScriptCapitalR]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`RLambda[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l, -
     xAct`HiGGS`m],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "_"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "3"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`cAlp3,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "3"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalR]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"},
           {" ", " ", " ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PR3[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q, xAct`HiGGS`w, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`p, -xAct`HiGGS`q, -xAct`HiGGS`w, -xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Lambda]", "\[ScriptCapitalR]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`RLambda[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l, -
     xAct`HiGGS`m],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "_"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "4"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`cAlp4,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "4"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalR]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"},
           {" ", " ", " ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PR4[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q, xAct`HiGGS`w, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`p, -xAct`HiGGS`q, -xAct`HiGGS`w, -xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Lambda]", "\[ScriptCapitalR]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`RLambda[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l, -
     xAct`HiGGS`m],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "_"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "5"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`cAlp5,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "5"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalR]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"},
           {" ", " ", " ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PR5[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q, xAct`HiGGS`w, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`p, -xAct`HiGGS`q, -xAct`HiGGS`w, -xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Lambda]", "\[ScriptCapitalR]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`RLambda[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l, -
     xAct`HiGGS`m],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       OverscriptBox["\[Alpha]", "_"],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "6"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`cAlp6,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "6"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalR]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"},
           {" ", " ", " ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PR6[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q, xAct`HiGGS`w, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicP]", "\[GothicQ]", "\[GothicW]", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[-xAct`HiGGS`p, -xAct`HiGGS`q, -xAct`HiGGS`w, -xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Lambda]", "\[ScriptCapitalR]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`RLambda[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l, -
     xAct`HiGGS`m],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Pi]", "\[ScriptB]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]"},
           {" ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`BGPi[xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicL]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`l, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicJ]", "\[GothicI]", "\[GothicK]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`j, -xAct`HiGGS`i, -xAct`HiGGS`k],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       RowBox[{
        SuperscriptBox[
         SubscriptBox["\[ScriptCapitalM]", "Pl"], "2"], 
        OverscriptBox["\[Beta]", "^"]}],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "1"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Bet1,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalT]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]"},
           {" ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PT1[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicM]", "\[GothicP]", "\[GothicQ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`m, -xAct`HiGGS`p, -xAct`HiGGS`q],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       RowBox[{
        SuperscriptBox[
         SubscriptBox["\[ScriptCapitalM]", "Pl"], "2"], 
        OverscriptBox["\[Beta]", "^"]}],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "2"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Bet2,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "2"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalT]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]"},
           {" ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PT2[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicM]", "\[GothicP]", "\[GothicQ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`m, -xAct`HiGGS`p, -xAct`HiGGS`q],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       RowBox[{
        SuperscriptBox[
         SubscriptBox["\[ScriptCapitalM]", "Pl"], "2"], 
        OverscriptBox["\[Beta]", "^"]}],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "3"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Bet3,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "3"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalT]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]"},
           {" ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PT3[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicM]", "\[GothicP]", "\[GothicQ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`m, -xAct`HiGGS`p, -xAct`HiGGS`q],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       RowBox[{
        SuperscriptBox[
         SubscriptBox["\[ScriptCapitalM]", "Pl"], "2"], 
        OverscriptBox["\[Beta]", "_"]}],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "1"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`cBet1,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalT]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]"},
           {" ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PT1[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicM]", "\[GothicP]", "\[GothicQ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`m, -xAct`HiGGS`p, -xAct`HiGGS`q],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Lambda]", "\[ScriptCapitalT]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`TLambda[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       RowBox[{
        SuperscriptBox[
         SubscriptBox["\[ScriptCapitalM]", "Pl"], "2"], 
        OverscriptBox["\[Beta]", "_"]}],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "2"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`cBet2,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "2"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalT]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]"},
           {" ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PT2[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicM]", "\[GothicP]", "\[GothicQ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`m, -xAct`HiGGS`p, -xAct`HiGGS`q],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Lambda]", "\[ScriptCapitalT]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`TLambda[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[
     RowBox[{
      StyleBox[
       RowBox[{
        SuperscriptBox[
         SubscriptBox["\[ScriptCapitalM]", "Pl"], "2"], 
        OverscriptBox["\[Beta]", "_"]}],
       FontColor->RGBColor[1., 0., 0.]], 
      StyleBox[
       UnderscriptBox[".", "3"],
       FontColor->RGBColor[0., 0., 1.]]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`cBet3,
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalN]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`Lapse[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "3"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox[
          SubscriptBox[
           OverscriptBox["\[ScriptCapitalP]", "^"], "\[ScriptCapitalT]"],
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]", "\[GothicM]", 
            "\[GothicP]", "\[GothicQ]"},
           {" ", " ", " ", " ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`PT3[
    xAct`HiGGS`j, xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m, xAct`HiGGS`p, 
     xAct`HiGGS`q],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicM]", "\[GothicP]", "\[GothicQ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`m, -xAct`HiGGS`p, -xAct`HiGGS`q],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Lambda]", "\[ScriptCapitalT]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicJ]", "\[GothicK]", "\[GothicL]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`TLambda[-xAct`HiGGS`j, -xAct`HiGGS`k, -xAct`HiGGS`l],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicN]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicK]", "\[GothicL]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`k, xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "\[GothicL]"], GridBox[{
        {
         StyleBox[
          SubscriptBox["\[Pi]", "\[ScriptB]"],
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"\[GothicI]", "\[GothicJ]", "\[GothicK]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`CD[-xAct`HiGGS`l][
     $CellContext`BGPi[-xAct`HiGGS`i, -xAct`HiGGS`j, -xAct`HiGGS`k]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Pi]", "\[ScriptB]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicJ]", "\[GothicK]"},
           {"\[GothicI]", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`BGPi[-xAct`HiGGS`i, xAct`HiGGS`j, xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicM]"},
           {"\[GothicJ]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`j, xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicP]"},
           {"\[GothicK]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`k, xAct`HiGGS`p],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicL]", "\[GothicN]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`l, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "\[GothicP]"], GridBox[{
        {
         StyleBox["\[ScriptB]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " "},
            {"\[GothicL]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`CD[-xAct`HiGGS`p][
     xAct`HiGGS`B[-xAct`HiGGS`l, -xAct`HiGGS`m]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Pi]", "\[ScriptB]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicJ]", "\[GothicK]"},
           {"\[GothicI]", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`BGPi[-xAct`HiGGS`i, xAct`HiGGS`j, xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicJ]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`j, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicL]"},
           {"\[GothicK]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`k, xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", "\[GothicP]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`m, xAct`HiGGS`p],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "\[GothicP]"], GridBox[{
        {
         StyleBox["\[ScriptB]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " "},
            {"\[GothicM]", "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`CD[-xAct`HiGGS`p][
     xAct`HiGGS`B[-xAct`HiGGS`m, -xAct`HiGGS`l]],
    Editable->False]}]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083003262873`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"0cd8973f-3019-433f-91e0-fb859654f7e2"],

Cell["\<\
We now impose the restriction on the coupling constants to go over to the \
most general case studied, and then we expand the projection operators and \
the generalised momenta. We subtract the right hand side, i.e. the \
(asymmetric) matter stress-energy tensor, to form the stress-energy equation.\
\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508300355853*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"f2575653-814a-4991-a2de-9ce7ed722149"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox[
        SubscriptBox["\[ScriptCapitalM]", "Pl"],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`MPl,
       Editable->False], "2"]}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicK]", " ", " "},
            {"\[GothicJ]", " ", "\[GothicI]", "\[GothicK]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`i, -xAct`HiGGS`k],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicK]", " ", " "},
            {" ", " ", "\[GothicJ]", "\[GothicK]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`j, -xAct`HiGGS`k],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicK]", " ", "\[GothicL]"},
            {"\[GothicJ]", " ", "\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`i, xAct`HiGGS`l],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicM]", " ", " "},
            {"\[GothicK]", " ", "\[GothicL]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`k, xAct`HiGGS`m, -xAct`HiGGS`l, -xAct`HiGGS`m],
     Editable->False]}], "-", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicK]", " ", "\[GothicL]"},
            {" ", " ", "\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`j, xAct`HiGGS`l],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicM]", " ", " "},
            {"\[GothicK]", " ", "\[GothicL]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`k, xAct`HiGGS`m, -xAct`HiGGS`l, -xAct`HiGGS`m],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicM]", " ", " "},
            {"\[GothicJ]", " ", "\[GothicL]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`m, -xAct`HiGGS`l, -xAct`HiGGS`m],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicK]", "\[GothicL]", " ", " "},
            {" ", " ", "\[GothicI]", "\[GothicK]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`k, xAct`HiGGS`l, -xAct`HiGGS`i, -xAct`HiGGS`k],
     Editable->False]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicK]", "\[GothicL]", " ", " "},
            {" ", " ", "\[GothicI]", "\[GothicK]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`k, xAct`HiGGS`l, -xAct`HiGGS`i, -xAct`HiGGS`k],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicM]", " ", " "},
            {"\[GothicL]", " ", "\[GothicJ]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`l, xAct`HiGGS`m, -xAct`HiGGS`j, -xAct`HiGGS`m],
     Editable->False]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicK]", " ", "\[GothicL]"},
            {"\[GothicJ]", " ", "\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`i, xAct`HiGGS`l],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicM]", " ", " "},
            {"\[GothicL]", " ", "\[GothicK]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`l, xAct`HiGGS`m, -xAct`HiGGS`k, -xAct`HiGGS`m],
     Editable->False]}], "+", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicK]", " ", "\[GothicL]"},
            {" ", " ", "\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`j, xAct`HiGGS`l],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicM]", " ", " "},
            {"\[GothicL]", " ", "\[GothicK]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`l, xAct`HiGGS`m, -xAct`HiGGS`k, -xAct`HiGGS`m],
     Editable->False]}], "+", 
   FractionBox[
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[Tau]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicN]", " "},
            {" ", "\[GothicI]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Tau[xAct`HiGGS`n, -xAct`HiGGS`i],
     Editable->False], 
    RowBox[{
     InterpretationBox[
      StyleBox["\[ScriptCapitalJ]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`J[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalN]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`Lapse[],
      Editable->False]}]]}], "\[Equal]", "0"}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301024342*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"1d261ece-ab42-4b33-a7cf-22ae810c6dcc"],

Cell["\<\
This equation is nearly ready to use, but the (asymmetric) stress-energy \
tensor of matter first needs some attention. This is because it still depends \
on the contorsion, and later on in the analysis we will need to refer only to \
the metric-based part, from which the symmetric Einstein stress-energy tensor \
is eventually derived. Before moving on to the spin equations therefore, we \
will explore this matter.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301047304*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"a86af238-0e18-4d41-a788-62e409387ad1"],

Cell["\<\
Define the contorsion tensor to have strictly two anholonomic indices and a \
holonomic index, in line with its interpretation as a part of the connection. \
This is recovered through Eq. (3.32b) on p. 57 of Blagojevi\[CAcute], with \
comparisons with Eq (3.46) on p. 61, and checks against the methods used on \
p. 67. Great care must be taken when attempting to achieve this index \
configuration using contractions of the HiGGS anholonomic torsion tensor with \
the translational gauge field and inverse:\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301069132*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"97a46e92-275a-47a1-a901-467264d86f54"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"Contorsion", "[", 
    RowBox[{"i", ",", "j", ",", 
     RowBox[{"-", "m"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`Contorsion[xAct`HiGGS`i, xAct`HiGGS`j, -xAct`HiGGS`m], ". ", 
   ""],
  Editable->False]], "Print",
 CellChangeTimes->{3.8895083010893106`*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"9ca02f3c-a9ba-4b26-9633-0117c1b9c7a6"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox["\[ScriptCapitalK]",
       FontColor->RGBColor[0., 0., 0.]], 
      StyleBox[GridBox[{
         {"\[GothicI]", "\[GothicJ]", " "},
         {" ", " ", "\[GothicM]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "Rows" -> {{
             Offset[0.]}}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`Contorsion[xAct`HiGGS`i, xAct`HiGGS`j, -xAct`HiGGS`m],
  Editable->False]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301108913*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"cb4d3995-bf8b-4ca6-9ce1-2f53df529da7"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicA]", " "},
           {" ", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`a, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicI]", "\[GothicJ]"},
           {"\[GothicA]", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`a, xAct`HiGGS`i, xAct`HiGGS`j],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicA]", " "},
           {" ", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`a, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicI]", "\[GothicJ]", " "},
           {" ", " ", "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[xAct`HiGGS`i, xAct`HiGGS`j, -xAct`HiGGS`a],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicA]", " "},
           {" ", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`a, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicI]", " "},
           {" ", " ", "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[xAct`HiGGS`j, xAct`HiGGS`i, -xAct`HiGGS`a],
    Editable->False]}]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301157699*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"84e5208f-6d8b-4803-b36f-4d82c8bbbad6"],

Cell["\<\
Now in HiGGS we are used to using the following stress-energy tensor.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301180402*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"e09aef32-3cff-4a32-8413-f0cab2e0ab9f"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox["\[Tau]",
       FontColor->RGBColor[0., 0., 0.]], 
      StyleBox[GridBox[{
         {"\[GothicM]", " "},
         {" ", "\[GothicK]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "Rows" -> {{
             Offset[0.]}}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`HiGGS`Tau[xAct`HiGGS`m, -xAct`HiGGS`k],
  Editable->False]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301202001*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"218c7d03-6c3a-47cc-bf25-13520291791b"],

Cell["\<\
But this tensor, the (negative) variational derivative of the matter \
Lagrangian (density) as defined in Eq. (3.21) on p. 48 of Blagojevi\[CAcute], \
still depends on the rotational gauge field. In the second order formalism, \
this means that it will depend both on the Ricci rotation coefficients and on \
the contorsion.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301223361*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"d3e25584-c3d9-4e03-89c2-44a581a6a931"],

Cell["\<\
We now define the part which depends only on the Ricci rotation coefficients.\
\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301243058*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"78f997fa-c618-4a9e-b48c-1e4fae4b04f4"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"TorsionlessTau", "[", 
    RowBox[{
     RowBox[{"-", "i"}], ",", 
     RowBox[{"-", "j"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`TorsionlessTau[-xAct`HiGGS`i, -xAct`HiGGS`j], ". ", ""],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508301262998*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"f05579ee-6cbc-46b5-9f4f-779a59ef958f"],

Cell["\<\
To understand how the contorsion dependency enters in, we look at Eq.  \
(3.75b) on p. 66 of Blagojevi\[CAcute]. This separated Lagrangian is varied \
with respect to the translational gauge field, in such a way that the Ricci \
rotation coefficients and contorsion are held constant (they must have two \
Roman and one Greek index, so that they algebraically inherit the role of the \
rotational gauge field). The variation of the first term will give us the \
above quantity, which can then be expressed in terms of the Einstein tensor \
using the methods of p. 67 (we do this later).\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301265409*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"f35e9a5b-c4dd-47e3-b2a7-9945e1d50e0e"],

Cell["\<\
The variation of the second term rests entirely on the variation of the spin \
tensor. This is rather suspicious, since it means that the details of the \
spin tensor of matter have a say in whether we can recover the second order \
formalism at all. However to proceed, we look to the Dirac matter spin tensor \
in Example 2 at the end of p. 49 of Blagojevi\[CAcute]. We define a (Lorentz) \
quantity which is truly independent of the gravitational variables, being \
composed of Grassmann numbers and (indexed) generators of the Clifford \
algebra.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083012848463`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"f4b93215-c9c0-48a0-ad66-68810261018f"],

Cell[BoxData[
 InterpretationBox[
  RowBox[{"\<\"** \"\>", "\[InvisibleSpace]", "DefTensor", 
   "\[InvisibleSpace]", "\<\": Defining \"\>", 
   "\[InvisibleSpace]", "\<\"tensor \"\>", "\[InvisibleSpace]", 
   RowBox[{"SigmaRoman", "[", 
    RowBox[{"i", ",", 
     RowBox[{"-", "j"}], ",", 
     RowBox[{"-", "k"}]}], "]"}], "\[InvisibleSpace]", "\<\". \"\>", 
   "\[InvisibleSpace]", "\<\"\"\>"}],
  SequenceForm["** ", xAct`xTensor`DefTensor, ": Defining ", "tensor ", 
   $CellContext`SigmaRoman[xAct`HiGGS`i, -xAct`HiGGS`j, -xAct`HiGGS`k], ". ", 
   ""],
  Editable->False]], "Print",
 CellChangeTimes->{3.889508301303671*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"94db25a8-ff82-49c6-9371-3b3906f4ffe5"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox["\[ScriptCapitalX]",
       FontColor->RGBColor[0., 0., 0.]], 
      StyleBox[GridBox[{
         {"\[GothicI]", " ", " "},
         {" ", "\[GothicJ]", "\[GothicK]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "Rows" -> {{
             Offset[0.]}}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`SigmaRoman[xAct`HiGGS`i, -xAct`HiGGS`j, -xAct`HiGGS`k],
  Editable->False]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301322945*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"570c9060-fb52-44a6-aa2e-389e9d5b02f6"],

Cell["Now the spin tensor is defined as follows.", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.88950830134307*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"9f952f08-0179-4acb-ad53-c119682c92aa"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox["\[Sigma]",
       FontColor->RGBColor[0., 0., 0.]], 
      StyleBox[GridBox[{
         {"\[GothicI]", " ", " "},
         {" ", "\[GothicJ]", "\[GothicK]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "Rows" -> {{
             Offset[0.]}}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`HiGGS`Sigma[xAct`HiGGS`i, -xAct`HiGGS`j, -xAct`HiGGS`k],
  Editable->False]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083013629417`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"b5bbdc2c-55b8-4870-b53d-0327b9f76fa3"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[ScriptH]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicA]", "\[GothicI]"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`i],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox["\[ScriptCapitalJ]",
    ShowAutoStyles->False,
    AutoSpacing->False,
    FontColor->RGBColor[0., 0., 0.]],
   xAct`HiGGS`J[],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox["\[ScriptCapitalN]",
    ShowAutoStyles->False,
    AutoSpacing->False,
    FontColor->RGBColor[0., 0., 0.]],
   xAct`HiGGS`Lapse[],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[ScriptCapitalX]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {" ", " ", " "},
          {"\[GothicA]", "\[GothicJ]", "\[GothicK]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`SigmaRoman[-xAct`HiGGS`a, -xAct`HiGGS`j, -xAct`HiGGS`k],
   Editable->False]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301408012*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"96617eac-23dc-476b-9652-b1dce9217326"],

Cell["\<\
The whole of the correction to the second order matter Lagrangian density now \
takes the following form.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301428357*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"d73d082a-4779-4c5d-9abe-ba15980c9aba"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[ScriptCapitalK]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicI]", "\[GothicJ]", " "},
          {" ", " ", "\[GothicM]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Contorsion[xAct`HiGGS`i, xAct`HiGGS`j, -xAct`HiGGS`m],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[Sigma]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicM]", " ", " "},
          {" ", "\[GothicI]", "\[GothicJ]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`Sigma[xAct`HiGGS`m, -xAct`HiGGS`i, -xAct`HiGGS`j],
   Editable->False]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301447659*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"6be96410-1bf9-449b-a873-8f2892d0394d"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "2"], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[ScriptCapitalK]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicM]", "\[GothicA]", " "},
          {" ", " ", "\[GothicJ]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`Contorsion[xAct`HiGGS`m, xAct`HiGGS`a, -xAct`HiGGS`j],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[ScriptH]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicI]", "\[GothicJ]"},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`H[xAct`HiGGS`i, xAct`HiGGS`j],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox["\[ScriptCapitalJ]",
    ShowAutoStyles->False,
    AutoSpacing->False,
    FontColor->RGBColor[0., 0., 0.]],
   xAct`HiGGS`J[],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox["\[ScriptCapitalN]",
    ShowAutoStyles->False,
    AutoSpacing->False,
    FontColor->RGBColor[0., 0., 0.]],
   xAct`HiGGS`Lapse[],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[ScriptCapitalX]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {" ", " ", " "},
          {"\[GothicI]", "\[GothicM]", "\[GothicA]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`SigmaRoman[-xAct`HiGGS`i, -xAct`HiGGS`m, -xAct`HiGGS`a],
   Editable->False]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301492972*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"38b4785c-5b69-4f18-ac19-480c5ae84db3"],

Cell["\<\
Now we remind ourselves about the derivatives with respect to the \
translational gauge field of some quantities.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301513144*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"0f72e7b7-7ed1-44e4-b60a-53bb0bdce2de"],

Cell["The lapse function.", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083015297318`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"0982f795-e428-4d19-8d15-b8ddb256bfff"],

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[ScriptCapitalN]",
   ShowAutoStyles->False,
   AutoSpacing->False,
   FontColor->RGBColor[0., 0., 0.]],
  xAct`HiGGS`Lapse[],
  Editable->False]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083015478573`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"d7d4a64a-4e5a-4912-b9ff-f899ec1dc807"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[ScriptH]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicA]", 
           RowBox[{"\[GothicA]", "'"}]},
          {" ", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox["\[ScriptCapitalN]",
    ShowAutoStyles->False,
    AutoSpacing->False,
    FontColor->RGBColor[0., 0., 0.]],
   xAct`HiGGS`Lapse[],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[ScriptN]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {" "},
          {"\[GothicA]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`V[-xAct`HiGGS`a],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[ScriptN]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicB]"},
          {" "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`V[xAct`HiGGS`b],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "\[GothicM]"], GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " "},
           {"\[GothicB]", 
            RowBox[{"\[GothicA]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`CD[-xAct`HiGGS`m][
    xAct`HiGGS`B[-xAct`HiGGS`b, -xAct`HiGGS`a1]],
   Editable->False]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301597767*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"aca6ec55-9556-45e8-9c9a-845b1241b594"],

Cell["The spatial measure.", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301619319*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"e547d27a-2162-4ea3-ad37-2ef09e5f4c86"],

Cell[BoxData[
 InterpretationBox[
  StyleBox["\[ScriptCapitalJ]",
   ShowAutoStyles->False,
   AutoSpacing->False,
   FontColor->RGBColor[0., 0., 0.]],
  xAct`HiGGS`J[],
  Editable->False]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083016383343`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"ed922378-bd8c-4ceb-b516-8d36678b0907"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "\[GothicM]"], GridBox[{
        {
         StyleBox["\[ScriptB]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " "},
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`CD[-xAct`HiGGS`m][
     xAct`HiGGS`B[-xAct`HiGGS`a, -xAct`HiGGS`a1]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox["\[ScriptCapitalJ]",
     ShowAutoStyles->False,
     AutoSpacing->False,
     FontColor->RGBColor[0., 0., 0.]],
    xAct`HiGGS`J[],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptN]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" "},
           {"\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`V[-xAct`HiGGS`a],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptN]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicB]"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`V[xAct`HiGGS`b],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "\[GothicM]"], GridBox[{
        {
         StyleBox["\[ScriptB]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " "},
            {"\[GothicB]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`CD[-xAct`HiGGS`m][
     xAct`HiGGS`B[-xAct`HiGGS`b, -xAct`HiGGS`a1]],
    Editable->False]}]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301687167*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"db353d9f-513f-4f9b-a0c8-aafde492e828"],

Cell["The inverse gauge field.", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083017072153`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"7719cccd-757a-4763-a80f-ac47a8e9174d"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox["\[ScriptH]",
       FontColor->RGBColor[0., 0., 0.]], 
      StyleBox[GridBox[{
         {" ", "\[GothicN]"},
         {"\[GothicI]", " "}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "Rows" -> {{
             Offset[0.]}}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
  Editable->False]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301726915*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"4d414f63-f7a4-495b-8cc6-d7055f83ad50"],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {
            RowBox[{"\[GothicA]", "'"}], "\[GothicN]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`a1, xAct`HiGGS`n],
    Editable->False]}], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[ScriptH]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {" ", "\[GothicA]"},
          {"\[GothicI]", " "}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`a],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "\[GothicM]"], GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " "},
           {
            RowBox[{"\[GothicA]", "'"}], "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`CD[-xAct`HiGGS`m][
    xAct`HiGGS`B[-xAct`HiGGS`a1, -xAct`HiGGS`a]],
   Editable->False]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301771978*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"d474b63f-5321-4855-b79e-084a20afd87e"],

Cell["\<\
Now that the dependence of the contorsion correction to the second-order \
Lagrangian on the translational gauge field has been made clear, we can use \
the above derivative laws to reconstruct the variational derivative of the \
correction.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301791854*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"3dee2795-4d05-4efe-a2f8-6bccf06b2d21"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "2"]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalK]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicI]", "\[GothicN]", " "},
           {" ", " ", "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Contorsion[xAct`HiGGS`i, xAct`HiGGS`n, -xAct`HiGGS`a],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicA]"},
           {"\[GothicK]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`k, xAct`HiGGS`a],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", " ", " "},
           {" ", "\[GothicI]", "\[GothicN]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[xAct`HiGGS`m, -xAct`HiGGS`i, -xAct`HiGGS`n],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalK]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicA]", "\[GothicI]", "\[GothicN]"},
           {" ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`Contorsion[xAct`HiGGS`a, xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicM]"},
           {"\[GothicK]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`k, xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicN]", "\[GothicA]", "\[GothicI]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[-xAct`HiGGS`n, -xAct`HiGGS`a, -xAct`HiGGS`i],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox[
        RowBox[{"\[Tau]", 
         RowBox[{"(", "\[CapitalDelta]", ")"}]}],
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicM]", " "},
          {" ", "\[GothicK]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`TorsionlessTau[xAct`HiGGS`m, -xAct`HiGGS`k],
   Editable->False]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301859252*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"f1aa6cd9-3914-4afc-8549-0e0268c04613"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "2"]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", "\[GothicA]", "\[GothicI]"},
           {" ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[xAct`HiGGS`m, xAct`HiGGS`a, xAct`HiGGS`i],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicA]", "\[GothicK]", "\[GothicI]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`a, -xAct`HiGGS`k, -xAct`HiGGS`i],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "4"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicA]", "\[GothicI]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`a, xAct`HiGGS`i],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicM]"},
           {"\[GothicK]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`k, xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]", 
            RowBox[{"\[GothicA]", "'"}]},
           {"\[GothicI]", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[-xAct`HiGGS`i, xAct`HiGGS`n, xAct`HiGGS`a1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicA]", "\[GothicN]", 
            RowBox[{"\[GothicA]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`a, -xAct`HiGGS`n, -xAct`HiGGS`a1],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "4"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", "\[GothicI]", "\[GothicN]"},
           {" ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[xAct`HiGGS`m, xAct`HiGGS`i, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicK]", "\[GothicI]", "\[GothicN]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`k, -xAct`HiGGS`i, -xAct`HiGGS`n],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicA]", "\[GothicI]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`a, xAct`HiGGS`i],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicM]"},
           {"\[GothicK]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`k, xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]", 
            RowBox[{"\[GothicA]", "'"}]},
           {"\[GothicI]", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[-xAct`HiGGS`i, xAct`HiGGS`n, xAct`HiGGS`a1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicN]", "\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`n, -xAct`HiGGS`a, -xAct`HiGGS`a1],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox[
        RowBox[{"\[Tau]", 
         RowBox[{"(", "\[CapitalDelta]", ")"}]}],
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicM]", " "},
          {" ", "\[GothicK]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`TorsionlessTau[xAct`HiGGS`m, -xAct`HiGGS`k],
   Editable->False]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301920455*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"f8d09264-8ab1-46dd-887b-e5ca058ee75c"],

Cell["\<\
We are now ready to write a rule which converts the usual HiGGS stress-energy \
tensor into torsion-free and torsionful parts.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301940916*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"0c0bb409-a2f6-4fee-b8c8-3b461b842efa"],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox["\[Tau]",
       FontColor->RGBColor[0., 0., 0.]], 
      StyleBox[GridBox[{
         {"\[GothicM]", " "},
         {" ", "\[GothicK]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "Rows" -> {{
             Offset[0.]}}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  xAct`HiGGS`Tau[xAct`HiGGS`m, -xAct`HiGGS`k],
  Editable->False]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508301960956*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"f4f145a4-47cd-4c20-a77d-fb8afa3c8a77"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["1", "4"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`a, xAct`HiGGS`a1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicM]"},
           {"\[GothicK]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`k, xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicB]", 
            RowBox[{"\[GothicB]", "'"}]},
           {
            RowBox[{"\[GothicA]", "'"}], " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[-xAct`HiGGS`a1, xAct`HiGGS`b, xAct`HiGGS`b1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicA]", "\[GothicB]", 
            RowBox[{"\[GothicB]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`a, -xAct`HiGGS`b, -xAct`HiGGS`b1],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", "\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]},
           {" ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[xAct`HiGGS`m, xAct`HiGGS`a, xAct`HiGGS`a1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicA]", "\[GothicK]", 
            RowBox[{"\[GothicA]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`a, -xAct`HiGGS`k, -xAct`HiGGS`a1],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`a, xAct`HiGGS`a1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicM]"},
           {"\[GothicK]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`k, xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicB]", 
            RowBox[{"\[GothicB]", "'"}]},
           {
            RowBox[{"\[GothicA]", "'"}], " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[-xAct`HiGGS`a1, xAct`HiGGS`b, xAct`HiGGS`b1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicB]", "\[GothicA]", 
            RowBox[{"\[GothicB]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`b, -xAct`HiGGS`a, -xAct`HiGGS`b1],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "4"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", "\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]},
           {" ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[xAct`HiGGS`m, xAct`HiGGS`a, xAct`HiGGS`a1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicK]", "\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`k, -xAct`HiGGS`a, -xAct`HiGGS`a1],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox[
        RowBox[{"\[Tau]", 
         RowBox[{"(", "\[CapitalDelta]", ")"}]}],
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicM]", " "},
          {" ", "\[GothicK]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   $CellContext`TorsionlessTau[xAct`HiGGS`m, -xAct`HiGGS`k],
   Editable->False]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.88950830202115*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"24fe1dd9-9f96-4acd-8ea6-bc2e71ca3f08"],

Cell["Now we will also write a rule to invert this.", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508302041799*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"3ba01e8b-167b-479a-81ec-f428c62f5f81"],

Cell[CellGroupData[{

Cell[BoxData["\<\" ** MakeQuotientRule: canonicalised expression with tensor \
substituted by rule:\"\>"], "Print",
 CellChangeTimes->{3.889508302094733*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"b636a247-8891-49df-a008-20813b773799"],

Cell[BoxData["0"], "Print",
 CellChangeTimes->{3.88950830212293*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"4bf2e0fa-3ba0-4464-a442-50a9cc50abdf"]
}, Open  ]],

Cell[BoxData[
 InterpretationBox[
  StyleBox[GridBox[{
     {
      StyleBox[
       RowBox[{"\[Tau]", 
        RowBox[{"(", "\[CapitalDelta]", ")"}]}],
       FontColor->RGBColor[0., 0., 0.]], 
      StyleBox[GridBox[{
         {"\[GothicM]", " "},
         {" ", "\[GothicK]"}
        },
        GridBoxSpacings->{"Columns" -> {
            Offset[0.], {
             Offset[0.034999999999999996`]}, 
            Offset[0.]}, "Rows" -> {{
             Offset[0.]}}}],
       FontSize->Rational[39, 4]]}
    },
    GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.034999999999999996`]}, 
        Offset[0.27999999999999997`]}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}}],
   ShowAutoStyles->False,
   AutoSpacing->False],
  $CellContext`TorsionlessTau[xAct`HiGGS`m, -xAct`HiGGS`k],
  Editable->False]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083021533546`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"ef82b0f8-f076-461a-bff9-66027e60bdfe"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "4"]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`a, xAct`HiGGS`a1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicM]"},
           {"\[GothicK]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`k, xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicB]", 
            RowBox[{"\[GothicB]", "'"}]},
           {
            RowBox[{"\[GothicA]", "'"}], " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[-xAct`HiGGS`a1, xAct`HiGGS`b, xAct`HiGGS`b1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicA]", "\[GothicB]", 
            RowBox[{"\[GothicB]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`a, -xAct`HiGGS`b, -xAct`HiGGS`b1],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", "\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]},
           {" ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[xAct`HiGGS`m, xAct`HiGGS`a, xAct`HiGGS`a1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicA]", "\[GothicK]", 
            RowBox[{"\[GothicA]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`a, -xAct`HiGGS`k, -xAct`HiGGS`a1],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`a, xAct`HiGGS`a1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicM]"},
           {"\[GothicK]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`k, xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicB]", 
            RowBox[{"\[GothicB]", "'"}]},
           {
            RowBox[{"\[GothicA]", "'"}], " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[-xAct`HiGGS`a1, xAct`HiGGS`b, xAct`HiGGS`b1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicB]", "\[GothicA]", 
            RowBox[{"\[GothicB]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`b, -xAct`HiGGS`a, -xAct`HiGGS`b1],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "4"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", "\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]},
           {" ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[xAct`HiGGS`m, xAct`HiGGS`a, xAct`HiGGS`a1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicK]", "\[GothicA]", 
            RowBox[{"\[GothicA]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[-xAct`HiGGS`k, -xAct`HiGGS`a, -xAct`HiGGS`a1],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[Tau]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicM]", " "},
          {" ", "\[GothicK]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`Tau[xAct`HiGGS`m, -xAct`HiGGS`k],
   Editable->False]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508302225152*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"a57de255-7d1b-4c42-b265-7c7745be17b6"],

Cell["\<\
Now the second order formalism `splitting' of the stress-energy current is \
understood, we will `split' the stress-energy equation.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508302247423*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"c303681a-55e6-4cfd-8724-f0b7162d116c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     SuperscriptBox[
      InterpretationBox[
       StyleBox[
        SubscriptBox["\[ScriptCapitalM]", "Pl"],
        ShowAutoStyles->False,
        AutoSpacing->False],
       $CellContext`MPl,
       Editable->False], "2"]}], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicK]", " ", " "},
            {"\[GothicJ]", " ", "\[GothicI]", "\[GothicK]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`i, -xAct`HiGGS`k],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicK]", " ", " "},
            {" ", " ", "\[GothicJ]", "\[GothicK]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`j, -xAct`HiGGS`k],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicK]", " ", "\[GothicL]"},
            {"\[GothicJ]", " ", "\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`i, xAct`HiGGS`l],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicM]", " ", " "},
            {"\[GothicK]", " ", "\[GothicL]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`k, xAct`HiGGS`m, -xAct`HiGGS`l, -xAct`HiGGS`m],
     Editable->False]}], "-", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicK]", " ", "\[GothicL]"},
            {" ", " ", "\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`j, xAct`HiGGS`l],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicM]", " ", " "},
            {"\[GothicK]", " ", "\[GothicL]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`k, xAct`HiGGS`m, -xAct`HiGGS`l, -xAct`HiGGS`m],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicM]", " ", " "},
            {"\[GothicJ]", " ", "\[GothicL]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`m, -xAct`HiGGS`l, -xAct`HiGGS`m],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicK]", "\[GothicL]", " ", " "},
            {" ", " ", "\[GothicI]", "\[GothicK]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`k, xAct`HiGGS`l, -xAct`HiGGS`i, -xAct`HiGGS`k],
     Editable->False]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicK]", "\[GothicL]", " ", " "},
            {" ", " ", "\[GothicI]", "\[GothicK]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`k, xAct`HiGGS`l, -xAct`HiGGS`i, -xAct`HiGGS`k],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicM]", " ", " "},
            {"\[GothicL]", " ", "\[GothicJ]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`l, xAct`HiGGS`m, -xAct`HiGGS`j, -xAct`HiGGS`m],
     Editable->False]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicK]", " ", "\[GothicL]"},
            {"\[GothicJ]", " ", "\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`i, xAct`HiGGS`l],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicM]", " ", " "},
            {"\[GothicL]", " ", "\[GothicK]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`l, xAct`HiGGS`m, -xAct`HiGGS`k, -xAct`HiGGS`m],
     Editable->False]}], "+", 
   RowBox[{
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicJ]", "\[GothicK]", " ", "\[GothicL]"},
            {" ", " ", "\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`j, xAct`HiGGS`l],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicM]", " ", " "},
            {"\[GothicL]", " ", "\[GothicK]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`l, xAct`HiGGS`m, -xAct`HiGGS`k, -xAct`HiGGS`m],
     Editable->False]}], "-", 
   FractionBox[
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[Sigma]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicN]", "\[GothicJ]", "\[GothicK]"},
             {" ", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`Sigma[xAct`HiGGS`n, xAct`HiGGS`j, xAct`HiGGS`k],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {"\[GothicI]", "\[GothicJ]", "\[GothicK]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`T[-xAct`HiGGS`i, -xAct`HiGGS`j, -xAct`HiGGS`k],
      Editable->False]}], 
    RowBox[{"4", " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalJ]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`J[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalN]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`Lapse[],
      Editable->False]}]], "-", 
   FractionBox[
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[Sigma]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicN]", "\[GothicJ]", "\[GothicK]"},
             {" ", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`Sigma[xAct`HiGGS`n, xAct`HiGGS`j, xAct`HiGGS`k],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {"\[GothicJ]", "\[GothicI]", "\[GothicK]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`T[-xAct`HiGGS`j, -xAct`HiGGS`i, -xAct`HiGGS`k],
      Editable->False]}], 
    RowBox[{"2", " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalJ]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`J[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalN]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`Lapse[],
      Editable->False]}]], "+", 
   FractionBox[
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptB]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicJ]", "\[GothicK]"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`B[xAct`HiGGS`j, xAct`HiGGS`k],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptH]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", "\[GothicN]"},
             {"\[GothicI]", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[Sigma]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", "\[GothicL]", "\[GothicM]"},
             {"\[GothicK]", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`Sigma[-xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {"\[GothicJ]", "\[GothicL]", "\[GothicM]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`T[-xAct`HiGGS`j, -xAct`HiGGS`l, -xAct`HiGGS`m],
      Editable->False]}], 
    RowBox[{"4", " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalJ]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`J[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalN]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`Lapse[],
      Editable->False]}]], "+", 
   FractionBox[
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptB]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicJ]", "\[GothicK]"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`B[xAct`HiGGS`j, xAct`HiGGS`k],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptH]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", "\[GothicN]"},
             {"\[GothicI]", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[Sigma]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", "\[GothicL]", "\[GothicM]"},
             {"\[GothicK]", " ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`Sigma[-xAct`HiGGS`k, xAct`HiGGS`l, xAct`HiGGS`m],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {"\[GothicL]", "\[GothicJ]", "\[GothicM]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`T[-xAct`HiGGS`l, -xAct`HiGGS`j, -xAct`HiGGS`m],
      Editable->False]}], 
    RowBox[{"2", " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalJ]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`J[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalN]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`Lapse[],
      Editable->False]}]], "+", 
   FractionBox[
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox[
          RowBox[{"\[Tau]", 
           RowBox[{"(", "\[CapitalDelta]", ")"}]}],
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicN]", " "},
            {" ", "\[GothicI]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     $CellContext`TorsionlessTau[xAct`HiGGS`n, -xAct`HiGGS`i],
     Editable->False], 
    RowBox[{
     InterpretationBox[
      StyleBox["\[ScriptCapitalJ]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`J[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalN]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`Lapse[],
      Editable->False]}]]}], "\[Equal]", "0"}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508302344967*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"29e07eb3-976c-411b-9f94-16375400abae"],

Cell["\<\
This then is the final form of the stress-energy equation in the first-order \
formalism. How does it differ from the first version of the equation which we \
wrote down above? The matter stress-energy tensor has been decomposed into a \
metric-based part and a series of terms bilinear in the torsion and the \
matter spin tensor. The gravitational part of the field equations is \
unaffected.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508302368977*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"262e2a6a-5401-403a-895c-4594c6210ba7"],

Cell[BoxData[
 TagBox[GridBox[{
    {Cell["Connection to Part III project",
      FontWeight->Bold,ExpressionUUID->
      "3c39e143-91e7-4511-9f04-738c13ae5cd0"], Cell["\<\
This equation is the stress-energy equation which should give rise to some of \
the cosmological perturbation equations. Remember that we can neglect the \
spin tensor, that the field strength tensors have only Roman indices, and \
that Greek indices are provided by the matter stress-energy tensor and the \
(inverse) translational gauge field wherever it appears. The factor of \
caligraphic J multiplied by caligraphic N is intended to mean the determinant \
of the translational gauge field, I've just written it out in 3+1 notation. \
I'd recommend contracting this equation with the tetrad to produce two raised \
Greek indices, and then extracting the symmetric part (the Einstein \
equations) and the antisymmetric part (which you should prove is merely an \
identity, with the help of the spin equation later on).\
\>",ExpressionUUID->"ffcabad8-fbb3-4fd0-ac4d-5ce921bbca3d"]}
   },
   AutoDelete->False,
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "TextGrid"]], "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508302389497*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 Background->RGBColor[1, 1, 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"fa281744-8557-47cc-9ab2-37c4eb2955eb"],

Cell["\<\
We also construct a replacement rule to convert the torsionless stress-energy \
tensor into gravitational variables, i.e. torsion, Riemann-Cartan curvature \
and multiplier fields, according to this stress-energy equation.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508302409525*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"6233d3d5-c5d2-42cf-8bae-2b61b7138602"],

Cell[CellGroupData[{

Cell[BoxData["\<\" ** MakeQuotientRule: canonicalised expression with tensor \
substituted by rule:\"\>"], "Print",
 CellChangeTimes->{3.889508302454287*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"6e61b564-aa01-4740-974f-4651cc6f1c16"],

Cell[BoxData["0"], "Print",
 CellChangeTimes->{3.889508302513438*^9},
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},
 CellLabel->
  "During evaluation of \
In[1]:=",ExpressionUUID->"c293088e-c2a0-420e-93b5-979f7126af49"]
}, Open  ]],

Cell["The spin tensor", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508302542973*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontSize->20,
 FontVariations->{"Underline"->True},
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"f2a71967-f0da-4412-8bc7-02eaf59f5458"],

Cell["\<\
Having studied the general stress-energy equation, we turn to the \
spin-torsion equation. The spin tensor is defined in Eq. (3.21) on p. 48 of \
Blagojevi\[CAcute].\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508302571764*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"195600ce-ea6b-44b0-94da-8a294f8ad95e"],

Cell["\<\
Once again, in terms of the generalised momenta and the gauge fields, the \
left hand side of the spin equation as expressed in the second line of Eq. \
(3.24b) on page 50 of Blagojevi\[CAcute] is as follows.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508302590386*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"c9d6f1f3-f340-4933-ad76-6dcdeee462a2"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Pi]", "\[ScriptB]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", "\[GothicL]"},
           {"\[GothicI]", "\[GothicJ]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`BGPi[-xAct`HiGGS`i, -xAct`HiGGS`j, xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicL]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`l, xAct`HiGGS`n],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Pi]", "\[ScriptB]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", "\[GothicL]"},
           {"\[GothicJ]", "\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`BGPi[-xAct`HiGGS`j, -xAct`HiGGS`i, xAct`HiGGS`l],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicN]"},
           {"\[GothicL]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[-xAct`HiGGS`l, xAct`HiGGS`n],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalA]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicY]", " "},
           {"\[GothicJ]", " ", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`A[-xAct`HiGGS`j, xAct`HiGGS`y, -xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Pi]", "\[ScriptCapitalA]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicI]", "\[GothicY]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`AGPi[-xAct`HiGGS`i, -xAct`HiGGS`y, -xAct`HiGGS`l, -
     xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicL]", "\[GothicN]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`l, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", "\[GothicX]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`m, xAct`HiGGS`x],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalA]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", "\[GothicY]", " "},
           {"\[GothicI]", " ", "\[GothicX]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`A[-xAct`HiGGS`i, xAct`HiGGS`y, -xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Pi]", "\[ScriptCapitalA]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicJ]", "\[GothicY]", "\[GothicL]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`AGPi[-xAct`HiGGS`j, -xAct`HiGGS`y, -xAct`HiGGS`l, -
     xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicL]", "\[GothicN]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`l, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", "\[GothicX]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`m, xAct`HiGGS`x],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Pi]", "\[ScriptCapitalA]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicI]", "\[GothicJ]", "\[GothicM]", "\[GothicY]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`AGPi[-xAct`HiGGS`i, -xAct`HiGGS`j, -xAct`HiGGS`m, -
     xAct`HiGGS`y],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicL]", "\[GothicN]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`l, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", "\[GothicX]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`m, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicY]", "\[GothicA]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`y, xAct`HiGGS`a],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "\[GothicA]"], GridBox[{
        {
         StyleBox["\[ScriptB]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " "},
            {"\[GothicL]", "\[GothicX]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`CD[-xAct`HiGGS`a][
     xAct`HiGGS`B[-xAct`HiGGS`l, -xAct`HiGGS`x]],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicL]", "\[GothicN]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`l, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", "\[GothicX]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`m, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "\[GothicX]"], GridBox[{
        {
         StyleBox[
          SubscriptBox["\[Pi]", "\[ScriptCapitalA]"],
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " ", " ", " "},
            {"\[GothicI]", "\[GothicJ]", "\[GothicL]", "\[GothicM]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`CD[-xAct`HiGGS`x][
     $CellContext`AGPi[-xAct`HiGGS`i, -xAct`HiGGS`j, -xAct`HiGGS`l, -
      xAct`HiGGS`m]],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         SubscriptBox["\[Pi]", "\[ScriptCapitalA]"],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicI]", "\[GothicJ]", "\[GothicL]", "\[GothicY]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`AGPi[-xAct`HiGGS`i, -xAct`HiGGS`j, -xAct`HiGGS`l, -
     xAct`HiGGS`y],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicL]", "\[GothicN]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`l, xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicM]", "\[GothicX]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`m, xAct`HiGGS`x],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicY]", "\[GothicA]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`y, xAct`HiGGS`a],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "\[GothicX]"], GridBox[{
        {
         StyleBox["\[ScriptB]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " "},
            {"\[GothicM]", "\[GothicA]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`CD[-xAct`HiGGS`x][
     xAct`HiGGS`B[-xAct`HiGGS`m, -xAct`HiGGS`a]],
    Editable->False]}]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.88950830263376*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"6ac621ba-2f0d-4b0c-9588-6ef6799b1710"],

Cell["\<\
We now impose the restriction on the coupling constants to go over to the \
most general case studied, and then we expand the projection operators and \
the generalised momenta. We subtract the right hand side, i.e. the matter \
spin tensor, to form the spin equation.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508302655641*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"a4a2657e-e1be-43c7-b9dc-37ad9b9aa9e9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox[
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[Sigma]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicN]", " ", " "},
            {" ", "\[GothicI]", "\[GothicJ]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Sigma[xAct`HiGGS`n, -xAct`HiGGS`i, -xAct`HiGGS`j],
     Editable->False], 
    RowBox[{
     InterpretationBox[
      StyleBox["\[ScriptCapitalJ]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`J[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalN]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`Lapse[],
      Editable->False]}]], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {
             RowBox[{"\[GothicA]", "'"}], " ", "\[GothicJ]", "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`l, -xAct`HiGGS`j, -xAct`HiGGS`l],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {"\[GothicA]", "\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`a, -xAct`HiGGS`i, xAct`HiGGS`a1],
     Editable->False]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {"\[GothicJ]", " ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`l, -xAct`HiGGS`a1, -xAct`HiGGS`l],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {"\[GothicA]", "\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`a, -xAct`HiGGS`i, xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " ", " "},
            {"\[GothicA]", "\[GothicI]", "\[GothicJ]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`a, -xAct`HiGGS`i, -xAct`HiGGS`j],
     Editable->False]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {
             RowBox[{"\[GothicA]", "'"}], " ", "\[GothicI]", "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`l, -xAct`HiGGS`i, -xAct`HiGGS`l],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {"\[GothicA]", "\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`a, -xAct`HiGGS`j, xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {"\[GothicI]", " ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`i, xAct`HiGGS`l, -xAct`HiGGS`a1, -xAct`HiGGS`l],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {"\[GothicA]", "\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`a, -xAct`HiGGS`j, xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {
             RowBox[{"\[GothicA]", "'"}], " ", "\[GothicI]", "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`l, -xAct`HiGGS`i, -xAct`HiGGS`l],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicA]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {
             RowBox[{"\[GothicA]", "'"}], " ", "\[GothicJ]", "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`l, -xAct`HiGGS`j, -xAct`HiGGS`l],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicA]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {"\[GothicI]", " ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`i, xAct`HiGGS`l, -xAct`HiGGS`a1, -xAct`HiGGS`l],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicA]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {"\[GothicJ]", " ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`l, -xAct`HiGGS`a1, -xAct`HiGGS`l],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicA]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False]}], "-", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", " "},
            {" ", "\[GothicI]", "\[GothicA]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`i, -xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", " "},
            {" ", "\[GothicJ]", "\[GothicA]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`j, -xAct`HiGGS`a],
     Editable->False]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {"\[GothicA]", " ", "\[GothicJ]", "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`l, -xAct`HiGGS`j, -xAct`HiGGS`l],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {" ", "\[GothicI]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a1, -xAct`HiGGS`i, -xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {"\[GothicJ]", " ", "\[GothicA]", "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`l, -xAct`HiGGS`a, -xAct`HiGGS`l],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {" ", "\[GothicI]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a1, -xAct`HiGGS`i, -xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {"\[GothicA]", " ", "\[GothicI]", "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`l, -xAct`HiGGS`i, -xAct`HiGGS`l],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {" ", "\[GothicJ]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a1, -xAct`HiGGS`j, -xAct`HiGGS`a1],
     Editable->False]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {"\[GothicI]", " ", "\[GothicA]", "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`i, xAct`HiGGS`l, -xAct`HiGGS`a, -xAct`HiGGS`l],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {" ", "\[GothicJ]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a1, -xAct`HiGGS`j, -xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {
             RowBox[{"\[GothicA]", "'"}], "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a1, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicA]"},
            {"\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`j, xAct`HiGGS`a],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", "\[GothicA]"], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicL]", " ", " "},
              {
               RowBox[{"\[GothicA]", "'"}], " ", "\[GothicI]", "\[GothicL]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a][
       xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`l, -xAct`HiGGS`i, -
        xAct`HiGGS`l]],
      Editable->False], ")"}]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {
             RowBox[{"\[GothicA]", "'"}], "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a1, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicA]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`a],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", "\[GothicA]"], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicL]", " ", " "},
              {
               RowBox[{"\[GothicA]", "'"}], " ", "\[GothicJ]", "\[GothicL]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a][
       xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`l, -xAct`HiGGS`j, -
        xAct`HiGGS`l]],
      Editable->False], ")"}]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {
             RowBox[{"\[GothicA]", "'"}], "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a1, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicA]"},
            {"\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`j, xAct`HiGGS`a],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", "\[GothicA]"], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicL]", " ", " "},
              {"\[GothicI]", " ", 
               RowBox[{"\[GothicA]", "'"}], "\[GothicL]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a][
       xAct`HiGGS`R[-xAct`HiGGS`i, xAct`HiGGS`l, -xAct`HiGGS`a1, -
        xAct`HiGGS`l]],
      Editable->False], ")"}]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {
             RowBox[{"\[GothicA]", "'"}], "\[GothicN]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a1, xAct`HiGGS`n],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicA]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`a],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", "\[GothicA]"], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicL]", " ", " "},
              {"\[GothicJ]", " ", 
               RowBox[{"\[GothicA]", "'"}], "\[GothicL]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a][
       xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`l, -xAct`HiGGS`a1, -
        xAct`HiGGS`l]],
      Editable->False], ")"}]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", 
         RowBox[{"\[GothicA]", "'"}]], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicL]", " ", " "},
              {"\[GothicA]", " ", "\[GothicI]", "\[GothicL]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a1][
       xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`l, -xAct`HiGGS`i, -
        xAct`HiGGS`l]],
      Editable->False], ")"}]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", 
         RowBox[{"\[GothicA]", "'"}]], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicL]", " ", " "},
              {"\[GothicA]", " ", "\[GothicJ]", "\[GothicL]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a1][
       xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`l, -xAct`HiGGS`j, -
        xAct`HiGGS`l]],
      Editable->False], ")"}]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicJ]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`j, xAct`HiGGS`n],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", 
         RowBox[{"\[GothicA]", "'"}]], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicL]", " ", " "},
              {"\[GothicI]", " ", "\[GothicA]", "\[GothicL]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a1][
       xAct`HiGGS`R[-xAct`HiGGS`i, xAct`HiGGS`l, -xAct`HiGGS`a, -
        xAct`HiGGS`l]],
      Editable->False], ")"}]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicN]"},
            {"\[GothicI]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`i, xAct`HiGGS`n],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", 
         RowBox[{"\[GothicA]", "'"}]], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicL]", " ", " "},
              {"\[GothicJ]", " ", "\[GothicA]", "\[GothicL]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a1][
       xAct`HiGGS`R[-xAct`HiGGS`j, xAct`HiGGS`l, -xAct`HiGGS`a, -
        xAct`HiGGS`l]],
      Editable->False], ")"}]}]}], "\[Equal]", "0"}]], \
"DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083045991*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"8d289f74-704d-420a-80d8-761be6d9e1ff"],

Cell["\<\
This time we do not need to further decompose the matter sources, and so this \
constitutes the final form of the spin equations in the first-order formalism.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508304624401*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"869d6edf-1a19-43ae-b937-da3fc25e528e"],

Cell[BoxData[
 TagBox[GridBox[{
    {Cell["Connection to Part III project",
      FontWeight->Bold,ExpressionUUID->
      "2dead4a2-d960-49b6-b40e-97560262e7ef"], Cell["\<\
This is the spin equation, from which additional cosmological perturbation \
equations can be derived. You recall that the spin equation is obtained by \
taking variational derivatives of the action with respect to the rotational \
gauge field. Hence, the indices of the equation are precisely those of the \
rotational gauge field itself. That means that you can go ahead and decompose \
this equation just as you did the rotational gauge field, and the torsion \
tensor example I gave you earlier. Remember that the spin tensor itself can \
be set to zero.\
\>",ExpressionUUID->"08fa6a53-66e4-471e-89d3-7caf6c7e64e4"]}
   },
   AutoDelete->False,
   GridBoxFrame->{"Columns" -> {{True}}, "Rows" -> {{True}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "TextGrid"]], "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083046433*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 Background->RGBColor[1, 1, 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"b541844c-60ee-4b27-ad80-c9abc93a8437"],

Cell["Stress-energy conservation", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508304663693*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontSize->20,
 FontVariations->{"Underline"->True},
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"c7f66d35-0768-40f4-9317-e3a2600040b8"],

Cell["\<\
We now have both sets of field equations at our disposal, with reference to \
their respective source currents. It would be helpful at this stage to verify \
the second conservation law from Eq. (3.23) p. 49 in Blagojevi\[CAcute].\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083046830378`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"3a5f6d79-e2de-4063-a5e5-c5722df33822"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["1", "2"]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicL]", " "},
           {" ", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`l, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicQ]", " "},
           {" ", "\[GothicN]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`q, -xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalR]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicI]", "\[GothicJ]", " ", " "},
           {" ", " ", "\[GothicL]", "\[GothicQ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`R[xAct`HiGGS`i, xAct`HiGGS`j, -xAct`HiGGS`l, -xAct`HiGGS`q],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicN]", " ", " "},
           {" ", "\[GothicI]", "\[GothicJ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[xAct`HiGGS`n, -xAct`HiGGS`i, -xAct`HiGGS`j],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicL]", " "},
           {" ", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`l, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicQ]", " "},
           {" ", "\[GothicN]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`q, -xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalT]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicK]", " ", " "},
           {" ", "\[GothicL]", "\[GothicQ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T[xAct`HiGGS`k, -xAct`HiGGS`l, -xAct`HiGGS`q],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Tau]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicN]", " "},
           {" ", "\[GothicK]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Tau[xAct`HiGGS`n, -xAct`HiGGS`k],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalA]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicL]", " ", " "},
           {" ", "\[GothicK]", "\[GothicN]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`A[xAct`HiGGS`l, -xAct`HiGGS`k, -xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicK]", " "},
           {" ", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`k, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Tau]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicN]", " "},
           {" ", "\[GothicL]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Tau[xAct`HiGGS`n, -xAct`HiGGS`l],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicK]", " "},
           {" ", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`k, -xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[
     RowBox[{
      SubscriptBox["\[PartialD]", "\[GothicN]"], GridBox[{
        {
         StyleBox["\[Tau]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicN]", " "},
            {" ", "\[GothicK]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}]}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`CD[-xAct`HiGGS`n][
     xAct`HiGGS`Tau[xAct`HiGGS`n, -xAct`HiGGS`k]],
    Editable->False]}]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508304708955*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"83d3926f-9e0d-4aed-a1e4-0aa3b2009d92"],

Cell["\<\
Substitution of the field equations into this expression, which refers to the \
sources only, causes it to vanish. The calculation is computationally quite \
expensive, so we will omit it here.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508304730537*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"15068d50-44a9-490e-8bbe-da6f6b0658f3"],

Cell["Spin conservation", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083047501993`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontSize->20,
 FontVariations->{"Underline"->True},
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"6012b86f-c5b5-4584-bcf3-2662a484fb69"],

Cell["\<\
Equally, it is important to verify the second conservation law from Eq. \
(3.23) page 49 in Blagojevi\[CAcute].\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508304768777*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"216ecab2-23d3-4088-8085-e8257fb73d07"],

Cell["First term in the putatively vanishing expression.", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508304787107*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"6799a4f0-567b-412f-aaff-a64c38495a67"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptB]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " "},
            {"\[GothicJ]", "\[GothicN]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`B[-xAct`HiGGS`j, -xAct`HiGGS`n],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         RowBox[{"\[Tau]", 
          RowBox[{"(", "\[CapitalDelta]", ")"}]}],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicN]", " "},
           {" ", "\[GothicI]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TorsionlessTau[xAct`HiGGS`n, -xAct`HiGGS`i],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {" ", " "},
           {"\[GothicI]", "\[GothicN]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[-xAct`HiGGS`i, -xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox[
         RowBox[{"\[Tau]", 
          RowBox[{"(", "\[CapitalDelta]", ")"}]}],
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicN]", " "},
           {" ", "\[GothicJ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    $CellContext`TorsionlessTau[xAct`HiGGS`n, -xAct`HiGGS`j],
    Editable->False]}]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508304807743*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"c0f00af1-c65e-46b6-bea7-af95cee96b01"],

Cell["Second term in the putatively vanishing expression.", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508304827875*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"d7863f6d-16db-4d15-ac48-8d32128a9b54"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalA]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicL]", " ", " "},
            {" ", "\[GothicJ]", "\[GothicN]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`A[xAct`HiGGS`l, -xAct`HiGGS`j, -xAct`HiGGS`n],
     Editable->False]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicN]", " ", " "},
           {" ", "\[GothicI]", "\[GothicL]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[xAct`HiGGS`n, -xAct`HiGGS`i, -xAct`HiGGS`l],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptCapitalA]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicL]", " ", " "},
           {" ", "\[GothicI]", "\[GothicN]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`A[xAct`HiGGS`l, -xAct`HiGGS`i, -xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicN]", " ", " "},
           {" ", "\[GothicL]", "\[GothicJ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma[xAct`HiGGS`n, -xAct`HiGGS`l, -xAct`HiGGS`j],
    Editable->False]}], "+", 
  InterpretationBox[
   StyleBox[
    RowBox[{
     SubscriptBox["\[PartialD]", "\[GothicN]"], GridBox[{
       {
        StyleBox["\[Sigma]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicN]", " ", " "},
           {" ", "\[GothicI]", "\[GothicJ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}]}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`CD[-xAct`HiGGS`n][
    xAct`HiGGS`Sigma[xAct`HiGGS`n, -xAct`HiGGS`i, -xAct`HiGGS`j]],
   Editable->False]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508304849901*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"f843b089-4a70-4161-9249-f59c662f230f"],

Cell["\<\
Once again, by substituting for the source currents on the field equation \
shell, we expect these terms to cancel, but the calculation itself is omitted \
for brevity.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508304870967*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"b68ed01c-fdb9-4a3e-bc81-7f1617a837ce"],

Cell["Irreducible decomposition of spin equations", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508304890047*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontSize->20,
 FontVariations->{"Underline"->True},
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"55ce4beb-ae95-4d2b-b519-c5423a1e8703"],

Cell["\<\
Assuming that the field equations have thus been correctly obtained, we find \
it important to decompose them into their irreducible parts under the actions \
of the Lorentz group.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.88950830490816*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"50f39a67-37f1-4fa0-825d-00e049d7d06e"],

Cell["\<\
The largest and most cumbersome part of the spin equation, the tensor part \
with 16 degrees of freedom.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083049257927`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"971aec87-bbbb-4f25-9de6-b7b2fd24a27c"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptB]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicA]"},
              {"\[GothicW]", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`B[-xAct`HiGGS`w, xAct`HiGGS`a],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[Sigma]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicR]", " "},
              {"\[GothicA]", " ", "\[GothicU]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`Sigma[-xAct`HiGGS`a, xAct`HiGGS`r, -xAct`HiGGS`u],
       Editable->False]}], 
     RowBox[{"3", " ", 
      InterpretationBox[
       StyleBox["\[ScriptCapitalJ]",
        ShowAutoStyles->False,
        AutoSpacing->False,
        FontColor->RGBColor[0., 0., 0.]],
       xAct`HiGGS`J[],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["\[ScriptCapitalN]",
        ShowAutoStyles->False,
        AutoSpacing->False,
        FontColor->RGBColor[0., 0., 0.]],
       xAct`HiGGS`Lapse[],
       Editable->False]}]]}], "+", 
   FractionBox[
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptB]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", "\[GothicA]"},
             {"\[GothicU]", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`B[-xAct`HiGGS`u, xAct`HiGGS`a],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[Sigma]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", "\[GothicR]", " "},
             {"\[GothicA]", " ", "\[GothicW]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`Sigma[-xAct`HiGGS`a, xAct`HiGGS`r, -xAct`HiGGS`w],
      Editable->False]}], 
    RowBox[{"3", " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalJ]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`J[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalN]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`Lapse[],
      Editable->False]}]], "+", 
   FractionBox[
    RowBox[{"2", " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptB]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicR]", "\[GothicA]"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`B[xAct`HiGGS`r, xAct`HiGGS`a],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[Sigma]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {"\[GothicA]", "\[GothicU]", "\[GothicW]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`Sigma[-xAct`HiGGS`a, -xAct`HiGGS`u, -xAct`HiGGS`w],
      Editable->False]}], 
    RowBox[{"3", " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalJ]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`J[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalN]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`Lapse[],
      Editable->False]}]], "-", 
   FractionBox[
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptB]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicA]", 
              RowBox[{"\[GothicA]", "'"}]},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`B[xAct`HiGGS`a, xAct`HiGGS`a1],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"\[Delta]", 
          StyleBox[GridBox[{
             {"\[GothicR]", " "},
             {" ", "\[GothicW]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`w],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[Sigma]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {
              RowBox[{"\[GothicA]", "'"}], "\[GothicU]", "\[GothicA]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`Sigma[-xAct`HiGGS`a1, -xAct`HiGGS`u, -xAct`HiGGS`a],
      Editable->False]}], 
    RowBox[{"3", " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalJ]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`J[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalN]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`Lapse[],
      Editable->False]}]], "+", 
   FractionBox[
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptB]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicA]", 
              RowBox[{"\[GothicA]", "'"}]},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`B[xAct`HiGGS`a, xAct`HiGGS`a1],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {"\[Delta]", 
          StyleBox[GridBox[{
             {"\[GothicR]", " "},
             {" ", "\[GothicU]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`u],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[Sigma]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", " ", " "},
             {
              RowBox[{"\[GothicA]", "'"}], "\[GothicW]", "\[GothicA]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`Sigma[-xAct`HiGGS`a1, -xAct`HiGGS`w, -xAct`HiGGS`a],
      Editable->False]}], 
    RowBox[{"3", " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalJ]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`J[],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox["\[ScriptCapitalN]",
       ShowAutoStyles->False,
       AutoSpacing->False,
       FontColor->RGBColor[0., 0., 0.]],
      xAct`HiGGS`Lapse[],
      Editable->False]}]], "+", 
   RowBox[{
    FractionBox["4", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicI]", " ", " "},
            {
             RowBox[{"\[GothicA]", "'"}], " ", "\[GothicU]", "\[GothicI]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`i, -xAct`HiGGS`u, -xAct`HiGGS`i],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicA]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["4", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicU]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`u],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicI]", " ", " "},
            {
             RowBox[{"\[GothicA]", "'"}], " ", "\[GothicW]", "\[GothicI]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`i, -xAct`HiGGS`w, -xAct`HiGGS`i],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicA]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["4", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicI]", " ", " "},
            {"\[GothicU]", " ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicI]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`u, xAct`HiGGS`i, -xAct`HiGGS`a1, -xAct`HiGGS`i],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicA]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["4", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicU]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`u],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicI]", " ", " "},
            {"\[GothicW]", " ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicI]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`w, xAct`HiGGS`i, -xAct`HiGGS`a1, -xAct`HiGGS`i],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicA]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["4", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {"\[GothicU]", " ", "\[GothicW]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`u, xAct`HiGGS`a1, -xAct`HiGGS`w, -xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", "\[GothicR]", " "},
            {" ", " ", "\[GothicA]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, xAct`HiGGS`r, -xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["4", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {"\[GothicW]", " ", "\[GothicU]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`w, xAct`HiGGS`a1, -xAct`HiGGS`u, -xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", "\[GothicR]", " "},
            {" ", " ", "\[GothicA]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, xAct`HiGGS`r, -xAct`HiGGS`a],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["1", "3"], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", " "},
            {" ", "\[GothicU]", "\[GothicA]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`u, -xAct`HiGGS`a],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicR]", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {" ", " ", "\[GothicW]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`r, xAct`HiGGS`a1, -xAct`HiGGS`w, -xAct`HiGGS`a1],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", " "},
            {" ", "\[GothicU]", "\[GothicA]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`u, -xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicR]", " "},
            {"\[GothicW]", " ", " ", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`w, xAct`HiGGS`a1, xAct`HiGGS`r, -xAct`HiGGS`a1],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", " "},
            {" ", "\[GothicU]", "\[GothicA]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`u, -xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicI]", " ", " "},
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicI]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`i, -xAct`HiGGS`a1, -xAct`HiGGS`i],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicU]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`u, xAct`HiGGS`a1],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicI]", " ", " "},
            {
             RowBox[{"\[GothicA]", "'"}], " ", "\[GothicA]", "\[GothicI]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`i, -xAct`HiGGS`a, -xAct`HiGGS`i],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicU]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`u, xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["1", "3"], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicU]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`u],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", " "},
            {" ", "\[GothicW]", "\[GothicA]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`w, -xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicR]", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {" ", " ", "\[GothicU]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`r, xAct`HiGGS`a1, -xAct`HiGGS`u, -xAct`HiGGS`a1],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", " "},
            {" ", "\[GothicW]", "\[GothicA]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`w, -xAct`HiGGS`a],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicR]", " "},
            {"\[GothicU]", " ", " ", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`u, xAct`HiGGS`a1, xAct`HiGGS`r, -xAct`HiGGS`a1],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", " "},
            {" ", "\[GothicW]", "\[GothicA]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`w, -xAct`HiGGS`a],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicU]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`u],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicI]", " ", " "},
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicI]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`i, -xAct`HiGGS`a1, -xAct`HiGGS`i],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicW]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`w, xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicU]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`u],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicI]", " ", " "},
            {
             RowBox[{"\[GothicA]", "'"}], " ", "\[GothicA]", "\[GothicI]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`i, -xAct`HiGGS`a, -xAct`HiGGS`i],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicW]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`w, xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["4", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {"\[GothicA]", " ", "\[GothicW]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`a1, -xAct`HiGGS`w, -xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicR]", " ", "\[GothicA]"},
            {" ", "\[GothicU]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`r, -xAct`HiGGS`u, xAct`HiGGS`a],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["4", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {"\[GothicW]", " ", "\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`w, xAct`HiGGS`a1, -xAct`HiGGS`a, -xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicR]", " ", "\[GothicA]"},
            {" ", "\[GothicU]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`r, -xAct`HiGGS`u, xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicR]", " ", " "},
            {" ", "\[GothicU]", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`r, -xAct`HiGGS`u, -xAct`HiGGS`w],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["4", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {"\[GothicA]", " ", "\[GothicU]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`a1, -xAct`HiGGS`u, -xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicR]", " ", "\[GothicA]"},
            {" ", "\[GothicW]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`r, -xAct`HiGGS`w, xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["4", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {"\[GothicU]", " ", "\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`u, xAct`HiGGS`a1, -xAct`HiGGS`a, -xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicR]", " ", "\[GothicA]"},
            {" ", "\[GothicW]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`r, -xAct`HiGGS`w, xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {"\[GothicA]", " ", "\[GothicW]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`a1, -xAct`HiGGS`w, -xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicR]", "\[GothicA]"},
            {"\[GothicU]", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`u, xAct`HiGGS`r, xAct`HiGGS`a],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {"\[GothicW]", " ", "\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`w, xAct`HiGGS`a1, -xAct`HiGGS`a, -xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicR]", "\[GothicA]"},
            {"\[GothicU]", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`u, xAct`HiGGS`r, xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["1", "3"], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicR]", " "},
            {"\[GothicU]", " ", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`u, xAct`HiGGS`r, -xAct`HiGGS`w],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicR]", " "},
            {"\[GothicA]", " ", " ", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`a1, xAct`HiGGS`r, -xAct`HiGGS`a1],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " ", "\[GothicA]"},
            {"\[GothicU]", "\[GothicW]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`u, -xAct`HiGGS`w, xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicR]", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {" ", " ", "\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`r, xAct`HiGGS`a1, -xAct`HiGGS`a, -xAct`HiGGS`a1],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " ", "\[GothicA]"},
            {"\[GothicU]", "\[GothicW]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`u, -xAct`HiGGS`w, xAct`HiGGS`a],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {"\[GothicA]", " ", "\[GothicU]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`a1, -xAct`HiGGS`u, -xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicR]", "\[GothicA]"},
            {"\[GothicW]", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`w, xAct`HiGGS`r, xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {"\[GothicU]", " ", "\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`u, xAct`HiGGS`a1, -xAct`HiGGS`a, -xAct`HiGGS`a1],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicR]", "\[GothicA]"},
            {"\[GothicW]", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`w, xAct`HiGGS`r, xAct`HiGGS`a],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["1", "3"], " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicR]", " "},
            {"\[GothicW]", " ", "\[GothicU]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`w, xAct`HiGGS`r, -xAct`HiGGS`u],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicR]", " "},
            {"\[GothicA]", " ", " ", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`a1, xAct`HiGGS`r, -xAct`HiGGS`a1],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " ", "\[GothicA]"},
            {"\[GothicW]", "\[GothicU]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`w, -xAct`HiGGS`u, xAct`HiGGS`a],
     Editable->False]}], "-", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicR]", 
             RowBox[{"\[GothicA]", "'"}], " ", " "},
            {" ", " ", "\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`r, xAct`HiGGS`a1, -xAct`HiGGS`a, -xAct`HiGGS`a1],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", " ", "\[GothicA]"},
            {"\[GothicW]", "\[GothicU]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[-xAct`HiGGS`w, -xAct`HiGGS`u, xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicA]"},
            {"\[GothicW]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`w, xAct`HiGGS`a],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", "\[GothicA]"], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {"\[GothicR]", 
               RowBox[{"\[GothicA]", "'"}], " ", " "},
              {" ", " ", "\[GothicU]", 
               RowBox[{"\[GothicA]", "'"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a][
       xAct`HiGGS`R[
       xAct`HiGGS`r, xAct`HiGGS`a1, -xAct`HiGGS`u, -xAct`HiGGS`a1]],
      Editable->False], ")"}]}], "-", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicA]"},
            {"\[GothicU]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`u, xAct`HiGGS`a],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", "\[GothicA]"], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {"\[GothicR]", 
               RowBox[{"\[GothicA]", "'"}], " ", " "},
              {" ", " ", "\[GothicW]", 
               RowBox[{"\[GothicA]", "'"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a][
       xAct`HiGGS`R[
       xAct`HiGGS`r, xAct`HiGGS`a1, -xAct`HiGGS`w, -xAct`HiGGS`a1]],
      Editable->False], ")"}]}], "-", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicA]"},
            {"\[GothicW]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`w, xAct`HiGGS`a],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", "\[GothicA]"], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", 
               RowBox[{"\[GothicA]", "'"}], "\[GothicR]", " "},
              {"\[GothicU]", " ", " ", 
               RowBox[{"\[GothicA]", "'"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a][
       xAct`HiGGS`R[-xAct`HiGGS`u, xAct`HiGGS`a1, xAct`HiGGS`r, -
        xAct`HiGGS`a1]],
      Editable->False], ")"}]}], "-", 
   RowBox[{
    FractionBox["4", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicR]", "\[GothicA]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`r, xAct`HiGGS`a],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", "\[GothicA]"], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", 
               RowBox[{"\[GothicA]", "'"}], " ", " "},
              {"\[GothicU]", " ", "\[GothicW]", 
               RowBox[{"\[GothicA]", "'"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a][
       xAct`HiGGS`R[-xAct`HiGGS`u, xAct`HiGGS`a1, -xAct`HiGGS`w, -
        xAct`HiGGS`a1]],
      Editable->False], ")"}]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicA]"},
            {"\[GothicU]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[-xAct`HiGGS`u, xAct`HiGGS`a],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", "\[GothicA]"], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", 
               RowBox[{"\[GothicA]", "'"}], "\[GothicR]", " "},
              {"\[GothicW]", " ", " ", 
               RowBox[{"\[GothicA]", "'"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a][
       xAct`HiGGS`R[-xAct`HiGGS`w, xAct`HiGGS`a1, xAct`HiGGS`r, -
        xAct`HiGGS`a1]],
      Editable->False], ")"}]}], "+", 
   RowBox[{
    FractionBox["4", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicR]", "\[GothicA]"},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`r, xAct`HiGGS`a],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", "\[GothicA]"], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", 
               RowBox[{"\[GothicA]", "'"}], " ", " "},
              {"\[GothicW]", " ", "\[GothicU]", 
               RowBox[{"\[GothicA]", "'"}]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a][
       xAct`HiGGS`R[-xAct`HiGGS`w, xAct`HiGGS`a1, -xAct`HiGGS`u, -
        xAct`HiGGS`a1]],
      Editable->False], ")"}]}], "-", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", 
         RowBox[{"\[GothicA]", "'"}]], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicI]", " ", " "},
              {"\[GothicA]", " ", "\[GothicU]", "\[GothicI]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a1][
       xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`i, -xAct`HiGGS`u, -
        xAct`HiGGS`i]],
      Editable->False], ")"}]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicU]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`u],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", 
         RowBox[{"\[GothicA]", "'"}]], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicI]", " ", " "},
              {"\[GothicA]", " ", "\[GothicW]", "\[GothicI]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a1][
       xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`i, -xAct`HiGGS`w, -
        xAct`HiGGS`i]],
      Editable->False], ")"}]}], "+", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", 
         RowBox[{"\[GothicA]", "'"}]], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicI]", " ", " "},
              {"\[GothicU]", " ", "\[GothicA]", "\[GothicI]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a1][
       xAct`HiGGS`R[-xAct`HiGGS`u, xAct`HiGGS`i, -xAct`HiGGS`a, -
        xAct`HiGGS`i]],
      Editable->False], ")"}]}], "-", 
   RowBox[{
    FractionBox["2", "3"], " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Delta]", 
         StyleBox[GridBox[{
            {"\[GothicR]", " "},
            {" ", "\[GothicU]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`xTensor`delta[xAct`HiGGS`r, -xAct`HiGGS`u],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", 
         RowBox[{"\[GothicA]", "'"}]], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicI]", " ", " "},
              {"\[GothicW]", " ", "\[GothicA]", "\[GothicI]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a1][
       xAct`HiGGS`R[-xAct`HiGGS`w, xAct`HiGGS`i, -xAct`HiGGS`a, -
        xAct`HiGGS`i]],
      Editable->False], ")"}]}]}], "\[Equal]", "0"}]], \
"DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083058049307`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"62b83f51-f719-4613-b1fb-27f8830506c0"],

Cell["\<\
The simplest vector part of the spin equation, with four degrees of freedom.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083058349333`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"1b4223bf-973e-44e7-b3e4-441de6e8bd44"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptB]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {"\[GothicA]", 
               RowBox[{"\[GothicA]", "'"}]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`B[xAct`HiGGS`a, xAct`HiGGS`a1],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[Sigma]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", " ", " "},
              {
               RowBox[{"\[GothicA]", "'"}], "\[GothicW]", "\[GothicA]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`Sigma[-xAct`HiGGS`a1, -xAct`HiGGS`w, -xAct`HiGGS`a],
       Editable->False]}], 
     RowBox[{
      InterpretationBox[
       StyleBox["\[ScriptCapitalJ]",
        ShowAutoStyles->False,
        AutoSpacing->False,
        FontColor->RGBColor[0., 0., 0.]],
       xAct`HiGGS`J[],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["\[ScriptCapitalN]",
        ShowAutoStyles->False,
        AutoSpacing->False,
        FontColor->RGBColor[0., 0., 0.]],
       xAct`HiGGS`Lapse[],
       Editable->False]}]]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {
             RowBox[{"\[GothicA]", "'"}], " ", "\[GothicW]", "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`l, -xAct`HiGGS`w, -xAct`HiGGS`l],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicA]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {"\[GothicW]", " ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`w, xAct`HiGGS`l, -xAct`HiGGS`a1, -xAct`HiGGS`l],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicA]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", " "},
            {" ", "\[GothicW]", "\[GothicA]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`w, -xAct`HiGGS`a],
     Editable->False]}], "+", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`l, -xAct`HiGGS`a1, -xAct`HiGGS`l],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicW]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`w, xAct`HiGGS`a1],
     Editable->False]}], "-", 
   RowBox[{"2", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicL]", " ", " "},
            {
             RowBox[{"\[GothicA]", "'"}], " ", "\[GothicA]", "\[GothicL]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`l, -xAct`HiGGS`a, -xAct`HiGGS`l],
     
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicW]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`w, xAct`HiGGS`a1],
     Editable->False]}], "+", 
   RowBox[{"4", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", 
         RowBox[{"\[GothicA]", "'"}]], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicL]", " ", " "},
              {"\[GothicA]", " ", "\[GothicW]", "\[GothicL]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a1][
       xAct`HiGGS`R[-xAct`HiGGS`a, xAct`HiGGS`l, -xAct`HiGGS`w, -
        xAct`HiGGS`l]],
      Editable->False], ")"}]}], "-", 
   RowBox[{"4", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", 
         RowBox[{"\[GothicA]", "'"}]], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicL]", " ", " "},
              {"\[GothicW]", " ", "\[GothicA]", "\[GothicL]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a1][
       xAct`HiGGS`R[-xAct`HiGGS`w, xAct`HiGGS`l, -xAct`HiGGS`a, -
        xAct`HiGGS`l]],
      Editable->False], ")"}]}]}], "\[Equal]", "0"}]], \
"DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.88950830633591*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"09191766-a67d-4d6e-8939-b02e692a5add"],

Cell["\<\
The other simplest axial vector part of the spin equation, also with four \
degrees of freedom.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508306358856*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"2d7971dd-7798-45ef-b4a1-01ee7ece9aef"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox[
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptB]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {"\[GothicA]", 
               RowBox[{"\[GothicA]", "'"}]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`B[xAct`HiGGS`a, xAct`HiGGS`a1],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"\[Epsilon]\[Gamma]", 
           StyleBox[GridBox[{
              {"\[GothicC]", " ", " ", " "},
              {" ", "\[GothicA]", "\[GothicR]", "\[GothicU]"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`epsilonG[
       xAct`HiGGS`c, -xAct`HiGGS`a, -xAct`HiGGS`r, -xAct`HiGGS`u],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[Sigma]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {" ", "\[GothicR]", "\[GothicU]"},
              {
               RowBox[{"\[GothicA]", "'"}], " ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`Sigma[-xAct`HiGGS`a1, xAct`HiGGS`r, xAct`HiGGS`u],
       Editable->False]}], 
     RowBox[{
      InterpretationBox[
       StyleBox["\[ScriptCapitalJ]",
        ShowAutoStyles->False,
        AutoSpacing->False,
        FontColor->RGBColor[0., 0., 0.]],
       xAct`HiGGS`J[],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox["\[ScriptCapitalN]",
        ShowAutoStyles->False,
        AutoSpacing->False,
        FontColor->RGBColor[0., 0., 0.]],
       xAct`HiGGS`Lapse[],
       Editable->False]}]]}], "+", 
   RowBox[{"8", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Epsilon]\[Gamma]", 
         StyleBox[GridBox[{
            {"\[GothicC]", " ", " ", " "},
            {" ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicU]", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`epsilonG[
     xAct`HiGGS`c, -xAct`HiGGS`a1, -xAct`HiGGS`u, -xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicR]", "\[GothicU]", " ", "\[GothicW]"},
            {" ", " ", "\[GothicR]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`r, xAct`HiGGS`u, -xAct`HiGGS`r, xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", " ", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", "\[GothicA]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, -xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False]}], "-", 
   RowBox[{
    SuperscriptBox[
     InterpretationBox[
      StyleBox[
       SubscriptBox["\[ScriptCapitalM]", "Pl"],
       ShowAutoStyles->False,
       AutoSpacing->False],
      $CellContext`MPl,
      Editable->False], "2"], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Epsilon]\[Gamma]", 
         StyleBox[GridBox[{
            {"\[GothicC]", " ", " ", " "},
            {" ", "\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicR]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`epsilonG[
     xAct`HiGGS`c, -xAct`HiGGS`a, -xAct`HiGGS`a1, -xAct`HiGGS`r],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicR]"},
            {" ", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, xAct`HiGGS`a1, xAct`HiGGS`r],
     Editable->False]}], "-", 
   RowBox[{"4", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Epsilon]\[Gamma]", 
         StyleBox[GridBox[{
            {"\[GothicC]", " ", " ", " "},
            {" ", "\[GothicA]", "\[GothicR]", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`epsilonG[
     xAct`HiGGS`c, -xAct`HiGGS`a, -xAct`HiGGS`r, -xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {" ", "\[GothicU]", " ", "\[GothicW]"},
            {
             RowBox[{"\[GothicA]", "'"}], " ", "\[GothicU]", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[-xAct`HiGGS`a1, xAct`HiGGS`u, -xAct`HiGGS`u, xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicR]"},
            {" ", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, xAct`HiGGS`a1, xAct`HiGGS`r],
     Editable->False]}], "+", 
   RowBox[{"4", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Epsilon]\[Gamma]", 
         StyleBox[GridBox[{
            {"\[GothicC]", " ", " ", " "},
            {" ", "\[GothicA]", "\[GothicR]", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`epsilonG[
     xAct`HiGGS`c, -xAct`HiGGS`a, -xAct`HiGGS`r, -xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalR]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicU]", "\[GothicW]", " ", " "},
            {" ", " ", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicU]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`R[xAct`HiGGS`u, xAct`HiGGS`w, -xAct`HiGGS`a1, -xAct`HiGGS`u],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}], "\[GothicR]"},
            {" ", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`T[xAct`HiGGS`a, xAct`HiGGS`a1, xAct`HiGGS`r],
     Editable->False]}], "-", 
   RowBox[{"8", " ", 
    InterpretationBox[
     StyleBox[
      RowBox[{
       StyleBox[
        OverscriptBox["\[Alpha]", "^"],
        FontColor->RGBColor[1., 0., 0.]], 
       StyleBox[
        UnderscriptBox[".", "5"],
        FontColor->RGBColor[0., 0., 1.]]}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`Alp5,
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Epsilon]\[Gamma]", 
         StyleBox[GridBox[{
            {"\[GothicC]", " ", " ", " "},
            {" ", "\[GothicA]", "\[GothicU]", "\[GothicW]"}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`epsilonG[
     xAct`HiGGS`c, -xAct`HiGGS`a, -xAct`HiGGS`u, -xAct`HiGGS`w],
     Editable->False], " ", 
    InterpretationBox[
     StyleBox[GridBox[{
        {
         StyleBox["\[ScriptH]",
          FontColor->RGBColor[0., 0., 0.]], 
         StyleBox[GridBox[{
            {"\[GothicA]", 
             RowBox[{"\[GothicA]", "'"}]},
            {" ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`H[xAct`HiGGS`a, xAct`HiGGS`a1],
     Editable->False], " ", 
    RowBox[{"(", 
     InterpretationBox[
      StyleBox[
       RowBox[{
        SubscriptBox["\[GothicCapitalD]", 
         RowBox[{"\[GothicA]", "'"}]], GridBox[{
          {
           StyleBox["\[ScriptCapitalR]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {"\[GothicR]", "\[GothicU]", " ", "\[GothicW]"},
              {" ", " ", "\[GothicR]", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}]}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`GaugeCovD[-xAct`HiGGS`a1][
       xAct`HiGGS`R[xAct`HiGGS`r, xAct`HiGGS`u, -xAct`HiGGS`r, xAct`HiGGS`w]],
      
      Editable->False], ")"}]}]}], "\[Equal]", "0"}]], \
"DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508306980585*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"7d4f7c77-e50a-4654-9498-79cad8026f94"],

Cell["\<\
Here is a quick reminder of our irrep conventions for the torsion.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508307003747*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"7d17b821-9dda-47f6-8359-8d2788625ed8"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["2", "3"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicM]", " ", " "},
           {" ", "\[GothicN]", "\[GothicS]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T1[xAct`HiGGS`m, -xAct`HiGGS`n, -xAct`HiGGS`s],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["2", "3"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicM]", " ", " "},
           {" ", "\[GothicS]", "\[GothicN]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T1[xAct`HiGGS`m, -xAct`HiGGS`s, -xAct`HiGGS`n],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {"\[GothicM]", " "},
           {" ", "\[GothicS]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[xAct`HiGGS`m, -xAct`HiGGS`s],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "2"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" "},
           {"\[GothicN]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T2[-xAct`HiGGS`n],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {"\[GothicM]", " "},
           {" ", "\[GothicN]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[xAct`HiGGS`m, -xAct`HiGGS`n],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "2"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" "},
           {"\[GothicS]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T2[-xAct`HiGGS`s],
    Editable->False]}], "+", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Epsilon]\[Gamma]", 
        StyleBox[GridBox[{
           {"\[GothicM]", " ", " ", " "},
           {" ", "\[GothicN]", "\[GothicS]", "\[GothicA]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`epsilonG[
    xAct`HiGGS`m, -xAct`HiGGS`n, -xAct`HiGGS`s, -xAct`HiGGS`a],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "3"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicA]"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T3[xAct`HiGGS`a],
    Editable->False]}]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083070562487`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"be8309ea-16d1-4f3a-b5f7-30e460260668"],

Cell["\<\
And we also want to see what the teleparallel Lagrangian looks like, this is \
the double-bar T symbol which must be multiplied by the measure and half the \
Planck mass, with a positive sign (see eq. (15) in arXiv:2006.03581).\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083070803337`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"d78691b9-4c55-45a8-9e3f-5020642c4d25"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["4", "9"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicI]", "\[GothicJ]", "\[GothicK]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T1[-xAct`HiGGS`i, -xAct`HiGGS`j, -xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicI]", "\[GothicJ]", "\[GothicK]"},
           {" ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T1[xAct`HiGGS`i, xAct`HiGGS`j, xAct`HiGGS`k],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["4", "9"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicI]", "\[GothicK]", "\[GothicJ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T1[-xAct`HiGGS`i, -xAct`HiGGS`k, -xAct`HiGGS`j],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicI]", "\[GothicJ]", "\[GothicK]"},
           {" ", " ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T1[xAct`HiGGS`i, xAct`HiGGS`j, xAct`HiGGS`k],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["2", "3"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "2"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" "},
           {"\[GothicI]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T2[-xAct`HiGGS`i],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "2"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicI]"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T2[xAct`HiGGS`i],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["3", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "3"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" "},
           {"\[GothicI]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T3[-xAct`HiGGS`i],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "3"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicI]"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T3[xAct`HiGGS`i],
    Editable->False]}]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508307237959*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"79cf473e-13ee-411c-ab41-e59682891b21"],

Cell["\<\
We will also take a look at our irrep conventions for the spin tensor.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083072609177`*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"90f3625a-e26e-4cd7-be4b-21bb01ded13f"],

Cell[BoxData[
 RowBox[{
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[ScriptH]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicK]", " "},
          {" ", "\[GothicM]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`H[xAct`HiGGS`k, -xAct`HiGGS`m],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[Sigma]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicM]", " ", " "},
          {" ", "\[GothicI]", "\[GothicJ]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`Sigma[xAct`HiGGS`m, -xAct`HiGGS`i, -xAct`HiGGS`j],
   Editable->False]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508307284202*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"33fd7929-7442-4545-9960-fc9669f7f8d9"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   FractionBox["2", "3"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[Sigma]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" ", "\[GothicK]", " "},
           {"\[GothicI]", " ", "\[GothicJ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma1[-xAct`HiGGS`i, xAct`HiGGS`k, -xAct`HiGGS`j],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["2", "3"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[Sigma]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" ", "\[GothicK]", " "},
           {"\[GothicJ]", " ", "\[GothicI]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma1[-xAct`HiGGS`j, xAct`HiGGS`k, -xAct`HiGGS`i],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicK]"},
           {"\[GothicJ]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`j, xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "2"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[Sigma]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" "},
           {"\[GothicI]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma2[-xAct`HiGGS`i],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Delta]", 
        StyleBox[GridBox[{
           {" ", "\[GothicK]"},
           {"\[GothicI]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`xTensor`delta[-xAct`HiGGS`i, xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "2"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[Sigma]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" "},
           {"\[GothicJ]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma2[-xAct`HiGGS`j],
    Editable->False]}], "-", 
  RowBox[{
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Epsilon]\[Gamma]", 
        StyleBox[GridBox[{
           {" ", " ", " ", "\[GothicK]"},
           {"\[GothicI]", "\[GothicJ]", "\[GothicA]", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`epsilonG[-xAct`HiGGS`i, -xAct`HiGGS`j, -xAct`HiGGS`a, 
     xAct`HiGGS`k],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "3"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[Sigma]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicA]"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma3[xAct`HiGGS`a],
    Editable->False]}]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508307340782*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"fb32e72e-da5f-4405-9051-33d9a7e880f3"],

Cell["\<\
Some care has to be taken when understanding how the vector and axial vector \
parts of the torsion couple to the respective parts of the spin tensor. The \
reason for this is that the spin tensor is constructed, as per the discussion \
above, with two Lorentz indices, and so in the stress-energy field equation \
there is a possible factor of two that can go missing unless the indices are \
kept carefully tracked. When we go over to the GeoHiGGS second-order \
formulation in the next part of the script, all appearances of the \
translational gauge field and its inverse are simply replaced by the Kroneker \
symbol. This is safe in the gravity sector of the theory, but not in the \
matter coupling.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508307366446*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"abfbf702-3626-40d4-92f1-b685bba6b9c0"],

Cell["\<\
Now we assume that every instance of an epsilon tensor appears with lowered \
Greek indices in the second-order formalism, so that it is safe to consider \
this equal to the original epsilon (with Roman indices assumed) with all \
indices contracted with translational (not inverse) gauge fields.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508307387931*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"7f38935d-b89e-4143-bd81-a1e794a3620e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"HoldPattern", "[", 
    InterpretationBox[
     StyleBox[GridBox[{
        {"\[Epsilon]\[Gamma]", 
         StyleBox[GridBox[{
            {
             UnderscriptBox[
              UnderscriptBox["\[GothicA]", "_"], "_"], 
             UnderscriptBox[
              UnderscriptBox["\[GothicB]", "_"], "_"], 
             UnderscriptBox[
              UnderscriptBox["\[GothicC]", "_"], "_"], 
             UnderscriptBox[
              UnderscriptBox["\[GothicD]", "_"], "_"]},
            {" ", " ", " ", " "}
           },
           GridBoxSpacings->{"Columns" -> {
               Offset[0.], {
                Offset[0.034999999999999996`]}, 
               Offset[0.]}, "Rows" -> {{
                Offset[0.]}}}],
          FontSize->Rational[39, 4]]}
       },
       GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.034999999999999996`]}, 
           Offset[0.27999999999999997`]}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}}],
      ShowAutoStyles->False,
      AutoSpacing->False],
     xAct`HiGGS`epsilonG[
      PatternTest[
       Pattern[xAct`HiGGS`a, 
        Blank[]], TangentM4`pmQ], 
      PatternTest[
       Pattern[xAct`HiGGS`b, 
        Blank[]], TangentM4`pmQ], 
      PatternTest[
       Pattern[xAct`HiGGS`c, 
        Blank[]], TangentM4`pmQ], 
      PatternTest[
       Pattern[xAct`HiGGS`d, 
        Blank[]], TangentM4`pmQ]],
     Editable->False], "]"}], "\[RuleDelayed]", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
      "xAct`HiGGS`Private`Zz9$13769", ",", "xAct`HiGGS`Private`Zz9$13770", 
       ",", "xAct`HiGGS`Private`Zz9$13771", ",", 
       "xAct`HiGGS`Private`Zz9$13772"}], "}"}], ",", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptB]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {"xAct`HiGGS`Private`Zz9$13769", "\[GothicA]"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`B[xAct`HiGGS`Private`Zz9$13769, xAct`HiGGS`a],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptB]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {"xAct`HiGGS`Private`Zz9$13770", "\[GothicB]"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`B[xAct`HiGGS`Private`Zz9$13770, xAct`HiGGS`b],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptB]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {"xAct`HiGGS`Private`Zz9$13771", "\[GothicC]"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`B[xAct`HiGGS`Private`Zz9$13771, xAct`HiGGS`c],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptB]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {"xAct`HiGGS`Private`Zz9$13772", "\[GothicD]"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`B[xAct`HiGGS`Private`Zz9$13772, xAct`HiGGS`d],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"\[Epsilon]\[Gamma]", 
           StyleBox[GridBox[{
              {" ", " ", " ", " "},
              {"xAct`HiGGS`Private`Zz9$13769", "xAct`HiGGS`Private`Zz9$13770",
                "xAct`HiGGS`Private`Zz9$13771", "xAct`HiGGS`Private`Zz9$13772"}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`epsilonG[-xAct`HiGGS`Private`Zz9$13769, -
        xAct`HiGGS`Private`Zz9$13770, -xAct`HiGGS`Private`Zz9$13771, -
        xAct`HiGGS`Private`Zz9$13772],
       Editable->False]}]}], "]"}]}], "}"}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508307412472*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"d1590147-804a-4778-a7fc-214616d69f15"],

Cell["\<\
Note that the above output is a rule to be used internally by the script, not \
a mathematical expression. We will occasionally display such rules below as \
we define them.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508307435582*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"143af27d-2b4e-4dac-b5ca-9bc398abb8ef"],

Cell["\<\
Moreover, Greek-index curved-metric tensors will always appear so as to \
satisfy the following rules, where we use the flat-space metric of HiGGS as a \
temporary abuse of notation.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083074556*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"d4b29d21-6334-41f2-9424-aebd2553e04f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptB]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["\[GothicI]", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["\[GothicM]", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`B[
        PatternTest[
         Pattern[xAct`HiGGS`i, 
          Blank[]], TangentM4`pmQ], 
        PatternTest[
         Pattern[xAct`HiGGS`m, 
          Blank[Symbol]], TangentM4`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptB]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["\[GothicJ]", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["\[GothicM]", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`B[
        PatternTest[
         Pattern[xAct`HiGGS`j, 
          Blank[]], TangentM4`pmQ], -PatternTest[
          Pattern[xAct`HiGGS`m, 
           Blank[Symbol]], TangentM4`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"\[Gamma]", 
           StyleBox[GridBox[{
              {"\[GothicI]", "\[GothicJ]"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`G[xAct`HiGGS`i, xAct`HiGGS`j],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptB]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["\[GothicI]", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["\[GothicM]", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`B[
        PatternTest[
         Pattern[xAct`HiGGS`i, 
          Blank[]], TangentM4`pmQ], -PatternTest[
          Pattern[xAct`HiGGS`m, 
           Blank[Symbol]], TangentM4`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptB]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["\[GothicJ]", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["\[GothicM]", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`B[
        PatternTest[
         Pattern[xAct`HiGGS`j, 
          Blank[]], TangentM4`pmQ], 
        PatternTest[
         Pattern[xAct`HiGGS`m, 
          Blank[Symbol]], TangentM4`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"\[Gamma]", 
           StyleBox[GridBox[{
              {"\[GothicI]", "\[GothicJ]"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`G[xAct`HiGGS`i, xAct`HiGGS`j],
       Editable->False]}], "]"}]}]}], "}"}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083074784517`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"df4416cb-5f00-4fea-8468-abbac73dd16c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptH]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["\[GothicI]", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["\[GothicM]", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`H[
        PatternTest[
         Pattern[xAct`HiGGS`i, 
          Blank[]], TangentM4`pmQ], 
        PatternTest[
         Pattern[xAct`HiGGS`m, 
          Blank[Symbol]], TangentM4`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptH]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["\[GothicJ]", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["\[GothicM]", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`H[
        PatternTest[
         Pattern[xAct`HiGGS`j, 
          Blank[]], TangentM4`pmQ], -PatternTest[
          Pattern[xAct`HiGGS`m, 
           Blank[Symbol]], TangentM4`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"\[Gamma]", 
           StyleBox[GridBox[{
              {"\[GothicJ]", "\[GothicI]"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`G[xAct`HiGGS`j, xAct`HiGGS`i],
       Editable->False]}], "]"}]}], ",", 
   RowBox[{
    RowBox[{"HoldPattern", "[", 
     RowBox[{
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptH]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["\[GothicI]", "_"], "_"], " "},
              {" ", 
               UnderscriptBox[
                UnderscriptBox["\[GothicM]", "_"], "_"]}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`H[
        PatternTest[
         Pattern[xAct`HiGGS`i, 
          Blank[]], TangentM4`pmQ], -PatternTest[
          Pattern[xAct`HiGGS`m, 
           Blank[Symbol]], TangentM4`Q]],
       Editable->False], " ", 
      InterpretationBox[
       StyleBox[GridBox[{
          {
           StyleBox["\[ScriptH]",
            FontColor->RGBColor[0., 0., 0.]], 
           StyleBox[GridBox[{
              {
               UnderscriptBox[
                UnderscriptBox["\[GothicJ]", "_"], "_"], 
               UnderscriptBox[
                UnderscriptBox["\[GothicM]", "_"], "_"]},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`H[
        PatternTest[
         Pattern[xAct`HiGGS`j, 
          Blank[]], TangentM4`pmQ], 
        PatternTest[
         Pattern[xAct`HiGGS`m, 
          Blank[Symbol]], TangentM4`Q]],
       Editable->False]}], "]"}], "\[RuleDelayed]", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      InterpretationBox[
       StyleBox[GridBox[{
          {"\[Gamma]", 
           StyleBox[GridBox[{
              {"\[GothicJ]", "\[GothicI]"},
              {" ", " "}
             },
             GridBoxSpacings->{"Columns" -> {
                 Offset[0.], {
                  Offset[0.034999999999999996`]}, 
                 Offset[0.]}, "Rows" -> {{
                  Offset[0.]}}}],
            FontSize->Rational[39, 4]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
         GridBoxSpacings->{"Columns" -> {
             Offset[0.27999999999999997`], {
              Offset[0.034999999999999996`]}, 
             Offset[0.27999999999999997`]}, "Rows" -> {
             Offset[0.2], {
              Offset[0.4]}, 
             Offset[0.2]}}],
        ShowAutoStyles->False,
        AutoSpacing->False],
       xAct`HiGGS`G[xAct`HiGGS`j, xAct`HiGGS`i],
       Editable->False]}], "]"}]}]}], "}"}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083075033903`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"d760e4b1-ced1-438e-82aa-394980ee3cf8"],

Cell["\<\
Here is the part of the Lagrangian in which the torsion is coupled to spin.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508307525276*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"173ce9ee-ae64-42e9-9e96-9d4a40dcfef3"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "4"], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[ScriptH]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicM]", " "},
          {" ", "\[GothicZ]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`H[xAct`HiGGS`m, -xAct`HiGGS`z],
   Editable->False], " ", 
  InterpretationBox[
   StyleBox[GridBox[{
      {
       StyleBox["\[Sigma]",
        FontColor->RGBColor[0., 0., 0.]], 
       StyleBox[GridBox[{
          {"\[GothicZ]", " ", " "},
          {" ", "\[GothicI]", "\[GothicJ]"}
         },
         GridBoxSpacings->{"Columns" -> {
             Offset[0.], {
              Offset[0.034999999999999996`]}, 
             Offset[0.]}, "Rows" -> {{
              Offset[0.]}}}],
        FontSize->Rational[39, 4]]}
     },
     GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.034999999999999996`]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    ShowAutoStyles->False,
    AutoSpacing->False],
   xAct`HiGGS`Sigma[xAct`HiGGS`z, -xAct`HiGGS`i, -xAct`HiGGS`j],
   Editable->False], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptB]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicI]", " "},
             {" ", "\[GothicS]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`B[xAct`HiGGS`i, -xAct`HiGGS`s],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptH]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicJ]", "\[GothicE]"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`e],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptH]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", 
              RowBox[{"\[GothicM]", "'"}]},
             {"\[GothicM]", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`H[-xAct`HiGGS`m, xAct`HiGGS`m1],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicS]", " ", " "},
             {" ", "\[GothicE]", 
              RowBox[{"\[GothicM]", "'"}]}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`T[xAct`HiGGS`s, -xAct`HiGGS`e, -xAct`HiGGS`m1],
      Editable->False]}], "+", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptB]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicJ]", " "},
             {" ", "\[GothicS]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`B[xAct`HiGGS`j, -xAct`HiGGS`s],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptH]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicI]", "\[GothicE]"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`H[xAct`HiGGS`i, xAct`HiGGS`e],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptH]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", 
              RowBox[{"\[GothicM]", "'"}]},
             {"\[GothicM]", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`H[-xAct`HiGGS`m, xAct`HiGGS`m1],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicS]", " ", " "},
             {" ", 
              RowBox[{"\[GothicM]", "'"}], "\[GothicE]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`T[xAct`HiGGS`s, -xAct`HiGGS`m1, -xAct`HiGGS`e],
      Editable->False]}], "-", 
    RowBox[{
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptB]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {" ", " "},
             {"\[GothicM]", "\[GothicS]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`B[-xAct`HiGGS`m, -xAct`HiGGS`s],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptH]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicI]", "\[GothicR]"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`H[xAct`HiGGS`i, xAct`HiGGS`r],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptH]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicJ]", "\[GothicP]"},
             {" ", " "}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`p],
      Editable->False], " ", 
     InterpretationBox[
      StyleBox[GridBox[{
         {
          StyleBox["\[ScriptCapitalT]",
           FontColor->RGBColor[0., 0., 0.]], 
          StyleBox[GridBox[{
             {"\[GothicS]", " ", " "},
             {" ", "\[GothicR]", "\[GothicP]"}
            },
            GridBoxSpacings->{"Columns" -> {
                Offset[0.], {
                 Offset[0.034999999999999996`]}, 
                Offset[0.]}, "Rows" -> {{
                 Offset[0.]}}}],
           FontSize->Rational[39, 4]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
        GridBoxSpacings->{"Columns" -> {
            Offset[0.27999999999999997`], {
             Offset[0.034999999999999996`]}, 
            Offset[0.27999999999999997`]}, "Rows" -> {
            Offset[0.2], {
             Offset[0.4]}, 
            Offset[0.2]}}],
       ShowAutoStyles->False,
       AutoSpacing->False],
      xAct`HiGGS`T[xAct`HiGGS`s, -xAct`HiGGS`r, -xAct`HiGGS`p],
      Editable->False]}]}], ")"}]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508307550646*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"4b203467-cb2b-46ae-8b47-71c772c3440c"],

Cell["\<\
Here is the expression expanded according to the above rules.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508307574155*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"c14e5092-7614-441f-8796-30a7a64d7499"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    FractionBox["4", "9"]}], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicE]", "\[GothicI]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`e, xAct`HiGGS`i],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicM]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {
            RowBox[{"\[GothicM]", "'"}], "\[GothicP]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`m1, xAct`HiGGS`p],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[Sigma]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicE]", "\[GothicJ]", 
            RowBox[{"\[GothicM]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma1[-xAct`HiGGS`e, -xAct`HiGGS`j, -xAct`HiGGS`m1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicI]", "\[GothicM]", "\[GothicP]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T1[-xAct`HiGGS`i, -xAct`HiGGS`m, -xAct`HiGGS`p],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicE]", "\[GothicI]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`e, xAct`HiGGS`i],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {"\[Epsilon]\[Gamma]", 
        StyleBox[GridBox[{
           {" ", " ", " ", " "},
           {"\[GothicE]", "\[GothicJ]", 
            RowBox[{"\[GothicM]", "'"}], "\[GothicR]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`epsilonG[-xAct`HiGGS`e, -xAct`HiGGS`j, -xAct`HiGGS`m1, -
     xAct`HiGGS`r],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicM]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {
            RowBox[{"\[GothicM]", "'"}], "\[GothicP]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`m1, xAct`HiGGS`p],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "3"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[Sigma]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {"\[GothicR]"},
           {" "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma3[xAct`HiGGS`r],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicI]", "\[GothicM]", "\[GothicP]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T1[-xAct`HiGGS`i, -xAct`HiGGS`m, -xAct`HiGGS`p],
    Editable->False]}], "+", 
  RowBox[{
   FractionBox["4", "9"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicE]", "\[GothicI]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`e, xAct`HiGGS`i],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicJ]", "\[GothicM]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`j, xAct`HiGGS`m],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {
            RowBox[{"\[GothicM]", "'"}], "\[GothicP]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`m1, xAct`HiGGS`p],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[Sigma]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicE]", "\[GothicJ]", 
            RowBox[{"\[GothicM]", "'"}]}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma1[-xAct`HiGGS`e, -xAct`HiGGS`j, -xAct`HiGGS`m1],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "1"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" ", " ", " "},
           {"\[GothicI]", "\[GothicP]", "\[GothicM]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T1[-xAct`HiGGS`i, -xAct`HiGGS`p, -xAct`HiGGS`m],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["1", "3"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptH]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicE]", "\[GothicI]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`H[xAct`HiGGS`e, xAct`HiGGS`i],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "2"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[Sigma]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" "},
           {"\[GothicE]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma2[-xAct`HiGGS`e],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "2"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" "},
           {"\[GothicI]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T2[-xAct`HiGGS`i],
    Editable->False]}], "-", 
  RowBox[{
   FractionBox["3", "2"], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        StyleBox["\[ScriptB]",
         FontColor->RGBColor[0., 0., 0.]], 
        StyleBox[GridBox[{
           {"\[GothicE]", "\[GothicI]"},
           {" ", " "}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`B[xAct`HiGGS`e, xAct`HiGGS`i],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "3"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[Sigma]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" "},
           {"\[GothicE]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`Sigma3[-xAct`HiGGS`e],
    Editable->False], " ", 
   InterpretationBox[
    StyleBox[GridBox[{
       {
        RowBox[{
         StyleBox[
          OverscriptBox[".", "3"],
          FontColor->RGBColor[0., 0., 1.]], 
         StyleBox["\[ScriptCapitalT]",
          FontColor->RGBColor[0., 0., 0.]]}], 
        StyleBox[GridBox[{
           {" "},
           {"\[GothicI]"}
          },
          GridBoxSpacings->{"Columns" -> {
              Offset[0.], {
               Offset[0.034999999999999996`]}, 
              Offset[0.]}, "Rows" -> {{
               Offset[0.]}}}],
         FontSize->Rational[39, 4]]}
      },
      GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Center}}},
      GridBoxSpacings->{"Columns" -> {
          Offset[0.27999999999999997`], {
           Offset[0.034999999999999996`]}, 
          Offset[0.27999999999999997`]}, "Rows" -> {
          Offset[0.2], {
           Offset[0.4]}, 
          Offset[0.2]}}],
     ShowAutoStyles->False,
     AutoSpacing->False],
    xAct`HiGGS`T3[-xAct`HiGGS`i],
    Editable->False]}]}]], "DisplayFormulaNumbered",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.8895083081677437`*^9},
 Background->RGBColor[0.88, 1, 0.88],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"07705ec2-49a0-4811-badb-e7afacbbcc74"],

Cell["\<\
The factors of the translational gauge field which appear here will be needed \
when we reconstruct the effective second-order theory at the end of the \
script, but this process will not be made explicit. Moreover, we note that it \
is better to assume a very general form for the matter spin tensor, such that \
the specific couplings between different fermion currents and the torsion are \
basically obscured.\
\>", "Text",
 GeneratedCell->True,
 CellAutoOverwrite->True,
 CellChangeTimes->{3.889508308190619*^9},
 LineColor->RGBColor[0, 
   Rational[2, 3], 0],
 FrontFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 BackFaceColor->RGBColor[0, 
   Rational[2, 3], 0],
 GraphicsColor->RGBColor[0, 
   Rational[2, 3], 0],
 FontColor->RGBColor[0, 
   Rational[2, 3], 0],
 CellTags->{
  "tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", 
   "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070",
    "tmp388064697992"},ExpressionUUID->"4b964916-6106-46d7-9708-3ad46712d94a"]
},
AutoGeneratedPackage->Automatic,
ScreenStyleEnvironment->"Slideshow Working",
WindowSize->{810., 1400.25},
WindowMargins->{{Automatic, -810}, {Automatic, 19.5}},
TaggingRules-><|
 "TryRealOnly" -> False, "PresenterSettings" -> <|"ShowSlideBreaks" -> True|>|>,
FrontEndVersion->"13.2 for Linux x86 (64-bit) (January 31, 2023)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"69921b61-618e-4eba-8681-6fdc731c34e5"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "tmp387881731476"->{
  Cell[558, 20, 946, 18, 29, "Input",ExpressionUUID->"b9384e29-ebcf-4d1e-b562-f1587dbf5da2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[1507, 40, 706, 20, 67, InheritFromParent,ExpressionUUID->"655f4e1b-1a8e-4d4a-858b-59aa7082063a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[2216, 62, 1385, 33, 170, InheritFromParent,ExpressionUUID->"e42835ff-d35e-4efe-8f43-5fa8125fbe19",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[3604, 97, 688, 19, 41, InheritFromParent,ExpressionUUID->"3b809e43-d2f6-4f4a-b810-e1659f4a791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[4295, 118, 923, 22, 81, InheritFromParent,ExpressionUUID->"26686cf6-295b-456f-8440-5cecf0e696d4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5243, 144, 437, 9, 23, "Print",ExpressionUUID->"323b0b43-1933-4a4d-8d67-cc689ab3de7e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5683, 155, 709, 17, 25, "Print",ExpressionUUID->"d6c5f485-5dc5-4431-8543-843bd39d1b58",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6395, 174, 458, 9, 25, "Print",ExpressionUUID->"b5a8c692-548b-4b15-bc8e-f1606953eb03",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6856, 185, 417, 8, 25, "Print",ExpressionUUID->"ca3e3494-a5eb-42f9-bf9c-084a6575d0f5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7276, 195, 398, 8, 25, "Print",ExpressionUUID->"dce92f5f-0b7b-4832-a094-5a29b828ef4c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7677, 205, 439, 9, 23, "Print",ExpressionUUID->"afc7b575-1f7c-427f-b676-a58e99b54b66",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8119, 216, 715, 17, 25, "Print",ExpressionUUID->"23de39fb-26b9-4d84-82e3-da0a04a1115f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8837, 235, 458, 9, 25, "Print",ExpressionUUID->"574d02c4-4d57-4750-b337-f1c46ac5862c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9298, 246, 437, 9, 23, "Print",ExpressionUUID->"48521381-9713-4ce9-864f-2b453436faf0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9738, 257, 709, 17, 25, "Print",ExpressionUUID->"23024247-584c-4c96-8b6f-c721149f15c5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10450, 276, 508, 10, 45, "Print",ExpressionUUID->"5773044e-1cdd-42e1-957b-023676b56af9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10961, 288, 679, 16, 25, "Print",ExpressionUUID->"31a3b4d1-3ec0-4321-997b-18407e25a553",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[11643, 306, 763, 17, 25, "Print",ExpressionUUID->"872a2ace-a03b-45ad-b812-2627df56dad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[12409, 325, 864, 17, 25, "Print",ExpressionUUID->"1be38cd1-3cc7-44e0-bc52-6df574d1c2b9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[13276, 344, 822, 17, 25, "Print",ExpressionUUID->"7061ace8-a728-4a87-b6e8-c70ed05fdb9c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14101, 363, 840, 17, 25, "Print",ExpressionUUID->"66be857f-bca3-4910-8e8b-bb1965f6d674",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14944, 382, 439, 9, 23, "Print",ExpressionUUID->"7aa4e98b-2b90-4a24-b206-6c8dc6252de7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[15386, 393, 706, 16, 25, "Print",ExpressionUUID->"01a2dfb3-df3e-4524-923f-193f1ee8f902",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16095, 411, 484, 9, 45, "Print",ExpressionUUID->"e524aae7-d731-4da4-b993-13b51dadae3c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16582, 422, 805, 18, 25, "Print",ExpressionUUID->"62a61f68-d160-4d30-8b50-55d247c0e779",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[17390, 442, 799, 17, 25, "Print",ExpressionUUID->"2e9f0da9-6901-493b-b37a-ef1dfe1aec8a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[18192, 461, 846, 17, 25, "Print",ExpressionUUID->"fd1dd82e-8dcd-48c3-9461-abbbe51137da",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19041, 480, 759, 17, 25, "Print",ExpressionUUID->"dcf6e6b9-3fe0-4127-98be-ecea4457fed2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19803, 499, 437, 9, 23, "Print",ExpressionUUID->"92dfb0cc-4789-482e-b696-12f7352ec09d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20243, 510, 709, 17, 25, "Print",ExpressionUUID->"d1cf077f-7149-4890-96bb-cd3adae9d216",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20955, 529, 476, 9, 25, "Print",ExpressionUUID->"ea9021ff-5cfd-4155-8028-a1585c035bfd",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21434, 540, 437, 9, 23, "Print",ExpressionUUID->"4cb132fe-915a-47f8-ba42-3fb34ee0abab",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21874, 551, 727, 17, 25, "Print",ExpressionUUID->"c13bab9e-02ca-433e-aebc-f78dcdaf592d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[22604, 570, 463, 9, 25, "Print",ExpressionUUID->"4f95d5a3-7129-406e-8568-b27ba2b8b59b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23070, 581, 437, 9, 23, "Print",ExpressionUUID->"2cd8248f-5158-464d-b269-55c1932871e0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23510, 592, 708, 16, 25, "Print",ExpressionUUID->"865cb17b-7c96-4fb6-a4d7-b1d2fe214dc9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24221, 610, 447, 9, 25, "Print",ExpressionUUID->"6f09edce-f6f6-4d28-9083-cf176e6e82d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24671, 621, 769, 18, 25, "Print",ExpressionUUID->"ca7368dd-3f4a-4b30-8b15-7618f53d721e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[25443, 641, 844, 17, 25, "Print",ExpressionUUID->"4420b90e-a632-482d-b04c-c6cc5b4024c1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26290, 660, 437, 9, 23, "Print",ExpressionUUID->"0d53df74-4ea0-45c1-bab2-6617740b19f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26730, 671, 729, 17, 25, "Print",ExpressionUUID->"a3cb39a0-e8fc-4781-af32-f4418b309b89",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27462, 690, 477, 9, 25, "Print",ExpressionUUID->"5a91617f-dbe1-4aee-a2c9-f6a22f3c8c18",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27942, 701, 436, 9, 23, "Print",ExpressionUUID->"8be6937d-ed63-4de9-94fb-08ec19588479",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28381, 712, 415, 8, 25, "Print",ExpressionUUID->"5b413eff-9b52-463e-bdd0-db947ebe7c3e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28799, 722, 437, 9, 23, "Print",ExpressionUUID->"f99ae39d-53b8-448a-82ff-7b0faa0ddd7c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29239, 733, 715, 17, 25, "Print",ExpressionUUID->"41d159ee-f66b-4ec8-ba2a-989f3f1487f1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29957, 752, 507, 10, 45, "Print",ExpressionUUID->"dd938ca7-6cbf-4871-b2cd-40f5d5e82ad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30467, 764, 439, 9, 23, "Print",ExpressionUUID->"7c3d6dcd-1bc3-45ce-9428-b4fb990ce33e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30909, 775, 710, 16, 25, "Print",ExpressionUUID->"6cdaf39b-fc2d-48b3-805f-8826f49bb899",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[31622, 793, 474, 9, 25, "Print",ExpressionUUID->"65aa0dc6-fa75-4e5a-9e72-bda776caf6f2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32099, 804, 486, 9, 25, "Print",ExpressionUUID->"244f0ac0-b1fa-4b7f-828a-99eed080d3bb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32588, 815, 757, 17, 25, "Print",ExpressionUUID->"77e59c75-0569-4c5b-88f4-8a3bc242ed27",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33348, 834, 439, 9, 23, "Print",ExpressionUUID->"6b90bd70-24d1-47bc-8e49-e597a39ba247",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33790, 845, 738, 18, 25, "Print",ExpressionUUID->"04e62656-e161-4e61-bda3-7e75717e8c92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34531, 865, 460, 9, 25, "Print",ExpressionUUID->"383567e6-b4a8-4966-8ac9-c0ccaf084a44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34994, 876, 437, 9, 23, "Print",ExpressionUUID->"19fd2032-d9b2-47b8-9169-9f457881a9a8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[35434, 887, 592, 11, 65, "Print",ExpressionUUID->"336ac5be-41b1-4631-ad29-bcd5ef3f3764",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36029, 900, 437, 9, 23, "Print",ExpressionUUID->"ed21db18-371d-4c65-8d93-f560c4e43105",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36481, 912, 708, 20, 35, InheritFromParent,ExpressionUUID->"7640975b-0fe9-4643-b47c-be5b016d6f9e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37192, 934, 712, 20, 54, InheritFromParent,ExpressionUUID->"b84d46a0-8f09-43bb-bc4b-56162b9fcf69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37907, 956, 972, 23, 81, InheritFromParent,ExpressionUUID->"19e9ed3f-c481-497e-afc6-f7da2c4bafe9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[38882, 981, 799, 17, 25, "Print",ExpressionUUID->"6906580a-4558-4bbe-bf0e-7c16ba99ab3d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[39684, 1000, 7613, 266, 92, InheritFromParent,ExpressionUUID->"74aac581-908d-4aa2-b5b2-fef7cc572235",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[47300, 1268, 951, 23, 81, InheritFromParent,ExpressionUUID->"494dd010-24a9-45a0-a465-eff3b3de769d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48254, 1293, 685, 19, 41, InheritFromParent,ExpressionUUID->"d840fcaf-aaa7-4b67-8321-14f0c79c712c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48942, 1314, 818, 21, 58, InheritFromParent,ExpressionUUID->"1a6e2d40-ed52-407e-8f50-e0b9455ead24",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[49785, 1339, 892, 19, 25, "Print",ExpressionUUID->"efbc3a1e-25c8-4110-aa87-f4b2c401161a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[50680, 1360, 943, 21, 25, "Print",ExpressionUUID->"ee72a628-8b2b-4587-ad28-a3b98ad0298c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[51638, 1384, 649, 17, 35, InheritFromParent,ExpressionUUID->"2dcbb549-93f3-44bf-b839-10d5215e6a09",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[52290, 1403, 1352, 37, 52, InheritFromParent,ExpressionUUID->"7ae24dfc-66ae-4a53-8f20-5a6022436885",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[53645, 1442, 424, 8, 41, InheritFromParent,ExpressionUUID->"eba1453e-4f9a-42e2-8c3f-5e6062f326ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54072, 1452, 646, 17, 35, InheritFromParent,ExpressionUUID->"5f64a805-243d-42e5-bc87-a2782c2cdd0b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54721, 1471, 1396, 38, 52, InheritFromParent,ExpressionUUID->"60156e09-a022-4b81-9697-a3e819a5673c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[56120, 1511, 26201, 816, 93, InheritFromParent,ExpressionUUID->"8cdf4af9-b767-472b-84fc-d82a415ab18b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[82324, 2329, 1252, 27, 150, InheritFromParent,ExpressionUUID->"69e59fb4-5c2f-4c22-9474-3b397b96e83b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[83579, 2358, 1068, 24, 104, InheritFromParent,ExpressionUUID->"9d78e71d-e0fc-47ea-8b40-1f0c35936d2a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[84650, 2384, 688, 19, 41, InheritFromParent,ExpressionUUID->"a702087f-7f0a-4a29-afa9-8595374e609c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[85341, 2405, 833, 21, 58, InheritFromParent,ExpressionUUID->"d22212a8-7e21-400c-a7c4-6154d10577ea",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[86177, 2428, 970, 23, 81, InheritFromParent,ExpressionUUID->"fb602348-7013-4bc7-a060-71ecd67a7b1d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[87150, 2453, 117941, 3523, 312, InheritFromParent,ExpressionUUID->"0cd8973f-3019-433f-91e0-fb859654f7e2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[205094, 5978, 918, 23, 81, InheritFromParent,ExpressionUUID->"f2575653-814a-4991-a2de-9ce7ed722149",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[206015, 6003, 26653, 774, 118, InheritFromParent,ExpressionUUID->"1d261ece-ab42-4b33-a7cf-22ae810c6dcc",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[232671, 6779, 1035, 24, 104, InheritFromParent,ExpressionUUID->"a86af238-0e18-4d41-a788-62e409387ad1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[233709, 6805, 1124, 25, 127, InheritFromParent,ExpressionUUID->"97a46e92-275a-47a1-a901-467264d86f54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[234836, 6832, 910, 20, 25, "Print",ExpressionUUID->"9ca02f3c-a9ba-4b26-9633-0117c1b9c7a6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[235749, 6854, 1332, 36, 52, InheritFromParent,ExpressionUUID->"cb4d3995-bf8b-4ca6-9ce1-2f53df529da7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[237084, 6892, 6229, 183, 56, InheritFromParent,ExpressionUUID->"84e5208f-6d8b-4803-b36f-4d82c8bbbad6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[243316, 7077, 686, 19, 35, InheritFromParent,ExpressionUUID->"e09aef32-3cff-4a32-8413-f0cab2e0ab9f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[244005, 7098, 1279, 36, 52, InheritFromParent,ExpressionUUID->"218c7d03-6c3a-47cc-bf25-13520291791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[245287, 7136, 941, 23, 81, InheritFromParent,ExpressionUUID->"d3e25584-c3d9-4e03-89c2-44a581a6a931",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246231, 7161, 696, 20, 35, InheritFromParent,ExpressionUUID->"78f997fa-c618-4a9e-b48c-1e4fae4b04f4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246930, 7183, 910, 20, 25, "Print",ExpressionUUID->"f05579ee-6cbc-46b5-9f4f-779a59ef958f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[247843, 7205, 1203, 26, 127, InheritFromParent,ExpressionUUID->"f35e9a5b-c4dd-47e3-b2a7-9945e1d50e0e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[249049, 7233, 1169, 26, 127, InheritFromParent,ExpressionUUID->"f4b93215-c9c0-48a0-ad66-68810261018f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[250221, 7261, 930, 21, 25, "Print",ExpressionUUID->"94db25a8-ff82-49c6-9371-3b3906f4ffe5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[251154, 7284, 1333, 36, 52, InheritFromParent,ExpressionUUID->"570c9060-fb52-44a6-aa2e-389e9d5b02f6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[252490, 7322, 650, 17, 35, InheritFromParent,ExpressionUUID->"9f952f08-0179-4acb-ad53-c119682c92aa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[253143, 7341, 1319, 36, 52, InheritFromParent,ExpressionUUID->"b5bbdc2c-55b8-4870-b53d-0327b9f76fa3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[254465, 7379, 2652, 79, 49, InheritFromParent,ExpressionUUID->"96617eac-23dc-476b-9652-b1dce9217326",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257120, 7460, 722, 20, 35, InheritFromParent,ExpressionUUID->"d73d082a-4779-4c5d-9abe-ba15980c9aba",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257845, 7482, 2336, 66, 56, InheritFromParent,ExpressionUUID->"6be96410-1bf9-449b-a873-8f2892d0394d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[260184, 7550, 3631, 108, 56, InheritFromParent,ExpressionUUID->"38b4785c-5b69-4f18-ac19-480c5ae84db3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[263818, 7660, 730, 20, 35, InheritFromParent,ExpressionUUID->"0f72e7b7-7ed1-44e4-b60a-53bb0bdce2de",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[264551, 7682, 630, 17, 35, InheritFromParent,ExpressionUUID->"0982f795-e428-4d19-8d15-b8ddb256bfff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265184, 7701, 600, 15, 41, InheritFromParent,ExpressionUUID->"d7d4a64a-4e5a-4912-b9ff-f899ec1dc807",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265787, 7718, 4316, 133, 49, InheritFromParent,ExpressionUUID->"aca6ec55-9556-45e8-9c9a-845b1241b594",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270106, 7853, 629, 17, 35, InheritFromParent,ExpressionUUID->"e547d27a-2162-4ea3-ad37-2ef09e5f4c86",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270738, 7872, 596, 15, 41, InheritFromParent,ExpressionUUID->"ed922378-bd8c-4ceb-b516-8d36678b0907",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[271337, 7889, 6691, 203, 49, InheritFromParent,ExpressionUUID->"db353d9f-513f-4f9b-a0c8-aafde492e828",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278031, 8094, 635, 17, 35, InheritFromParent,ExpressionUUID->"7719cccd-757a-4763-a80f-ac47a8e9174d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278669, 8113, 1281, 36, 52, InheritFromParent,ExpressionUUID->"4d414f63-f7a4-495b-8cc6-d7055f83ad50",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[279953, 8151, 3340, 99, 52, InheritFromParent,ExpressionUUID->"d474b63f-5321-4855-b79e-084a20afd87e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[283296, 8252, 858, 22, 81, InheritFromParent,ExpressionUUID->"3dee2795-4d05-4efe-a2f8-6bccf06b2d21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[284157, 8276, 7234, 212, 56, InheritFromParent,ExpressionUUID->"f1aa6cd9-3914-4afc-8549-0e0268c04613",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[291394, 8490, 13120, 388, 56, InheritFromParent,ExpressionUUID->"f8d09264-8ab1-46dd-887b-e5ca058ee75c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[304517, 8880, 743, 20, 58, InheritFromParent,ExpressionUUID->"0c0bb409-a2f6-4fee-b8c8-3b461b842efa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[305263, 8902, 1279, 36, 52, InheritFromParent,ExpressionUUID->"f4f145a4-47cd-4c20-a77d-fb8afa3c8a77",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[306545, 8940, 13331, 395, 56, InheritFromParent,ExpressionUUID->"24fe1dd9-9f96-4acd-8ea6-bc2e71ca3f08",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[319879, 9337, 654, 17, 35, InheritFromParent,ExpressionUUID->"3ba01e8b-167b-479a-81ec-f428c62f5f81",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[320558, 9358, 456, 9, 25, "Print",ExpressionUUID->"b636a247-8891-49df-a008-20813b773799",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321017, 9369, 367, 8, 23, "Print",ExpressionUUID->"4bf2e0fa-3ba0-4464-a442-50a9cc50abdf",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321399, 9380, 1360, 38, 52, InheritFromParent,ExpressionUUID->"ef82b0f8-f076-461a-bff9-66027e60bdfe",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[322762, 9420, 13271, 394, 56, InheritFromParent,ExpressionUUID->"a57de255-7d1b-4c42-b265-7c7745be17b6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336036, 9816, 749, 20, 58, InheritFromParent,ExpressionUUID->"c303681a-55e6-4cfd-8724-f0b7162d116c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336788, 9838, 40718, 1180, 118, InheritFromParent,ExpressionUUID->"29e07eb3-976c-411b-9f94-16375400abae",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[377509, 11020, 1011, 24, 104, InheritFromParent,ExpressionUUID->"262e2a6a-5401-403a-895c-4594c6210ba7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[378523, 11046, 1872, 39, 368, InheritFromParent,ExpressionUUID->"fa281744-8557-47cc-9ab2-37c4eb2955eb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[380398, 11087, 839, 21, 58, InheritFromParent,ExpressionUUID->"6233d3d5-c5d2-42cf-8bae-2b61b7138602",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381262, 11112, 456, 9, 25, "Print",ExpressionUUID->"6e61b564-aa01-4740-974f-4651cc6f1c16",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381721, 11123, 368, 8, 23, "Print",ExpressionUUID->"c293088e-c2a0-420e-93b5-979f7126af49",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382104, 11134, 677, 19, 41, InheritFromParent,ExpressionUUID->"f2a71967-f0da-4412-8bc7-02eaf59f5458",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382784, 11155, 782, 21, 58, InheritFromParent,ExpressionUUID->"195600ce-ea6b-44b0-94da-8a294f8ad95e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[383569, 11178, 825, 21, 58, InheritFromParent,ExpressionUUID->"c9d6f1f3-f340-4933-ad76-6dcdeee462a2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[384397, 11201, 24829, 737, 81, InheritFromParent,ExpressionUUID->"6ac621ba-2f0d-4b0c-9588-6ef6799b1710",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[409229, 11940, 885, 22, 81, InheritFromParent,ExpressionUUID->"a4a2657e-e1be-43c7-b9dc-37ad9b9aa9e9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[410117, 11964, 78067, 2298, 229, InheritFromParent,ExpressionUUID->"8d289f74-704d-420a-80d8-761be6d9e1ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488187, 14264, 775, 20, 58, InheritFromParent,ExpressionUUID->"869d6edf-1a19-43ae-b937-da3fc25e528e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488965, 14286, 1606, 36, 258, InheritFromParent,ExpressionUUID->"b541844c-60ee-4b27-ad80-c9abc93a8437",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[490574, 14324, 688, 19, 41, InheritFromParent,ExpressionUUID->"c7f66d35-0768-40f4-9317-e3a2600040b8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[491265, 14345, 849, 21, 58, InheritFromParent,ExpressionUUID->"3a5f6d79-e2de-4063-a5e5-c5722df33822",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[492117, 14368, 12863, 382, 56, InheritFromParent,ExpressionUUID->"83d3926f-9e0d-4aed-a1e4-0aa3b2009d92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[504983, 14752, 810, 21, 58, InheritFromParent,ExpressionUUID->"15068d50-44a9-490e-8bbe-da6f6b0658f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[505796, 14775, 681, 19, 41, InheritFromParent,ExpressionUUID->"6012b86f-c5b5-4584-bcf3-2662a484fb69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[506480, 14796, 728, 20, 35, InheritFromParent,ExpressionUUID->"216ecab2-23d3-4088-8085-e8257fb73d07",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507211, 14818, 659, 17, 35, InheritFromParent,ExpressionUUID->"6799a4f0-567b-412f-aaff-a64c38495a67",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507873, 14837, 4361, 128, 52, InheritFromParent,ExpressionUUID->"c0f00af1-c65e-46b6-bea7-af95cee96b01",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512237, 14967, 660, 17, 35, InheritFromParent,ExpressionUUID->"d7863f6d-16db-4d15-ac48-8d32128a9b54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512900, 14986, 5405, 155, 52, InheritFromParent,ExpressionUUID->"f843b089-4a70-4161-9249-f59c662f230f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[518308, 15143, 785, 21, 58, InheritFromParent,ExpressionUUID->"b68ed01c-fdb9-4a3e-bc81-7f1617a837ce",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519096, 15166, 705, 19, 41, InheritFromParent,ExpressionUUID->"55ce4beb-ae95-4d2b-b519-c5423a1e8703",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519804, 15187, 796, 21, 58, InheritFromParent,ExpressionUUID->"50f39a67-37f1-4fa0-825d-00e049d7d06e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[520603, 15210, 723, 20, 35, InheritFromParent,ExpressionUUID->"971aec87-bbbb-4f25-9de6-b7b2fd24a27c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[521329, 15232, 124875, 3681, 391, InheritFromParent,ExpressionUUID->"62b83f51-f719-4613-b1fb-27f8830506c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646207, 18915, 695, 19, 35, InheritFromParent,ExpressionUUID->"1b4223bf-973e-44e7-b3e4-441de6e8bd44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646905, 18936, 19423, 570, 113, InheritFromParent,ExpressionUUID->"09191766-a67d-4d6e-8939-b02e692a5add",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[666331, 19508, 712, 20, 35, InheritFromParent,ExpressionUUID->"2d7971dd-7798-45ef-b4a1-01ee7ece9aef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[667046, 19530, 20284, 581, 116, InheritFromParent,ExpressionUUID->"7d4f7c77-e50a-4654-9498-79cad8026f94",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[687333, 20113, 683, 19, 35, InheritFromParent,ExpressionUUID->"7d17b821-9dda-47f6-8359-8d2788625ed8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[688019, 20134, 8540, 257, 57, InheritFromParent,ExpressionUUID->"be8309ea-16d1-4f3a-b5f7-30e460260668",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[696562, 20393, 846, 21, 58, InheritFromParent,ExpressionUUID->"d78691b9-4c55-45a8-9e3f-5020642c4d25",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[697411, 20416, 9028, 273, 57, InheritFromParent,ExpressionUUID->"79cf473e-13ee-411c-ab41-e59682891b21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[706442, 20691, 689, 19, 35, InheritFromParent,ExpressionUUID->"90f3625a-e26e-4cd7-be4b-21bb01ded13f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[707134, 20712, 2254, 65, 52, InheritFromParent,ExpressionUUID->"33fd7929-7442-4545-9960-fc9669f7f8d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[709391, 20779, 8514, 257, 57, InheritFromParent,ExpressionUUID->"fb32e72e-da5f-4405-9051-33d9a7e880f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[717908, 21038, 1322, 28, 150, InheritFromParent,ExpressionUUID->"abfbf702-3626-40d4-92f1-b685bba6b9c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[719233, 21068, 913, 22, 81, InheritFromParent,ExpressionUUID->"7f38935d-b89e-4143-bd81-a1e794a3620e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[720149, 21092, 7676, 206, 136, InheritFromParent,ExpressionUUID->"d1590147-804a-4778-a7fc-214616d69f15",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[727828, 21300, 790, 21, 58, InheritFromParent,ExpressionUUID->"143af27d-2b4e-4dac-b5ca-9bc398abb8ef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[728621, 21323, 797, 21, 58, InheritFromParent,ExpressionUUID->"d4b29d21-6334-41f2-9424-aebd2553e04f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[729421, 21346, 7903, 224, 61, InheritFromParent,ExpressionUUID->"df4416cb-5f00-4fea-8468-abbac73dd16c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[737327, 21572, 7903, 224, 61, InheritFromParent,ExpressionUUID->"d760e4b1-ced1-438e-82aa-394980ee3cf8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745233, 21798, 692, 19, 35, InheritFromParent,ExpressionUUID->"173ce9ee-ae64-42e9-9e96-9d4a40dcfef3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745928, 21819, 14383, 411, 56, InheritFromParent,ExpressionUUID->"4b203467-cb2b-46ae-8b47-71c772c3440c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760314, 22232, 678, 19, 35, InheritFromParent,ExpressionUUID->"c14e5092-7614-441f-8796-30a7a64d7499",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760995, 22253, 22477, 681, 96, InheritFromParent,ExpressionUUID->"07705ec2-49a0-4811-badb-e7afacbbcc74",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[783475, 22936, 1030, 24, 104, InheritFromParent,ExpressionUUID->"4b964916-6106-46d7-9708-3ad46712d94a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]},
 "tmp387881759548"->{
  Cell[558, 20, 946, 18, 29, "Input",ExpressionUUID->"b9384e29-ebcf-4d1e-b562-f1587dbf5da2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[1507, 40, 706, 20, 67, InheritFromParent,ExpressionUUID->"655f4e1b-1a8e-4d4a-858b-59aa7082063a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[2216, 62, 1385, 33, 170, InheritFromParent,ExpressionUUID->"e42835ff-d35e-4efe-8f43-5fa8125fbe19",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[3604, 97, 688, 19, 41, InheritFromParent,ExpressionUUID->"3b809e43-d2f6-4f4a-b810-e1659f4a791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[4295, 118, 923, 22, 81, InheritFromParent,ExpressionUUID->"26686cf6-295b-456f-8440-5cecf0e696d4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5243, 144, 437, 9, 23, "Print",ExpressionUUID->"323b0b43-1933-4a4d-8d67-cc689ab3de7e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5683, 155, 709, 17, 25, "Print",ExpressionUUID->"d6c5f485-5dc5-4431-8543-843bd39d1b58",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6395, 174, 458, 9, 25, "Print",ExpressionUUID->"b5a8c692-548b-4b15-bc8e-f1606953eb03",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6856, 185, 417, 8, 25, "Print",ExpressionUUID->"ca3e3494-a5eb-42f9-bf9c-084a6575d0f5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7276, 195, 398, 8, 25, "Print",ExpressionUUID->"dce92f5f-0b7b-4832-a094-5a29b828ef4c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7677, 205, 439, 9, 23, "Print",ExpressionUUID->"afc7b575-1f7c-427f-b676-a58e99b54b66",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8119, 216, 715, 17, 25, "Print",ExpressionUUID->"23de39fb-26b9-4d84-82e3-da0a04a1115f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8837, 235, 458, 9, 25, "Print",ExpressionUUID->"574d02c4-4d57-4750-b337-f1c46ac5862c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9298, 246, 437, 9, 23, "Print",ExpressionUUID->"48521381-9713-4ce9-864f-2b453436faf0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9738, 257, 709, 17, 25, "Print",ExpressionUUID->"23024247-584c-4c96-8b6f-c721149f15c5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10450, 276, 508, 10, 45, "Print",ExpressionUUID->"5773044e-1cdd-42e1-957b-023676b56af9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10961, 288, 679, 16, 25, "Print",ExpressionUUID->"31a3b4d1-3ec0-4321-997b-18407e25a553",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[11643, 306, 763, 17, 25, "Print",ExpressionUUID->"872a2ace-a03b-45ad-b812-2627df56dad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[12409, 325, 864, 17, 25, "Print",ExpressionUUID->"1be38cd1-3cc7-44e0-bc52-6df574d1c2b9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[13276, 344, 822, 17, 25, "Print",ExpressionUUID->"7061ace8-a728-4a87-b6e8-c70ed05fdb9c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14101, 363, 840, 17, 25, "Print",ExpressionUUID->"66be857f-bca3-4910-8e8b-bb1965f6d674",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14944, 382, 439, 9, 23, "Print",ExpressionUUID->"7aa4e98b-2b90-4a24-b206-6c8dc6252de7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[15386, 393, 706, 16, 25, "Print",ExpressionUUID->"01a2dfb3-df3e-4524-923f-193f1ee8f902",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16095, 411, 484, 9, 45, "Print",ExpressionUUID->"e524aae7-d731-4da4-b993-13b51dadae3c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16582, 422, 805, 18, 25, "Print",ExpressionUUID->"62a61f68-d160-4d30-8b50-55d247c0e779",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[17390, 442, 799, 17, 25, "Print",ExpressionUUID->"2e9f0da9-6901-493b-b37a-ef1dfe1aec8a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[18192, 461, 846, 17, 25, "Print",ExpressionUUID->"fd1dd82e-8dcd-48c3-9461-abbbe51137da",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19041, 480, 759, 17, 25, "Print",ExpressionUUID->"dcf6e6b9-3fe0-4127-98be-ecea4457fed2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19803, 499, 437, 9, 23, "Print",ExpressionUUID->"92dfb0cc-4789-482e-b696-12f7352ec09d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20243, 510, 709, 17, 25, "Print",ExpressionUUID->"d1cf077f-7149-4890-96bb-cd3adae9d216",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20955, 529, 476, 9, 25, "Print",ExpressionUUID->"ea9021ff-5cfd-4155-8028-a1585c035bfd",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21434, 540, 437, 9, 23, "Print",ExpressionUUID->"4cb132fe-915a-47f8-ba42-3fb34ee0abab",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21874, 551, 727, 17, 25, "Print",ExpressionUUID->"c13bab9e-02ca-433e-aebc-f78dcdaf592d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[22604, 570, 463, 9, 25, "Print",ExpressionUUID->"4f95d5a3-7129-406e-8568-b27ba2b8b59b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23070, 581, 437, 9, 23, "Print",ExpressionUUID->"2cd8248f-5158-464d-b269-55c1932871e0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23510, 592, 708, 16, 25, "Print",ExpressionUUID->"865cb17b-7c96-4fb6-a4d7-b1d2fe214dc9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24221, 610, 447, 9, 25, "Print",ExpressionUUID->"6f09edce-f6f6-4d28-9083-cf176e6e82d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24671, 621, 769, 18, 25, "Print",ExpressionUUID->"ca7368dd-3f4a-4b30-8b15-7618f53d721e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[25443, 641, 844, 17, 25, "Print",ExpressionUUID->"4420b90e-a632-482d-b04c-c6cc5b4024c1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26290, 660, 437, 9, 23, "Print",ExpressionUUID->"0d53df74-4ea0-45c1-bab2-6617740b19f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26730, 671, 729, 17, 25, "Print",ExpressionUUID->"a3cb39a0-e8fc-4781-af32-f4418b309b89",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27462, 690, 477, 9, 25, "Print",ExpressionUUID->"5a91617f-dbe1-4aee-a2c9-f6a22f3c8c18",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27942, 701, 436, 9, 23, "Print",ExpressionUUID->"8be6937d-ed63-4de9-94fb-08ec19588479",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28381, 712, 415, 8, 25, "Print",ExpressionUUID->"5b413eff-9b52-463e-bdd0-db947ebe7c3e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28799, 722, 437, 9, 23, "Print",ExpressionUUID->"f99ae39d-53b8-448a-82ff-7b0faa0ddd7c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29239, 733, 715, 17, 25, "Print",ExpressionUUID->"41d159ee-f66b-4ec8-ba2a-989f3f1487f1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29957, 752, 507, 10, 45, "Print",ExpressionUUID->"dd938ca7-6cbf-4871-b2cd-40f5d5e82ad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30467, 764, 439, 9, 23, "Print",ExpressionUUID->"7c3d6dcd-1bc3-45ce-9428-b4fb990ce33e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30909, 775, 710, 16, 25, "Print",ExpressionUUID->"6cdaf39b-fc2d-48b3-805f-8826f49bb899",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[31622, 793, 474, 9, 25, "Print",ExpressionUUID->"65aa0dc6-fa75-4e5a-9e72-bda776caf6f2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32099, 804, 486, 9, 25, "Print",ExpressionUUID->"244f0ac0-b1fa-4b7f-828a-99eed080d3bb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32588, 815, 757, 17, 25, "Print",ExpressionUUID->"77e59c75-0569-4c5b-88f4-8a3bc242ed27",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33348, 834, 439, 9, 23, "Print",ExpressionUUID->"6b90bd70-24d1-47bc-8e49-e597a39ba247",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33790, 845, 738, 18, 25, "Print",ExpressionUUID->"04e62656-e161-4e61-bda3-7e75717e8c92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34531, 865, 460, 9, 25, "Print",ExpressionUUID->"383567e6-b4a8-4966-8ac9-c0ccaf084a44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34994, 876, 437, 9, 23, "Print",ExpressionUUID->"19fd2032-d9b2-47b8-9169-9f457881a9a8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[35434, 887, 592, 11, 65, "Print",ExpressionUUID->"336ac5be-41b1-4631-ad29-bcd5ef3f3764",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36029, 900, 437, 9, 23, "Print",ExpressionUUID->"ed21db18-371d-4c65-8d93-f560c4e43105",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36481, 912, 708, 20, 35, InheritFromParent,ExpressionUUID->"7640975b-0fe9-4643-b47c-be5b016d6f9e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37192, 934, 712, 20, 54, InheritFromParent,ExpressionUUID->"b84d46a0-8f09-43bb-bc4b-56162b9fcf69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37907, 956, 972, 23, 81, InheritFromParent,ExpressionUUID->"19e9ed3f-c481-497e-afc6-f7da2c4bafe9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[38882, 981, 799, 17, 25, "Print",ExpressionUUID->"6906580a-4558-4bbe-bf0e-7c16ba99ab3d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[39684, 1000, 7613, 266, 92, InheritFromParent,ExpressionUUID->"74aac581-908d-4aa2-b5b2-fef7cc572235",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[47300, 1268, 951, 23, 81, InheritFromParent,ExpressionUUID->"494dd010-24a9-45a0-a465-eff3b3de769d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48254, 1293, 685, 19, 41, InheritFromParent,ExpressionUUID->"d840fcaf-aaa7-4b67-8321-14f0c79c712c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48942, 1314, 818, 21, 58, InheritFromParent,ExpressionUUID->"1a6e2d40-ed52-407e-8f50-e0b9455ead24",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[49785, 1339, 892, 19, 25, "Print",ExpressionUUID->"efbc3a1e-25c8-4110-aa87-f4b2c401161a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[50680, 1360, 943, 21, 25, "Print",ExpressionUUID->"ee72a628-8b2b-4587-ad28-a3b98ad0298c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[51638, 1384, 649, 17, 35, InheritFromParent,ExpressionUUID->"2dcbb549-93f3-44bf-b839-10d5215e6a09",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[52290, 1403, 1352, 37, 52, InheritFromParent,ExpressionUUID->"7ae24dfc-66ae-4a53-8f20-5a6022436885",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[53645, 1442, 424, 8, 41, InheritFromParent,ExpressionUUID->"eba1453e-4f9a-42e2-8c3f-5e6062f326ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54072, 1452, 646, 17, 35, InheritFromParent,ExpressionUUID->"5f64a805-243d-42e5-bc87-a2782c2cdd0b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54721, 1471, 1396, 38, 52, InheritFromParent,ExpressionUUID->"60156e09-a022-4b81-9697-a3e819a5673c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[56120, 1511, 26201, 816, 93, InheritFromParent,ExpressionUUID->"8cdf4af9-b767-472b-84fc-d82a415ab18b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[82324, 2329, 1252, 27, 150, InheritFromParent,ExpressionUUID->"69e59fb4-5c2f-4c22-9474-3b397b96e83b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[83579, 2358, 1068, 24, 104, InheritFromParent,ExpressionUUID->"9d78e71d-e0fc-47ea-8b40-1f0c35936d2a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[84650, 2384, 688, 19, 41, InheritFromParent,ExpressionUUID->"a702087f-7f0a-4a29-afa9-8595374e609c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[85341, 2405, 833, 21, 58, InheritFromParent,ExpressionUUID->"d22212a8-7e21-400c-a7c4-6154d10577ea",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[86177, 2428, 970, 23, 81, InheritFromParent,ExpressionUUID->"fb602348-7013-4bc7-a060-71ecd67a7b1d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[87150, 2453, 117941, 3523, 312, InheritFromParent,ExpressionUUID->"0cd8973f-3019-433f-91e0-fb859654f7e2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[205094, 5978, 918, 23, 81, InheritFromParent,ExpressionUUID->"f2575653-814a-4991-a2de-9ce7ed722149",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[206015, 6003, 26653, 774, 118, InheritFromParent,ExpressionUUID->"1d261ece-ab42-4b33-a7cf-22ae810c6dcc",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[232671, 6779, 1035, 24, 104, InheritFromParent,ExpressionUUID->"a86af238-0e18-4d41-a788-62e409387ad1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[233709, 6805, 1124, 25, 127, InheritFromParent,ExpressionUUID->"97a46e92-275a-47a1-a901-467264d86f54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[234836, 6832, 910, 20, 25, "Print",ExpressionUUID->"9ca02f3c-a9ba-4b26-9633-0117c1b9c7a6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[235749, 6854, 1332, 36, 52, InheritFromParent,ExpressionUUID->"cb4d3995-bf8b-4ca6-9ce1-2f53df529da7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[237084, 6892, 6229, 183, 56, InheritFromParent,ExpressionUUID->"84e5208f-6d8b-4803-b36f-4d82c8bbbad6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[243316, 7077, 686, 19, 35, InheritFromParent,ExpressionUUID->"e09aef32-3cff-4a32-8413-f0cab2e0ab9f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[244005, 7098, 1279, 36, 52, InheritFromParent,ExpressionUUID->"218c7d03-6c3a-47cc-bf25-13520291791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[245287, 7136, 941, 23, 81, InheritFromParent,ExpressionUUID->"d3e25584-c3d9-4e03-89c2-44a581a6a931",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246231, 7161, 696, 20, 35, InheritFromParent,ExpressionUUID->"78f997fa-c618-4a9e-b48c-1e4fae4b04f4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246930, 7183, 910, 20, 25, "Print",ExpressionUUID->"f05579ee-6cbc-46b5-9f4f-779a59ef958f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[247843, 7205, 1203, 26, 127, InheritFromParent,ExpressionUUID->"f35e9a5b-c4dd-47e3-b2a7-9945e1d50e0e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[249049, 7233, 1169, 26, 127, InheritFromParent,ExpressionUUID->"f4b93215-c9c0-48a0-ad66-68810261018f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[250221, 7261, 930, 21, 25, "Print",ExpressionUUID->"94db25a8-ff82-49c6-9371-3b3906f4ffe5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[251154, 7284, 1333, 36, 52, InheritFromParent,ExpressionUUID->"570c9060-fb52-44a6-aa2e-389e9d5b02f6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[252490, 7322, 650, 17, 35, InheritFromParent,ExpressionUUID->"9f952f08-0179-4acb-ad53-c119682c92aa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[253143, 7341, 1319, 36, 52, InheritFromParent,ExpressionUUID->"b5bbdc2c-55b8-4870-b53d-0327b9f76fa3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[254465, 7379, 2652, 79, 49, InheritFromParent,ExpressionUUID->"96617eac-23dc-476b-9652-b1dce9217326",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257120, 7460, 722, 20, 35, InheritFromParent,ExpressionUUID->"d73d082a-4779-4c5d-9abe-ba15980c9aba",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257845, 7482, 2336, 66, 56, InheritFromParent,ExpressionUUID->"6be96410-1bf9-449b-a873-8f2892d0394d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[260184, 7550, 3631, 108, 56, InheritFromParent,ExpressionUUID->"38b4785c-5b69-4f18-ac19-480c5ae84db3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[263818, 7660, 730, 20, 35, InheritFromParent,ExpressionUUID->"0f72e7b7-7ed1-44e4-b60a-53bb0bdce2de",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[264551, 7682, 630, 17, 35, InheritFromParent,ExpressionUUID->"0982f795-e428-4d19-8d15-b8ddb256bfff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265184, 7701, 600, 15, 41, InheritFromParent,ExpressionUUID->"d7d4a64a-4e5a-4912-b9ff-f899ec1dc807",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265787, 7718, 4316, 133, 49, InheritFromParent,ExpressionUUID->"aca6ec55-9556-45e8-9c9a-845b1241b594",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270106, 7853, 629, 17, 35, InheritFromParent,ExpressionUUID->"e547d27a-2162-4ea3-ad37-2ef09e5f4c86",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270738, 7872, 596, 15, 41, InheritFromParent,ExpressionUUID->"ed922378-bd8c-4ceb-b516-8d36678b0907",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[271337, 7889, 6691, 203, 49, InheritFromParent,ExpressionUUID->"db353d9f-513f-4f9b-a0c8-aafde492e828",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278031, 8094, 635, 17, 35, InheritFromParent,ExpressionUUID->"7719cccd-757a-4763-a80f-ac47a8e9174d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278669, 8113, 1281, 36, 52, InheritFromParent,ExpressionUUID->"4d414f63-f7a4-495b-8cc6-d7055f83ad50",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[279953, 8151, 3340, 99, 52, InheritFromParent,ExpressionUUID->"d474b63f-5321-4855-b79e-084a20afd87e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[283296, 8252, 858, 22, 81, InheritFromParent,ExpressionUUID->"3dee2795-4d05-4efe-a2f8-6bccf06b2d21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[284157, 8276, 7234, 212, 56, InheritFromParent,ExpressionUUID->"f1aa6cd9-3914-4afc-8549-0e0268c04613",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[291394, 8490, 13120, 388, 56, InheritFromParent,ExpressionUUID->"f8d09264-8ab1-46dd-887b-e5ca058ee75c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[304517, 8880, 743, 20, 58, InheritFromParent,ExpressionUUID->"0c0bb409-a2f6-4fee-b8c8-3b461b842efa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[305263, 8902, 1279, 36, 52, InheritFromParent,ExpressionUUID->"f4f145a4-47cd-4c20-a77d-fb8afa3c8a77",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[306545, 8940, 13331, 395, 56, InheritFromParent,ExpressionUUID->"24fe1dd9-9f96-4acd-8ea6-bc2e71ca3f08",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[319879, 9337, 654, 17, 35, InheritFromParent,ExpressionUUID->"3ba01e8b-167b-479a-81ec-f428c62f5f81",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[320558, 9358, 456, 9, 25, "Print",ExpressionUUID->"b636a247-8891-49df-a008-20813b773799",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321017, 9369, 367, 8, 23, "Print",ExpressionUUID->"4bf2e0fa-3ba0-4464-a442-50a9cc50abdf",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321399, 9380, 1360, 38, 52, InheritFromParent,ExpressionUUID->"ef82b0f8-f076-461a-bff9-66027e60bdfe",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[322762, 9420, 13271, 394, 56, InheritFromParent,ExpressionUUID->"a57de255-7d1b-4c42-b265-7c7745be17b6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336036, 9816, 749, 20, 58, InheritFromParent,ExpressionUUID->"c303681a-55e6-4cfd-8724-f0b7162d116c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336788, 9838, 40718, 1180, 118, InheritFromParent,ExpressionUUID->"29e07eb3-976c-411b-9f94-16375400abae",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[377509, 11020, 1011, 24, 104, InheritFromParent,ExpressionUUID->"262e2a6a-5401-403a-895c-4594c6210ba7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[378523, 11046, 1872, 39, 368, InheritFromParent,ExpressionUUID->"fa281744-8557-47cc-9ab2-37c4eb2955eb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[380398, 11087, 839, 21, 58, InheritFromParent,ExpressionUUID->"6233d3d5-c5d2-42cf-8bae-2b61b7138602",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381262, 11112, 456, 9, 25, "Print",ExpressionUUID->"6e61b564-aa01-4740-974f-4651cc6f1c16",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381721, 11123, 368, 8, 23, "Print",ExpressionUUID->"c293088e-c2a0-420e-93b5-979f7126af49",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382104, 11134, 677, 19, 41, InheritFromParent,ExpressionUUID->"f2a71967-f0da-4412-8bc7-02eaf59f5458",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382784, 11155, 782, 21, 58, InheritFromParent,ExpressionUUID->"195600ce-ea6b-44b0-94da-8a294f8ad95e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[383569, 11178, 825, 21, 58, InheritFromParent,ExpressionUUID->"c9d6f1f3-f340-4933-ad76-6dcdeee462a2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[384397, 11201, 24829, 737, 81, InheritFromParent,ExpressionUUID->"6ac621ba-2f0d-4b0c-9588-6ef6799b1710",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[409229, 11940, 885, 22, 81, InheritFromParent,ExpressionUUID->"a4a2657e-e1be-43c7-b9dc-37ad9b9aa9e9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[410117, 11964, 78067, 2298, 229, InheritFromParent,ExpressionUUID->"8d289f74-704d-420a-80d8-761be6d9e1ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488187, 14264, 775, 20, 58, InheritFromParent,ExpressionUUID->"869d6edf-1a19-43ae-b937-da3fc25e528e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488965, 14286, 1606, 36, 258, InheritFromParent,ExpressionUUID->"b541844c-60ee-4b27-ad80-c9abc93a8437",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[490574, 14324, 688, 19, 41, InheritFromParent,ExpressionUUID->"c7f66d35-0768-40f4-9317-e3a2600040b8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[491265, 14345, 849, 21, 58, InheritFromParent,ExpressionUUID->"3a5f6d79-e2de-4063-a5e5-c5722df33822",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[492117, 14368, 12863, 382, 56, InheritFromParent,ExpressionUUID->"83d3926f-9e0d-4aed-a1e4-0aa3b2009d92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[504983, 14752, 810, 21, 58, InheritFromParent,ExpressionUUID->"15068d50-44a9-490e-8bbe-da6f6b0658f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[505796, 14775, 681, 19, 41, InheritFromParent,ExpressionUUID->"6012b86f-c5b5-4584-bcf3-2662a484fb69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[506480, 14796, 728, 20, 35, InheritFromParent,ExpressionUUID->"216ecab2-23d3-4088-8085-e8257fb73d07",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507211, 14818, 659, 17, 35, InheritFromParent,ExpressionUUID->"6799a4f0-567b-412f-aaff-a64c38495a67",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507873, 14837, 4361, 128, 52, InheritFromParent,ExpressionUUID->"c0f00af1-c65e-46b6-bea7-af95cee96b01",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512237, 14967, 660, 17, 35, InheritFromParent,ExpressionUUID->"d7863f6d-16db-4d15-ac48-8d32128a9b54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512900, 14986, 5405, 155, 52, InheritFromParent,ExpressionUUID->"f843b089-4a70-4161-9249-f59c662f230f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[518308, 15143, 785, 21, 58, InheritFromParent,ExpressionUUID->"b68ed01c-fdb9-4a3e-bc81-7f1617a837ce",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519096, 15166, 705, 19, 41, InheritFromParent,ExpressionUUID->"55ce4beb-ae95-4d2b-b519-c5423a1e8703",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519804, 15187, 796, 21, 58, InheritFromParent,ExpressionUUID->"50f39a67-37f1-4fa0-825d-00e049d7d06e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[520603, 15210, 723, 20, 35, InheritFromParent,ExpressionUUID->"971aec87-bbbb-4f25-9de6-b7b2fd24a27c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[521329, 15232, 124875, 3681, 391, InheritFromParent,ExpressionUUID->"62b83f51-f719-4613-b1fb-27f8830506c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646207, 18915, 695, 19, 35, InheritFromParent,ExpressionUUID->"1b4223bf-973e-44e7-b3e4-441de6e8bd44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646905, 18936, 19423, 570, 113, InheritFromParent,ExpressionUUID->"09191766-a67d-4d6e-8939-b02e692a5add",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[666331, 19508, 712, 20, 35, InheritFromParent,ExpressionUUID->"2d7971dd-7798-45ef-b4a1-01ee7ece9aef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[667046, 19530, 20284, 581, 116, InheritFromParent,ExpressionUUID->"7d4f7c77-e50a-4654-9498-79cad8026f94",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[687333, 20113, 683, 19, 35, InheritFromParent,ExpressionUUID->"7d17b821-9dda-47f6-8359-8d2788625ed8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[688019, 20134, 8540, 257, 57, InheritFromParent,ExpressionUUID->"be8309ea-16d1-4f3a-b5f7-30e460260668",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[696562, 20393, 846, 21, 58, InheritFromParent,ExpressionUUID->"d78691b9-4c55-45a8-9e3f-5020642c4d25",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[697411, 20416, 9028, 273, 57, InheritFromParent,ExpressionUUID->"79cf473e-13ee-411c-ab41-e59682891b21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[706442, 20691, 689, 19, 35, InheritFromParent,ExpressionUUID->"90f3625a-e26e-4cd7-be4b-21bb01ded13f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[707134, 20712, 2254, 65, 52, InheritFromParent,ExpressionUUID->"33fd7929-7442-4545-9960-fc9669f7f8d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[709391, 20779, 8514, 257, 57, InheritFromParent,ExpressionUUID->"fb32e72e-da5f-4405-9051-33d9a7e880f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[717908, 21038, 1322, 28, 150, InheritFromParent,ExpressionUUID->"abfbf702-3626-40d4-92f1-b685bba6b9c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[719233, 21068, 913, 22, 81, InheritFromParent,ExpressionUUID->"7f38935d-b89e-4143-bd81-a1e794a3620e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[720149, 21092, 7676, 206, 136, InheritFromParent,ExpressionUUID->"d1590147-804a-4778-a7fc-214616d69f15",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[727828, 21300, 790, 21, 58, InheritFromParent,ExpressionUUID->"143af27d-2b4e-4dac-b5ca-9bc398abb8ef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[728621, 21323, 797, 21, 58, InheritFromParent,ExpressionUUID->"d4b29d21-6334-41f2-9424-aebd2553e04f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[729421, 21346, 7903, 224, 61, InheritFromParent,ExpressionUUID->"df4416cb-5f00-4fea-8468-abbac73dd16c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[737327, 21572, 7903, 224, 61, InheritFromParent,ExpressionUUID->"d760e4b1-ced1-438e-82aa-394980ee3cf8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745233, 21798, 692, 19, 35, InheritFromParent,ExpressionUUID->"173ce9ee-ae64-42e9-9e96-9d4a40dcfef3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745928, 21819, 14383, 411, 56, InheritFromParent,ExpressionUUID->"4b203467-cb2b-46ae-8b47-71c772c3440c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760314, 22232, 678, 19, 35, InheritFromParent,ExpressionUUID->"c14e5092-7614-441f-8796-30a7a64d7499",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760995, 22253, 22477, 681, 96, InheritFromParent,ExpressionUUID->"07705ec2-49a0-4811-badb-e7afacbbcc74",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[783475, 22936, 1030, 24, 104, InheritFromParent,ExpressionUUID->"4b964916-6106-46d7-9708-3ad46712d94a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]},
 "tmp387881774099"->{
  Cell[558, 20, 946, 18, 29, "Input",ExpressionUUID->"b9384e29-ebcf-4d1e-b562-f1587dbf5da2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[1507, 40, 706, 20, 67, InheritFromParent,ExpressionUUID->"655f4e1b-1a8e-4d4a-858b-59aa7082063a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[2216, 62, 1385, 33, 170, InheritFromParent,ExpressionUUID->"e42835ff-d35e-4efe-8f43-5fa8125fbe19",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[3604, 97, 688, 19, 41, InheritFromParent,ExpressionUUID->"3b809e43-d2f6-4f4a-b810-e1659f4a791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[4295, 118, 923, 22, 81, InheritFromParent,ExpressionUUID->"26686cf6-295b-456f-8440-5cecf0e696d4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5243, 144, 437, 9, 23, "Print",ExpressionUUID->"323b0b43-1933-4a4d-8d67-cc689ab3de7e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5683, 155, 709, 17, 25, "Print",ExpressionUUID->"d6c5f485-5dc5-4431-8543-843bd39d1b58",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6395, 174, 458, 9, 25, "Print",ExpressionUUID->"b5a8c692-548b-4b15-bc8e-f1606953eb03",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6856, 185, 417, 8, 25, "Print",ExpressionUUID->"ca3e3494-a5eb-42f9-bf9c-084a6575d0f5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7276, 195, 398, 8, 25, "Print",ExpressionUUID->"dce92f5f-0b7b-4832-a094-5a29b828ef4c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7677, 205, 439, 9, 23, "Print",ExpressionUUID->"afc7b575-1f7c-427f-b676-a58e99b54b66",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8119, 216, 715, 17, 25, "Print",ExpressionUUID->"23de39fb-26b9-4d84-82e3-da0a04a1115f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8837, 235, 458, 9, 25, "Print",ExpressionUUID->"574d02c4-4d57-4750-b337-f1c46ac5862c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9298, 246, 437, 9, 23, "Print",ExpressionUUID->"48521381-9713-4ce9-864f-2b453436faf0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9738, 257, 709, 17, 25, "Print",ExpressionUUID->"23024247-584c-4c96-8b6f-c721149f15c5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10450, 276, 508, 10, 45, "Print",ExpressionUUID->"5773044e-1cdd-42e1-957b-023676b56af9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10961, 288, 679, 16, 25, "Print",ExpressionUUID->"31a3b4d1-3ec0-4321-997b-18407e25a553",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[11643, 306, 763, 17, 25, "Print",ExpressionUUID->"872a2ace-a03b-45ad-b812-2627df56dad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[12409, 325, 864, 17, 25, "Print",ExpressionUUID->"1be38cd1-3cc7-44e0-bc52-6df574d1c2b9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[13276, 344, 822, 17, 25, "Print",ExpressionUUID->"7061ace8-a728-4a87-b6e8-c70ed05fdb9c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14101, 363, 840, 17, 25, "Print",ExpressionUUID->"66be857f-bca3-4910-8e8b-bb1965f6d674",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14944, 382, 439, 9, 23, "Print",ExpressionUUID->"7aa4e98b-2b90-4a24-b206-6c8dc6252de7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[15386, 393, 706, 16, 25, "Print",ExpressionUUID->"01a2dfb3-df3e-4524-923f-193f1ee8f902",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16095, 411, 484, 9, 45, "Print",ExpressionUUID->"e524aae7-d731-4da4-b993-13b51dadae3c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16582, 422, 805, 18, 25, "Print",ExpressionUUID->"62a61f68-d160-4d30-8b50-55d247c0e779",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[17390, 442, 799, 17, 25, "Print",ExpressionUUID->"2e9f0da9-6901-493b-b37a-ef1dfe1aec8a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[18192, 461, 846, 17, 25, "Print",ExpressionUUID->"fd1dd82e-8dcd-48c3-9461-abbbe51137da",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19041, 480, 759, 17, 25, "Print",ExpressionUUID->"dcf6e6b9-3fe0-4127-98be-ecea4457fed2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19803, 499, 437, 9, 23, "Print",ExpressionUUID->"92dfb0cc-4789-482e-b696-12f7352ec09d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20243, 510, 709, 17, 25, "Print",ExpressionUUID->"d1cf077f-7149-4890-96bb-cd3adae9d216",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20955, 529, 476, 9, 25, "Print",ExpressionUUID->"ea9021ff-5cfd-4155-8028-a1585c035bfd",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21434, 540, 437, 9, 23, "Print",ExpressionUUID->"4cb132fe-915a-47f8-ba42-3fb34ee0abab",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21874, 551, 727, 17, 25, "Print",ExpressionUUID->"c13bab9e-02ca-433e-aebc-f78dcdaf592d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[22604, 570, 463, 9, 25, "Print",ExpressionUUID->"4f95d5a3-7129-406e-8568-b27ba2b8b59b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23070, 581, 437, 9, 23, "Print",ExpressionUUID->"2cd8248f-5158-464d-b269-55c1932871e0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23510, 592, 708, 16, 25, "Print",ExpressionUUID->"865cb17b-7c96-4fb6-a4d7-b1d2fe214dc9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24221, 610, 447, 9, 25, "Print",ExpressionUUID->"6f09edce-f6f6-4d28-9083-cf176e6e82d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24671, 621, 769, 18, 25, "Print",ExpressionUUID->"ca7368dd-3f4a-4b30-8b15-7618f53d721e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[25443, 641, 844, 17, 25, "Print",ExpressionUUID->"4420b90e-a632-482d-b04c-c6cc5b4024c1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26290, 660, 437, 9, 23, "Print",ExpressionUUID->"0d53df74-4ea0-45c1-bab2-6617740b19f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26730, 671, 729, 17, 25, "Print",ExpressionUUID->"a3cb39a0-e8fc-4781-af32-f4418b309b89",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27462, 690, 477, 9, 25, "Print",ExpressionUUID->"5a91617f-dbe1-4aee-a2c9-f6a22f3c8c18",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27942, 701, 436, 9, 23, "Print",ExpressionUUID->"8be6937d-ed63-4de9-94fb-08ec19588479",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28381, 712, 415, 8, 25, "Print",ExpressionUUID->"5b413eff-9b52-463e-bdd0-db947ebe7c3e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28799, 722, 437, 9, 23, "Print",ExpressionUUID->"f99ae39d-53b8-448a-82ff-7b0faa0ddd7c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29239, 733, 715, 17, 25, "Print",ExpressionUUID->"41d159ee-f66b-4ec8-ba2a-989f3f1487f1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29957, 752, 507, 10, 45, "Print",ExpressionUUID->"dd938ca7-6cbf-4871-b2cd-40f5d5e82ad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30467, 764, 439, 9, 23, "Print",ExpressionUUID->"7c3d6dcd-1bc3-45ce-9428-b4fb990ce33e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30909, 775, 710, 16, 25, "Print",ExpressionUUID->"6cdaf39b-fc2d-48b3-805f-8826f49bb899",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[31622, 793, 474, 9, 25, "Print",ExpressionUUID->"65aa0dc6-fa75-4e5a-9e72-bda776caf6f2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32099, 804, 486, 9, 25, "Print",ExpressionUUID->"244f0ac0-b1fa-4b7f-828a-99eed080d3bb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32588, 815, 757, 17, 25, "Print",ExpressionUUID->"77e59c75-0569-4c5b-88f4-8a3bc242ed27",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33348, 834, 439, 9, 23, "Print",ExpressionUUID->"6b90bd70-24d1-47bc-8e49-e597a39ba247",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33790, 845, 738, 18, 25, "Print",ExpressionUUID->"04e62656-e161-4e61-bda3-7e75717e8c92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34531, 865, 460, 9, 25, "Print",ExpressionUUID->"383567e6-b4a8-4966-8ac9-c0ccaf084a44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34994, 876, 437, 9, 23, "Print",ExpressionUUID->"19fd2032-d9b2-47b8-9169-9f457881a9a8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[35434, 887, 592, 11, 65, "Print",ExpressionUUID->"336ac5be-41b1-4631-ad29-bcd5ef3f3764",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36029, 900, 437, 9, 23, "Print",ExpressionUUID->"ed21db18-371d-4c65-8d93-f560c4e43105",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36481, 912, 708, 20, 35, InheritFromParent,ExpressionUUID->"7640975b-0fe9-4643-b47c-be5b016d6f9e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37192, 934, 712, 20, 54, InheritFromParent,ExpressionUUID->"b84d46a0-8f09-43bb-bc4b-56162b9fcf69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37907, 956, 972, 23, 81, InheritFromParent,ExpressionUUID->"19e9ed3f-c481-497e-afc6-f7da2c4bafe9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[38882, 981, 799, 17, 25, "Print",ExpressionUUID->"6906580a-4558-4bbe-bf0e-7c16ba99ab3d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[39684, 1000, 7613, 266, 92, InheritFromParent,ExpressionUUID->"74aac581-908d-4aa2-b5b2-fef7cc572235",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[47300, 1268, 951, 23, 81, InheritFromParent,ExpressionUUID->"494dd010-24a9-45a0-a465-eff3b3de769d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48254, 1293, 685, 19, 41, InheritFromParent,ExpressionUUID->"d840fcaf-aaa7-4b67-8321-14f0c79c712c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48942, 1314, 818, 21, 58, InheritFromParent,ExpressionUUID->"1a6e2d40-ed52-407e-8f50-e0b9455ead24",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[49785, 1339, 892, 19, 25, "Print",ExpressionUUID->"efbc3a1e-25c8-4110-aa87-f4b2c401161a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[50680, 1360, 943, 21, 25, "Print",ExpressionUUID->"ee72a628-8b2b-4587-ad28-a3b98ad0298c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[51638, 1384, 649, 17, 35, InheritFromParent,ExpressionUUID->"2dcbb549-93f3-44bf-b839-10d5215e6a09",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[52290, 1403, 1352, 37, 52, InheritFromParent,ExpressionUUID->"7ae24dfc-66ae-4a53-8f20-5a6022436885",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[53645, 1442, 424, 8, 41, InheritFromParent,ExpressionUUID->"eba1453e-4f9a-42e2-8c3f-5e6062f326ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54072, 1452, 646, 17, 35, InheritFromParent,ExpressionUUID->"5f64a805-243d-42e5-bc87-a2782c2cdd0b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54721, 1471, 1396, 38, 52, InheritFromParent,ExpressionUUID->"60156e09-a022-4b81-9697-a3e819a5673c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[56120, 1511, 26201, 816, 93, InheritFromParent,ExpressionUUID->"8cdf4af9-b767-472b-84fc-d82a415ab18b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[82324, 2329, 1252, 27, 150, InheritFromParent,ExpressionUUID->"69e59fb4-5c2f-4c22-9474-3b397b96e83b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[83579, 2358, 1068, 24, 104, InheritFromParent,ExpressionUUID->"9d78e71d-e0fc-47ea-8b40-1f0c35936d2a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[84650, 2384, 688, 19, 41, InheritFromParent,ExpressionUUID->"a702087f-7f0a-4a29-afa9-8595374e609c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[85341, 2405, 833, 21, 58, InheritFromParent,ExpressionUUID->"d22212a8-7e21-400c-a7c4-6154d10577ea",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[86177, 2428, 970, 23, 81, InheritFromParent,ExpressionUUID->"fb602348-7013-4bc7-a060-71ecd67a7b1d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[87150, 2453, 117941, 3523, 312, InheritFromParent,ExpressionUUID->"0cd8973f-3019-433f-91e0-fb859654f7e2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[205094, 5978, 918, 23, 81, InheritFromParent,ExpressionUUID->"f2575653-814a-4991-a2de-9ce7ed722149",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[206015, 6003, 26653, 774, 118, InheritFromParent,ExpressionUUID->"1d261ece-ab42-4b33-a7cf-22ae810c6dcc",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[232671, 6779, 1035, 24, 104, InheritFromParent,ExpressionUUID->"a86af238-0e18-4d41-a788-62e409387ad1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[233709, 6805, 1124, 25, 127, InheritFromParent,ExpressionUUID->"97a46e92-275a-47a1-a901-467264d86f54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[234836, 6832, 910, 20, 25, "Print",ExpressionUUID->"9ca02f3c-a9ba-4b26-9633-0117c1b9c7a6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[235749, 6854, 1332, 36, 52, InheritFromParent,ExpressionUUID->"cb4d3995-bf8b-4ca6-9ce1-2f53df529da7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[237084, 6892, 6229, 183, 56, InheritFromParent,ExpressionUUID->"84e5208f-6d8b-4803-b36f-4d82c8bbbad6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[243316, 7077, 686, 19, 35, InheritFromParent,ExpressionUUID->"e09aef32-3cff-4a32-8413-f0cab2e0ab9f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[244005, 7098, 1279, 36, 52, InheritFromParent,ExpressionUUID->"218c7d03-6c3a-47cc-bf25-13520291791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[245287, 7136, 941, 23, 81, InheritFromParent,ExpressionUUID->"d3e25584-c3d9-4e03-89c2-44a581a6a931",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246231, 7161, 696, 20, 35, InheritFromParent,ExpressionUUID->"78f997fa-c618-4a9e-b48c-1e4fae4b04f4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246930, 7183, 910, 20, 25, "Print",ExpressionUUID->"f05579ee-6cbc-46b5-9f4f-779a59ef958f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[247843, 7205, 1203, 26, 127, InheritFromParent,ExpressionUUID->"f35e9a5b-c4dd-47e3-b2a7-9945e1d50e0e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[249049, 7233, 1169, 26, 127, InheritFromParent,ExpressionUUID->"f4b93215-c9c0-48a0-ad66-68810261018f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[250221, 7261, 930, 21, 25, "Print",ExpressionUUID->"94db25a8-ff82-49c6-9371-3b3906f4ffe5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[251154, 7284, 1333, 36, 52, InheritFromParent,ExpressionUUID->"570c9060-fb52-44a6-aa2e-389e9d5b02f6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[252490, 7322, 650, 17, 35, InheritFromParent,ExpressionUUID->"9f952f08-0179-4acb-ad53-c119682c92aa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[253143, 7341, 1319, 36, 52, InheritFromParent,ExpressionUUID->"b5bbdc2c-55b8-4870-b53d-0327b9f76fa3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[254465, 7379, 2652, 79, 49, InheritFromParent,ExpressionUUID->"96617eac-23dc-476b-9652-b1dce9217326",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257120, 7460, 722, 20, 35, InheritFromParent,ExpressionUUID->"d73d082a-4779-4c5d-9abe-ba15980c9aba",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257845, 7482, 2336, 66, 56, InheritFromParent,ExpressionUUID->"6be96410-1bf9-449b-a873-8f2892d0394d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[260184, 7550, 3631, 108, 56, InheritFromParent,ExpressionUUID->"38b4785c-5b69-4f18-ac19-480c5ae84db3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[263818, 7660, 730, 20, 35, InheritFromParent,ExpressionUUID->"0f72e7b7-7ed1-44e4-b60a-53bb0bdce2de",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[264551, 7682, 630, 17, 35, InheritFromParent,ExpressionUUID->"0982f795-e428-4d19-8d15-b8ddb256bfff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265184, 7701, 600, 15, 41, InheritFromParent,ExpressionUUID->"d7d4a64a-4e5a-4912-b9ff-f899ec1dc807",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265787, 7718, 4316, 133, 49, InheritFromParent,ExpressionUUID->"aca6ec55-9556-45e8-9c9a-845b1241b594",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270106, 7853, 629, 17, 35, InheritFromParent,ExpressionUUID->"e547d27a-2162-4ea3-ad37-2ef09e5f4c86",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270738, 7872, 596, 15, 41, InheritFromParent,ExpressionUUID->"ed922378-bd8c-4ceb-b516-8d36678b0907",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[271337, 7889, 6691, 203, 49, InheritFromParent,ExpressionUUID->"db353d9f-513f-4f9b-a0c8-aafde492e828",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278031, 8094, 635, 17, 35, InheritFromParent,ExpressionUUID->"7719cccd-757a-4763-a80f-ac47a8e9174d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278669, 8113, 1281, 36, 52, InheritFromParent,ExpressionUUID->"4d414f63-f7a4-495b-8cc6-d7055f83ad50",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[279953, 8151, 3340, 99, 52, InheritFromParent,ExpressionUUID->"d474b63f-5321-4855-b79e-084a20afd87e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[283296, 8252, 858, 22, 81, InheritFromParent,ExpressionUUID->"3dee2795-4d05-4efe-a2f8-6bccf06b2d21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[284157, 8276, 7234, 212, 56, InheritFromParent,ExpressionUUID->"f1aa6cd9-3914-4afc-8549-0e0268c04613",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[291394, 8490, 13120, 388, 56, InheritFromParent,ExpressionUUID->"f8d09264-8ab1-46dd-887b-e5ca058ee75c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[304517, 8880, 743, 20, 58, InheritFromParent,ExpressionUUID->"0c0bb409-a2f6-4fee-b8c8-3b461b842efa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[305263, 8902, 1279, 36, 52, InheritFromParent,ExpressionUUID->"f4f145a4-47cd-4c20-a77d-fb8afa3c8a77",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[306545, 8940, 13331, 395, 56, InheritFromParent,ExpressionUUID->"24fe1dd9-9f96-4acd-8ea6-bc2e71ca3f08",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[319879, 9337, 654, 17, 35, InheritFromParent,ExpressionUUID->"3ba01e8b-167b-479a-81ec-f428c62f5f81",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[320558, 9358, 456, 9, 25, "Print",ExpressionUUID->"b636a247-8891-49df-a008-20813b773799",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321017, 9369, 367, 8, 23, "Print",ExpressionUUID->"4bf2e0fa-3ba0-4464-a442-50a9cc50abdf",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321399, 9380, 1360, 38, 52, InheritFromParent,ExpressionUUID->"ef82b0f8-f076-461a-bff9-66027e60bdfe",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[322762, 9420, 13271, 394, 56, InheritFromParent,ExpressionUUID->"a57de255-7d1b-4c42-b265-7c7745be17b6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336036, 9816, 749, 20, 58, InheritFromParent,ExpressionUUID->"c303681a-55e6-4cfd-8724-f0b7162d116c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336788, 9838, 40718, 1180, 118, InheritFromParent,ExpressionUUID->"29e07eb3-976c-411b-9f94-16375400abae",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[377509, 11020, 1011, 24, 104, InheritFromParent,ExpressionUUID->"262e2a6a-5401-403a-895c-4594c6210ba7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[378523, 11046, 1872, 39, 368, InheritFromParent,ExpressionUUID->"fa281744-8557-47cc-9ab2-37c4eb2955eb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[380398, 11087, 839, 21, 58, InheritFromParent,ExpressionUUID->"6233d3d5-c5d2-42cf-8bae-2b61b7138602",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381262, 11112, 456, 9, 25, "Print",ExpressionUUID->"6e61b564-aa01-4740-974f-4651cc6f1c16",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381721, 11123, 368, 8, 23, "Print",ExpressionUUID->"c293088e-c2a0-420e-93b5-979f7126af49",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382104, 11134, 677, 19, 41, InheritFromParent,ExpressionUUID->"f2a71967-f0da-4412-8bc7-02eaf59f5458",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382784, 11155, 782, 21, 58, InheritFromParent,ExpressionUUID->"195600ce-ea6b-44b0-94da-8a294f8ad95e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[383569, 11178, 825, 21, 58, InheritFromParent,ExpressionUUID->"c9d6f1f3-f340-4933-ad76-6dcdeee462a2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[384397, 11201, 24829, 737, 81, InheritFromParent,ExpressionUUID->"6ac621ba-2f0d-4b0c-9588-6ef6799b1710",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[409229, 11940, 885, 22, 81, InheritFromParent,ExpressionUUID->"a4a2657e-e1be-43c7-b9dc-37ad9b9aa9e9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[410117, 11964, 78067, 2298, 229, InheritFromParent,ExpressionUUID->"8d289f74-704d-420a-80d8-761be6d9e1ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488187, 14264, 775, 20, 58, InheritFromParent,ExpressionUUID->"869d6edf-1a19-43ae-b937-da3fc25e528e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488965, 14286, 1606, 36, 258, InheritFromParent,ExpressionUUID->"b541844c-60ee-4b27-ad80-c9abc93a8437",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[490574, 14324, 688, 19, 41, InheritFromParent,ExpressionUUID->"c7f66d35-0768-40f4-9317-e3a2600040b8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[491265, 14345, 849, 21, 58, InheritFromParent,ExpressionUUID->"3a5f6d79-e2de-4063-a5e5-c5722df33822",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[492117, 14368, 12863, 382, 56, InheritFromParent,ExpressionUUID->"83d3926f-9e0d-4aed-a1e4-0aa3b2009d92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[504983, 14752, 810, 21, 58, InheritFromParent,ExpressionUUID->"15068d50-44a9-490e-8bbe-da6f6b0658f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[505796, 14775, 681, 19, 41, InheritFromParent,ExpressionUUID->"6012b86f-c5b5-4584-bcf3-2662a484fb69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[506480, 14796, 728, 20, 35, InheritFromParent,ExpressionUUID->"216ecab2-23d3-4088-8085-e8257fb73d07",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507211, 14818, 659, 17, 35, InheritFromParent,ExpressionUUID->"6799a4f0-567b-412f-aaff-a64c38495a67",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507873, 14837, 4361, 128, 52, InheritFromParent,ExpressionUUID->"c0f00af1-c65e-46b6-bea7-af95cee96b01",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512237, 14967, 660, 17, 35, InheritFromParent,ExpressionUUID->"d7863f6d-16db-4d15-ac48-8d32128a9b54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512900, 14986, 5405, 155, 52, InheritFromParent,ExpressionUUID->"f843b089-4a70-4161-9249-f59c662f230f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[518308, 15143, 785, 21, 58, InheritFromParent,ExpressionUUID->"b68ed01c-fdb9-4a3e-bc81-7f1617a837ce",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519096, 15166, 705, 19, 41, InheritFromParent,ExpressionUUID->"55ce4beb-ae95-4d2b-b519-c5423a1e8703",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519804, 15187, 796, 21, 58, InheritFromParent,ExpressionUUID->"50f39a67-37f1-4fa0-825d-00e049d7d06e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[520603, 15210, 723, 20, 35, InheritFromParent,ExpressionUUID->"971aec87-bbbb-4f25-9de6-b7b2fd24a27c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[521329, 15232, 124875, 3681, 391, InheritFromParent,ExpressionUUID->"62b83f51-f719-4613-b1fb-27f8830506c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646207, 18915, 695, 19, 35, InheritFromParent,ExpressionUUID->"1b4223bf-973e-44e7-b3e4-441de6e8bd44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646905, 18936, 19423, 570, 113, InheritFromParent,ExpressionUUID->"09191766-a67d-4d6e-8939-b02e692a5add",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[666331, 19508, 712, 20, 35, InheritFromParent,ExpressionUUID->"2d7971dd-7798-45ef-b4a1-01ee7ece9aef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[667046, 19530, 20284, 581, 116, InheritFromParent,ExpressionUUID->"7d4f7c77-e50a-4654-9498-79cad8026f94",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[687333, 20113, 683, 19, 35, InheritFromParent,ExpressionUUID->"7d17b821-9dda-47f6-8359-8d2788625ed8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[688019, 20134, 8540, 257, 57, InheritFromParent,ExpressionUUID->"be8309ea-16d1-4f3a-b5f7-30e460260668",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[696562, 20393, 846, 21, 58, InheritFromParent,ExpressionUUID->"d78691b9-4c55-45a8-9e3f-5020642c4d25",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[697411, 20416, 9028, 273, 57, InheritFromParent,ExpressionUUID->"79cf473e-13ee-411c-ab41-e59682891b21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[706442, 20691, 689, 19, 35, InheritFromParent,ExpressionUUID->"90f3625a-e26e-4cd7-be4b-21bb01ded13f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[707134, 20712, 2254, 65, 52, InheritFromParent,ExpressionUUID->"33fd7929-7442-4545-9960-fc9669f7f8d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[709391, 20779, 8514, 257, 57, InheritFromParent,ExpressionUUID->"fb32e72e-da5f-4405-9051-33d9a7e880f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[717908, 21038, 1322, 28, 150, InheritFromParent,ExpressionUUID->"abfbf702-3626-40d4-92f1-b685bba6b9c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[719233, 21068, 913, 22, 81, InheritFromParent,ExpressionUUID->"7f38935d-b89e-4143-bd81-a1e794a3620e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[720149, 21092, 7676, 206, 136, InheritFromParent,ExpressionUUID->"d1590147-804a-4778-a7fc-214616d69f15",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[727828, 21300, 790, 21, 58, InheritFromParent,ExpressionUUID->"143af27d-2b4e-4dac-b5ca-9bc398abb8ef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[728621, 21323, 797, 21, 58, InheritFromParent,ExpressionUUID->"d4b29d21-6334-41f2-9424-aebd2553e04f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[729421, 21346, 7903, 224, 61, InheritFromParent,ExpressionUUID->"df4416cb-5f00-4fea-8468-abbac73dd16c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[737327, 21572, 7903, 224, 61, InheritFromParent,ExpressionUUID->"d760e4b1-ced1-438e-82aa-394980ee3cf8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745233, 21798, 692, 19, 35, InheritFromParent,ExpressionUUID->"173ce9ee-ae64-42e9-9e96-9d4a40dcfef3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745928, 21819, 14383, 411, 56, InheritFromParent,ExpressionUUID->"4b203467-cb2b-46ae-8b47-71c772c3440c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760314, 22232, 678, 19, 35, InheritFromParent,ExpressionUUID->"c14e5092-7614-441f-8796-30a7a64d7499",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760995, 22253, 22477, 681, 96, InheritFromParent,ExpressionUUID->"07705ec2-49a0-4811-badb-e7afacbbcc74",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[783475, 22936, 1030, 24, 104, InheritFromParent,ExpressionUUID->"4b964916-6106-46d7-9708-3ad46712d94a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]},
 "tmp387881790868"->{
  Cell[558, 20, 946, 18, 29, "Input",ExpressionUUID->"b9384e29-ebcf-4d1e-b562-f1587dbf5da2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[1507, 40, 706, 20, 67, InheritFromParent,ExpressionUUID->"655f4e1b-1a8e-4d4a-858b-59aa7082063a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[2216, 62, 1385, 33, 170, InheritFromParent,ExpressionUUID->"e42835ff-d35e-4efe-8f43-5fa8125fbe19",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[3604, 97, 688, 19, 41, InheritFromParent,ExpressionUUID->"3b809e43-d2f6-4f4a-b810-e1659f4a791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[4295, 118, 923, 22, 81, InheritFromParent,ExpressionUUID->"26686cf6-295b-456f-8440-5cecf0e696d4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5243, 144, 437, 9, 23, "Print",ExpressionUUID->"323b0b43-1933-4a4d-8d67-cc689ab3de7e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5683, 155, 709, 17, 25, "Print",ExpressionUUID->"d6c5f485-5dc5-4431-8543-843bd39d1b58",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6395, 174, 458, 9, 25, "Print",ExpressionUUID->"b5a8c692-548b-4b15-bc8e-f1606953eb03",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6856, 185, 417, 8, 25, "Print",ExpressionUUID->"ca3e3494-a5eb-42f9-bf9c-084a6575d0f5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7276, 195, 398, 8, 25, "Print",ExpressionUUID->"dce92f5f-0b7b-4832-a094-5a29b828ef4c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7677, 205, 439, 9, 23, "Print",ExpressionUUID->"afc7b575-1f7c-427f-b676-a58e99b54b66",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8119, 216, 715, 17, 25, "Print",ExpressionUUID->"23de39fb-26b9-4d84-82e3-da0a04a1115f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8837, 235, 458, 9, 25, "Print",ExpressionUUID->"574d02c4-4d57-4750-b337-f1c46ac5862c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9298, 246, 437, 9, 23, "Print",ExpressionUUID->"48521381-9713-4ce9-864f-2b453436faf0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9738, 257, 709, 17, 25, "Print",ExpressionUUID->"23024247-584c-4c96-8b6f-c721149f15c5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10450, 276, 508, 10, 45, "Print",ExpressionUUID->"5773044e-1cdd-42e1-957b-023676b56af9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10961, 288, 679, 16, 25, "Print",ExpressionUUID->"31a3b4d1-3ec0-4321-997b-18407e25a553",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[11643, 306, 763, 17, 25, "Print",ExpressionUUID->"872a2ace-a03b-45ad-b812-2627df56dad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[12409, 325, 864, 17, 25, "Print",ExpressionUUID->"1be38cd1-3cc7-44e0-bc52-6df574d1c2b9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[13276, 344, 822, 17, 25, "Print",ExpressionUUID->"7061ace8-a728-4a87-b6e8-c70ed05fdb9c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14101, 363, 840, 17, 25, "Print",ExpressionUUID->"66be857f-bca3-4910-8e8b-bb1965f6d674",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14944, 382, 439, 9, 23, "Print",ExpressionUUID->"7aa4e98b-2b90-4a24-b206-6c8dc6252de7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[15386, 393, 706, 16, 25, "Print",ExpressionUUID->"01a2dfb3-df3e-4524-923f-193f1ee8f902",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16095, 411, 484, 9, 45, "Print",ExpressionUUID->"e524aae7-d731-4da4-b993-13b51dadae3c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16582, 422, 805, 18, 25, "Print",ExpressionUUID->"62a61f68-d160-4d30-8b50-55d247c0e779",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[17390, 442, 799, 17, 25, "Print",ExpressionUUID->"2e9f0da9-6901-493b-b37a-ef1dfe1aec8a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[18192, 461, 846, 17, 25, "Print",ExpressionUUID->"fd1dd82e-8dcd-48c3-9461-abbbe51137da",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19041, 480, 759, 17, 25, "Print",ExpressionUUID->"dcf6e6b9-3fe0-4127-98be-ecea4457fed2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19803, 499, 437, 9, 23, "Print",ExpressionUUID->"92dfb0cc-4789-482e-b696-12f7352ec09d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20243, 510, 709, 17, 25, "Print",ExpressionUUID->"d1cf077f-7149-4890-96bb-cd3adae9d216",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20955, 529, 476, 9, 25, "Print",ExpressionUUID->"ea9021ff-5cfd-4155-8028-a1585c035bfd",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21434, 540, 437, 9, 23, "Print",ExpressionUUID->"4cb132fe-915a-47f8-ba42-3fb34ee0abab",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21874, 551, 727, 17, 25, "Print",ExpressionUUID->"c13bab9e-02ca-433e-aebc-f78dcdaf592d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[22604, 570, 463, 9, 25, "Print",ExpressionUUID->"4f95d5a3-7129-406e-8568-b27ba2b8b59b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23070, 581, 437, 9, 23, "Print",ExpressionUUID->"2cd8248f-5158-464d-b269-55c1932871e0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23510, 592, 708, 16, 25, "Print",ExpressionUUID->"865cb17b-7c96-4fb6-a4d7-b1d2fe214dc9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24221, 610, 447, 9, 25, "Print",ExpressionUUID->"6f09edce-f6f6-4d28-9083-cf176e6e82d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24671, 621, 769, 18, 25, "Print",ExpressionUUID->"ca7368dd-3f4a-4b30-8b15-7618f53d721e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[25443, 641, 844, 17, 25, "Print",ExpressionUUID->"4420b90e-a632-482d-b04c-c6cc5b4024c1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26290, 660, 437, 9, 23, "Print",ExpressionUUID->"0d53df74-4ea0-45c1-bab2-6617740b19f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26730, 671, 729, 17, 25, "Print",ExpressionUUID->"a3cb39a0-e8fc-4781-af32-f4418b309b89",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27462, 690, 477, 9, 25, "Print",ExpressionUUID->"5a91617f-dbe1-4aee-a2c9-f6a22f3c8c18",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27942, 701, 436, 9, 23, "Print",ExpressionUUID->"8be6937d-ed63-4de9-94fb-08ec19588479",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28381, 712, 415, 8, 25, "Print",ExpressionUUID->"5b413eff-9b52-463e-bdd0-db947ebe7c3e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28799, 722, 437, 9, 23, "Print",ExpressionUUID->"f99ae39d-53b8-448a-82ff-7b0faa0ddd7c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29239, 733, 715, 17, 25, "Print",ExpressionUUID->"41d159ee-f66b-4ec8-ba2a-989f3f1487f1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29957, 752, 507, 10, 45, "Print",ExpressionUUID->"dd938ca7-6cbf-4871-b2cd-40f5d5e82ad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30467, 764, 439, 9, 23, "Print",ExpressionUUID->"7c3d6dcd-1bc3-45ce-9428-b4fb990ce33e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30909, 775, 710, 16, 25, "Print",ExpressionUUID->"6cdaf39b-fc2d-48b3-805f-8826f49bb899",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[31622, 793, 474, 9, 25, "Print",ExpressionUUID->"65aa0dc6-fa75-4e5a-9e72-bda776caf6f2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32099, 804, 486, 9, 25, "Print",ExpressionUUID->"244f0ac0-b1fa-4b7f-828a-99eed080d3bb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32588, 815, 757, 17, 25, "Print",ExpressionUUID->"77e59c75-0569-4c5b-88f4-8a3bc242ed27",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33348, 834, 439, 9, 23, "Print",ExpressionUUID->"6b90bd70-24d1-47bc-8e49-e597a39ba247",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33790, 845, 738, 18, 25, "Print",ExpressionUUID->"04e62656-e161-4e61-bda3-7e75717e8c92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34531, 865, 460, 9, 25, "Print",ExpressionUUID->"383567e6-b4a8-4966-8ac9-c0ccaf084a44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34994, 876, 437, 9, 23, "Print",ExpressionUUID->"19fd2032-d9b2-47b8-9169-9f457881a9a8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[35434, 887, 592, 11, 65, "Print",ExpressionUUID->"336ac5be-41b1-4631-ad29-bcd5ef3f3764",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36029, 900, 437, 9, 23, "Print",ExpressionUUID->"ed21db18-371d-4c65-8d93-f560c4e43105",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36481, 912, 708, 20, 35, InheritFromParent,ExpressionUUID->"7640975b-0fe9-4643-b47c-be5b016d6f9e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37192, 934, 712, 20, 54, InheritFromParent,ExpressionUUID->"b84d46a0-8f09-43bb-bc4b-56162b9fcf69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37907, 956, 972, 23, 81, InheritFromParent,ExpressionUUID->"19e9ed3f-c481-497e-afc6-f7da2c4bafe9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[38882, 981, 799, 17, 25, "Print",ExpressionUUID->"6906580a-4558-4bbe-bf0e-7c16ba99ab3d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[39684, 1000, 7613, 266, 92, InheritFromParent,ExpressionUUID->"74aac581-908d-4aa2-b5b2-fef7cc572235",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[47300, 1268, 951, 23, 81, InheritFromParent,ExpressionUUID->"494dd010-24a9-45a0-a465-eff3b3de769d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48254, 1293, 685, 19, 41, InheritFromParent,ExpressionUUID->"d840fcaf-aaa7-4b67-8321-14f0c79c712c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48942, 1314, 818, 21, 58, InheritFromParent,ExpressionUUID->"1a6e2d40-ed52-407e-8f50-e0b9455ead24",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[49785, 1339, 892, 19, 25, "Print",ExpressionUUID->"efbc3a1e-25c8-4110-aa87-f4b2c401161a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[50680, 1360, 943, 21, 25, "Print",ExpressionUUID->"ee72a628-8b2b-4587-ad28-a3b98ad0298c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[51638, 1384, 649, 17, 35, InheritFromParent,ExpressionUUID->"2dcbb549-93f3-44bf-b839-10d5215e6a09",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[52290, 1403, 1352, 37, 52, InheritFromParent,ExpressionUUID->"7ae24dfc-66ae-4a53-8f20-5a6022436885",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[53645, 1442, 424, 8, 41, InheritFromParent,ExpressionUUID->"eba1453e-4f9a-42e2-8c3f-5e6062f326ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54072, 1452, 646, 17, 35, InheritFromParent,ExpressionUUID->"5f64a805-243d-42e5-bc87-a2782c2cdd0b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54721, 1471, 1396, 38, 52, InheritFromParent,ExpressionUUID->"60156e09-a022-4b81-9697-a3e819a5673c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[56120, 1511, 26201, 816, 93, InheritFromParent,ExpressionUUID->"8cdf4af9-b767-472b-84fc-d82a415ab18b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[82324, 2329, 1252, 27, 150, InheritFromParent,ExpressionUUID->"69e59fb4-5c2f-4c22-9474-3b397b96e83b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[83579, 2358, 1068, 24, 104, InheritFromParent,ExpressionUUID->"9d78e71d-e0fc-47ea-8b40-1f0c35936d2a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[84650, 2384, 688, 19, 41, InheritFromParent,ExpressionUUID->"a702087f-7f0a-4a29-afa9-8595374e609c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[85341, 2405, 833, 21, 58, InheritFromParent,ExpressionUUID->"d22212a8-7e21-400c-a7c4-6154d10577ea",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[86177, 2428, 970, 23, 81, InheritFromParent,ExpressionUUID->"fb602348-7013-4bc7-a060-71ecd67a7b1d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[87150, 2453, 117941, 3523, 312, InheritFromParent,ExpressionUUID->"0cd8973f-3019-433f-91e0-fb859654f7e2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[205094, 5978, 918, 23, 81, InheritFromParent,ExpressionUUID->"f2575653-814a-4991-a2de-9ce7ed722149",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[206015, 6003, 26653, 774, 118, InheritFromParent,ExpressionUUID->"1d261ece-ab42-4b33-a7cf-22ae810c6dcc",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[232671, 6779, 1035, 24, 104, InheritFromParent,ExpressionUUID->"a86af238-0e18-4d41-a788-62e409387ad1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[233709, 6805, 1124, 25, 127, InheritFromParent,ExpressionUUID->"97a46e92-275a-47a1-a901-467264d86f54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[234836, 6832, 910, 20, 25, "Print",ExpressionUUID->"9ca02f3c-a9ba-4b26-9633-0117c1b9c7a6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[235749, 6854, 1332, 36, 52, InheritFromParent,ExpressionUUID->"cb4d3995-bf8b-4ca6-9ce1-2f53df529da7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[237084, 6892, 6229, 183, 56, InheritFromParent,ExpressionUUID->"84e5208f-6d8b-4803-b36f-4d82c8bbbad6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[243316, 7077, 686, 19, 35, InheritFromParent,ExpressionUUID->"e09aef32-3cff-4a32-8413-f0cab2e0ab9f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[244005, 7098, 1279, 36, 52, InheritFromParent,ExpressionUUID->"218c7d03-6c3a-47cc-bf25-13520291791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[245287, 7136, 941, 23, 81, InheritFromParent,ExpressionUUID->"d3e25584-c3d9-4e03-89c2-44a581a6a931",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246231, 7161, 696, 20, 35, InheritFromParent,ExpressionUUID->"78f997fa-c618-4a9e-b48c-1e4fae4b04f4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246930, 7183, 910, 20, 25, "Print",ExpressionUUID->"f05579ee-6cbc-46b5-9f4f-779a59ef958f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[247843, 7205, 1203, 26, 127, InheritFromParent,ExpressionUUID->"f35e9a5b-c4dd-47e3-b2a7-9945e1d50e0e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[249049, 7233, 1169, 26, 127, InheritFromParent,ExpressionUUID->"f4b93215-c9c0-48a0-ad66-68810261018f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[250221, 7261, 930, 21, 25, "Print",ExpressionUUID->"94db25a8-ff82-49c6-9371-3b3906f4ffe5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[251154, 7284, 1333, 36, 52, InheritFromParent,ExpressionUUID->"570c9060-fb52-44a6-aa2e-389e9d5b02f6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[252490, 7322, 650, 17, 35, InheritFromParent,ExpressionUUID->"9f952f08-0179-4acb-ad53-c119682c92aa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[253143, 7341, 1319, 36, 52, InheritFromParent,ExpressionUUID->"b5bbdc2c-55b8-4870-b53d-0327b9f76fa3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[254465, 7379, 2652, 79, 49, InheritFromParent,ExpressionUUID->"96617eac-23dc-476b-9652-b1dce9217326",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257120, 7460, 722, 20, 35, InheritFromParent,ExpressionUUID->"d73d082a-4779-4c5d-9abe-ba15980c9aba",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257845, 7482, 2336, 66, 56, InheritFromParent,ExpressionUUID->"6be96410-1bf9-449b-a873-8f2892d0394d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[260184, 7550, 3631, 108, 56, InheritFromParent,ExpressionUUID->"38b4785c-5b69-4f18-ac19-480c5ae84db3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[263818, 7660, 730, 20, 35, InheritFromParent,ExpressionUUID->"0f72e7b7-7ed1-44e4-b60a-53bb0bdce2de",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[264551, 7682, 630, 17, 35, InheritFromParent,ExpressionUUID->"0982f795-e428-4d19-8d15-b8ddb256bfff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265184, 7701, 600, 15, 41, InheritFromParent,ExpressionUUID->"d7d4a64a-4e5a-4912-b9ff-f899ec1dc807",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265787, 7718, 4316, 133, 49, InheritFromParent,ExpressionUUID->"aca6ec55-9556-45e8-9c9a-845b1241b594",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270106, 7853, 629, 17, 35, InheritFromParent,ExpressionUUID->"e547d27a-2162-4ea3-ad37-2ef09e5f4c86",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270738, 7872, 596, 15, 41, InheritFromParent,ExpressionUUID->"ed922378-bd8c-4ceb-b516-8d36678b0907",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[271337, 7889, 6691, 203, 49, InheritFromParent,ExpressionUUID->"db353d9f-513f-4f9b-a0c8-aafde492e828",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278031, 8094, 635, 17, 35, InheritFromParent,ExpressionUUID->"7719cccd-757a-4763-a80f-ac47a8e9174d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278669, 8113, 1281, 36, 52, InheritFromParent,ExpressionUUID->"4d414f63-f7a4-495b-8cc6-d7055f83ad50",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[279953, 8151, 3340, 99, 52, InheritFromParent,ExpressionUUID->"d474b63f-5321-4855-b79e-084a20afd87e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[283296, 8252, 858, 22, 81, InheritFromParent,ExpressionUUID->"3dee2795-4d05-4efe-a2f8-6bccf06b2d21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[284157, 8276, 7234, 212, 56, InheritFromParent,ExpressionUUID->"f1aa6cd9-3914-4afc-8549-0e0268c04613",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[291394, 8490, 13120, 388, 56, InheritFromParent,ExpressionUUID->"f8d09264-8ab1-46dd-887b-e5ca058ee75c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[304517, 8880, 743, 20, 58, InheritFromParent,ExpressionUUID->"0c0bb409-a2f6-4fee-b8c8-3b461b842efa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[305263, 8902, 1279, 36, 52, InheritFromParent,ExpressionUUID->"f4f145a4-47cd-4c20-a77d-fb8afa3c8a77",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[306545, 8940, 13331, 395, 56, InheritFromParent,ExpressionUUID->"24fe1dd9-9f96-4acd-8ea6-bc2e71ca3f08",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[319879, 9337, 654, 17, 35, InheritFromParent,ExpressionUUID->"3ba01e8b-167b-479a-81ec-f428c62f5f81",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[320558, 9358, 456, 9, 25, "Print",ExpressionUUID->"b636a247-8891-49df-a008-20813b773799",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321017, 9369, 367, 8, 23, "Print",ExpressionUUID->"4bf2e0fa-3ba0-4464-a442-50a9cc50abdf",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321399, 9380, 1360, 38, 52, InheritFromParent,ExpressionUUID->"ef82b0f8-f076-461a-bff9-66027e60bdfe",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[322762, 9420, 13271, 394, 56, InheritFromParent,ExpressionUUID->"a57de255-7d1b-4c42-b265-7c7745be17b6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336036, 9816, 749, 20, 58, InheritFromParent,ExpressionUUID->"c303681a-55e6-4cfd-8724-f0b7162d116c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336788, 9838, 40718, 1180, 118, InheritFromParent,ExpressionUUID->"29e07eb3-976c-411b-9f94-16375400abae",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[377509, 11020, 1011, 24, 104, InheritFromParent,ExpressionUUID->"262e2a6a-5401-403a-895c-4594c6210ba7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[378523, 11046, 1872, 39, 368, InheritFromParent,ExpressionUUID->"fa281744-8557-47cc-9ab2-37c4eb2955eb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[380398, 11087, 839, 21, 58, InheritFromParent,ExpressionUUID->"6233d3d5-c5d2-42cf-8bae-2b61b7138602",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381262, 11112, 456, 9, 25, "Print",ExpressionUUID->"6e61b564-aa01-4740-974f-4651cc6f1c16",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381721, 11123, 368, 8, 23, "Print",ExpressionUUID->"c293088e-c2a0-420e-93b5-979f7126af49",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382104, 11134, 677, 19, 41, InheritFromParent,ExpressionUUID->"f2a71967-f0da-4412-8bc7-02eaf59f5458",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382784, 11155, 782, 21, 58, InheritFromParent,ExpressionUUID->"195600ce-ea6b-44b0-94da-8a294f8ad95e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[383569, 11178, 825, 21, 58, InheritFromParent,ExpressionUUID->"c9d6f1f3-f340-4933-ad76-6dcdeee462a2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[384397, 11201, 24829, 737, 81, InheritFromParent,ExpressionUUID->"6ac621ba-2f0d-4b0c-9588-6ef6799b1710",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[409229, 11940, 885, 22, 81, InheritFromParent,ExpressionUUID->"a4a2657e-e1be-43c7-b9dc-37ad9b9aa9e9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[410117, 11964, 78067, 2298, 229, InheritFromParent,ExpressionUUID->"8d289f74-704d-420a-80d8-761be6d9e1ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488187, 14264, 775, 20, 58, InheritFromParent,ExpressionUUID->"869d6edf-1a19-43ae-b937-da3fc25e528e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488965, 14286, 1606, 36, 258, InheritFromParent,ExpressionUUID->"b541844c-60ee-4b27-ad80-c9abc93a8437",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[490574, 14324, 688, 19, 41, InheritFromParent,ExpressionUUID->"c7f66d35-0768-40f4-9317-e3a2600040b8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[491265, 14345, 849, 21, 58, InheritFromParent,ExpressionUUID->"3a5f6d79-e2de-4063-a5e5-c5722df33822",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[492117, 14368, 12863, 382, 56, InheritFromParent,ExpressionUUID->"83d3926f-9e0d-4aed-a1e4-0aa3b2009d92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[504983, 14752, 810, 21, 58, InheritFromParent,ExpressionUUID->"15068d50-44a9-490e-8bbe-da6f6b0658f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[505796, 14775, 681, 19, 41, InheritFromParent,ExpressionUUID->"6012b86f-c5b5-4584-bcf3-2662a484fb69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[506480, 14796, 728, 20, 35, InheritFromParent,ExpressionUUID->"216ecab2-23d3-4088-8085-e8257fb73d07",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507211, 14818, 659, 17, 35, InheritFromParent,ExpressionUUID->"6799a4f0-567b-412f-aaff-a64c38495a67",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507873, 14837, 4361, 128, 52, InheritFromParent,ExpressionUUID->"c0f00af1-c65e-46b6-bea7-af95cee96b01",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512237, 14967, 660, 17, 35, InheritFromParent,ExpressionUUID->"d7863f6d-16db-4d15-ac48-8d32128a9b54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512900, 14986, 5405, 155, 52, InheritFromParent,ExpressionUUID->"f843b089-4a70-4161-9249-f59c662f230f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[518308, 15143, 785, 21, 58, InheritFromParent,ExpressionUUID->"b68ed01c-fdb9-4a3e-bc81-7f1617a837ce",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519096, 15166, 705, 19, 41, InheritFromParent,ExpressionUUID->"55ce4beb-ae95-4d2b-b519-c5423a1e8703",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519804, 15187, 796, 21, 58, InheritFromParent,ExpressionUUID->"50f39a67-37f1-4fa0-825d-00e049d7d06e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[520603, 15210, 723, 20, 35, InheritFromParent,ExpressionUUID->"971aec87-bbbb-4f25-9de6-b7b2fd24a27c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[521329, 15232, 124875, 3681, 391, InheritFromParent,ExpressionUUID->"62b83f51-f719-4613-b1fb-27f8830506c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646207, 18915, 695, 19, 35, InheritFromParent,ExpressionUUID->"1b4223bf-973e-44e7-b3e4-441de6e8bd44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646905, 18936, 19423, 570, 113, InheritFromParent,ExpressionUUID->"09191766-a67d-4d6e-8939-b02e692a5add",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[666331, 19508, 712, 20, 35, InheritFromParent,ExpressionUUID->"2d7971dd-7798-45ef-b4a1-01ee7ece9aef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[667046, 19530, 20284, 581, 116, InheritFromParent,ExpressionUUID->"7d4f7c77-e50a-4654-9498-79cad8026f94",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[687333, 20113, 683, 19, 35, InheritFromParent,ExpressionUUID->"7d17b821-9dda-47f6-8359-8d2788625ed8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[688019, 20134, 8540, 257, 57, InheritFromParent,ExpressionUUID->"be8309ea-16d1-4f3a-b5f7-30e460260668",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[696562, 20393, 846, 21, 58, InheritFromParent,ExpressionUUID->"d78691b9-4c55-45a8-9e3f-5020642c4d25",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[697411, 20416, 9028, 273, 57, InheritFromParent,ExpressionUUID->"79cf473e-13ee-411c-ab41-e59682891b21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[706442, 20691, 689, 19, 35, InheritFromParent,ExpressionUUID->"90f3625a-e26e-4cd7-be4b-21bb01ded13f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[707134, 20712, 2254, 65, 52, InheritFromParent,ExpressionUUID->"33fd7929-7442-4545-9960-fc9669f7f8d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[709391, 20779, 8514, 257, 57, InheritFromParent,ExpressionUUID->"fb32e72e-da5f-4405-9051-33d9a7e880f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[717908, 21038, 1322, 28, 150, InheritFromParent,ExpressionUUID->"abfbf702-3626-40d4-92f1-b685bba6b9c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[719233, 21068, 913, 22, 81, InheritFromParent,ExpressionUUID->"7f38935d-b89e-4143-bd81-a1e794a3620e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[720149, 21092, 7676, 206, 136, InheritFromParent,ExpressionUUID->"d1590147-804a-4778-a7fc-214616d69f15",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[727828, 21300, 790, 21, 58, InheritFromParent,ExpressionUUID->"143af27d-2b4e-4dac-b5ca-9bc398abb8ef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[728621, 21323, 797, 21, 58, InheritFromParent,ExpressionUUID->"d4b29d21-6334-41f2-9424-aebd2553e04f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[729421, 21346, 7903, 224, 61, InheritFromParent,ExpressionUUID->"df4416cb-5f00-4fea-8468-abbac73dd16c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[737327, 21572, 7903, 224, 61, InheritFromParent,ExpressionUUID->"d760e4b1-ced1-438e-82aa-394980ee3cf8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745233, 21798, 692, 19, 35, InheritFromParent,ExpressionUUID->"173ce9ee-ae64-42e9-9e96-9d4a40dcfef3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745928, 21819, 14383, 411, 56, InheritFromParent,ExpressionUUID->"4b203467-cb2b-46ae-8b47-71c772c3440c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760314, 22232, 678, 19, 35, InheritFromParent,ExpressionUUID->"c14e5092-7614-441f-8796-30a7a64d7499",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760995, 22253, 22477, 681, 96, InheritFromParent,ExpressionUUID->"07705ec2-49a0-4811-badb-e7afacbbcc74",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[783475, 22936, 1030, 24, 104, InheritFromParent,ExpressionUUID->"4b964916-6106-46d7-9708-3ad46712d94a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]},
 "tmp387881843924"->{
  Cell[558, 20, 946, 18, 29, "Input",ExpressionUUID->"b9384e29-ebcf-4d1e-b562-f1587dbf5da2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[1507, 40, 706, 20, 67, InheritFromParent,ExpressionUUID->"655f4e1b-1a8e-4d4a-858b-59aa7082063a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[2216, 62, 1385, 33, 170, InheritFromParent,ExpressionUUID->"e42835ff-d35e-4efe-8f43-5fa8125fbe19",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[3604, 97, 688, 19, 41, InheritFromParent,ExpressionUUID->"3b809e43-d2f6-4f4a-b810-e1659f4a791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[4295, 118, 923, 22, 81, InheritFromParent,ExpressionUUID->"26686cf6-295b-456f-8440-5cecf0e696d4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5243, 144, 437, 9, 23, "Print",ExpressionUUID->"323b0b43-1933-4a4d-8d67-cc689ab3de7e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5683, 155, 709, 17, 25, "Print",ExpressionUUID->"d6c5f485-5dc5-4431-8543-843bd39d1b58",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6395, 174, 458, 9, 25, "Print",ExpressionUUID->"b5a8c692-548b-4b15-bc8e-f1606953eb03",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6856, 185, 417, 8, 25, "Print",ExpressionUUID->"ca3e3494-a5eb-42f9-bf9c-084a6575d0f5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7276, 195, 398, 8, 25, "Print",ExpressionUUID->"dce92f5f-0b7b-4832-a094-5a29b828ef4c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7677, 205, 439, 9, 23, "Print",ExpressionUUID->"afc7b575-1f7c-427f-b676-a58e99b54b66",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8119, 216, 715, 17, 25, "Print",ExpressionUUID->"23de39fb-26b9-4d84-82e3-da0a04a1115f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8837, 235, 458, 9, 25, "Print",ExpressionUUID->"574d02c4-4d57-4750-b337-f1c46ac5862c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9298, 246, 437, 9, 23, "Print",ExpressionUUID->"48521381-9713-4ce9-864f-2b453436faf0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9738, 257, 709, 17, 25, "Print",ExpressionUUID->"23024247-584c-4c96-8b6f-c721149f15c5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10450, 276, 508, 10, 45, "Print",ExpressionUUID->"5773044e-1cdd-42e1-957b-023676b56af9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10961, 288, 679, 16, 25, "Print",ExpressionUUID->"31a3b4d1-3ec0-4321-997b-18407e25a553",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[11643, 306, 763, 17, 25, "Print",ExpressionUUID->"872a2ace-a03b-45ad-b812-2627df56dad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[12409, 325, 864, 17, 25, "Print",ExpressionUUID->"1be38cd1-3cc7-44e0-bc52-6df574d1c2b9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[13276, 344, 822, 17, 25, "Print",ExpressionUUID->"7061ace8-a728-4a87-b6e8-c70ed05fdb9c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14101, 363, 840, 17, 25, "Print",ExpressionUUID->"66be857f-bca3-4910-8e8b-bb1965f6d674",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14944, 382, 439, 9, 23, "Print",ExpressionUUID->"7aa4e98b-2b90-4a24-b206-6c8dc6252de7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[15386, 393, 706, 16, 25, "Print",ExpressionUUID->"01a2dfb3-df3e-4524-923f-193f1ee8f902",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16095, 411, 484, 9, 45, "Print",ExpressionUUID->"e524aae7-d731-4da4-b993-13b51dadae3c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16582, 422, 805, 18, 25, "Print",ExpressionUUID->"62a61f68-d160-4d30-8b50-55d247c0e779",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[17390, 442, 799, 17, 25, "Print",ExpressionUUID->"2e9f0da9-6901-493b-b37a-ef1dfe1aec8a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[18192, 461, 846, 17, 25, "Print",ExpressionUUID->"fd1dd82e-8dcd-48c3-9461-abbbe51137da",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19041, 480, 759, 17, 25, "Print",ExpressionUUID->"dcf6e6b9-3fe0-4127-98be-ecea4457fed2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19803, 499, 437, 9, 23, "Print",ExpressionUUID->"92dfb0cc-4789-482e-b696-12f7352ec09d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20243, 510, 709, 17, 25, "Print",ExpressionUUID->"d1cf077f-7149-4890-96bb-cd3adae9d216",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20955, 529, 476, 9, 25, "Print",ExpressionUUID->"ea9021ff-5cfd-4155-8028-a1585c035bfd",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21434, 540, 437, 9, 23, "Print",ExpressionUUID->"4cb132fe-915a-47f8-ba42-3fb34ee0abab",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21874, 551, 727, 17, 25, "Print",ExpressionUUID->"c13bab9e-02ca-433e-aebc-f78dcdaf592d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[22604, 570, 463, 9, 25, "Print",ExpressionUUID->"4f95d5a3-7129-406e-8568-b27ba2b8b59b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23070, 581, 437, 9, 23, "Print",ExpressionUUID->"2cd8248f-5158-464d-b269-55c1932871e0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23510, 592, 708, 16, 25, "Print",ExpressionUUID->"865cb17b-7c96-4fb6-a4d7-b1d2fe214dc9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24221, 610, 447, 9, 25, "Print",ExpressionUUID->"6f09edce-f6f6-4d28-9083-cf176e6e82d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24671, 621, 769, 18, 25, "Print",ExpressionUUID->"ca7368dd-3f4a-4b30-8b15-7618f53d721e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[25443, 641, 844, 17, 25, "Print",ExpressionUUID->"4420b90e-a632-482d-b04c-c6cc5b4024c1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26290, 660, 437, 9, 23, "Print",ExpressionUUID->"0d53df74-4ea0-45c1-bab2-6617740b19f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26730, 671, 729, 17, 25, "Print",ExpressionUUID->"a3cb39a0-e8fc-4781-af32-f4418b309b89",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27462, 690, 477, 9, 25, "Print",ExpressionUUID->"5a91617f-dbe1-4aee-a2c9-f6a22f3c8c18",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27942, 701, 436, 9, 23, "Print",ExpressionUUID->"8be6937d-ed63-4de9-94fb-08ec19588479",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28381, 712, 415, 8, 25, "Print",ExpressionUUID->"5b413eff-9b52-463e-bdd0-db947ebe7c3e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28799, 722, 437, 9, 23, "Print",ExpressionUUID->"f99ae39d-53b8-448a-82ff-7b0faa0ddd7c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29239, 733, 715, 17, 25, "Print",ExpressionUUID->"41d159ee-f66b-4ec8-ba2a-989f3f1487f1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29957, 752, 507, 10, 45, "Print",ExpressionUUID->"dd938ca7-6cbf-4871-b2cd-40f5d5e82ad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30467, 764, 439, 9, 23, "Print",ExpressionUUID->"7c3d6dcd-1bc3-45ce-9428-b4fb990ce33e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30909, 775, 710, 16, 25, "Print",ExpressionUUID->"6cdaf39b-fc2d-48b3-805f-8826f49bb899",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[31622, 793, 474, 9, 25, "Print",ExpressionUUID->"65aa0dc6-fa75-4e5a-9e72-bda776caf6f2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32099, 804, 486, 9, 25, "Print",ExpressionUUID->"244f0ac0-b1fa-4b7f-828a-99eed080d3bb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32588, 815, 757, 17, 25, "Print",ExpressionUUID->"77e59c75-0569-4c5b-88f4-8a3bc242ed27",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33348, 834, 439, 9, 23, "Print",ExpressionUUID->"6b90bd70-24d1-47bc-8e49-e597a39ba247",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33790, 845, 738, 18, 25, "Print",ExpressionUUID->"04e62656-e161-4e61-bda3-7e75717e8c92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34531, 865, 460, 9, 25, "Print",ExpressionUUID->"383567e6-b4a8-4966-8ac9-c0ccaf084a44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34994, 876, 437, 9, 23, "Print",ExpressionUUID->"19fd2032-d9b2-47b8-9169-9f457881a9a8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[35434, 887, 592, 11, 65, "Print",ExpressionUUID->"336ac5be-41b1-4631-ad29-bcd5ef3f3764",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36029, 900, 437, 9, 23, "Print",ExpressionUUID->"ed21db18-371d-4c65-8d93-f560c4e43105",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36481, 912, 708, 20, 35, InheritFromParent,ExpressionUUID->"7640975b-0fe9-4643-b47c-be5b016d6f9e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37192, 934, 712, 20, 54, InheritFromParent,ExpressionUUID->"b84d46a0-8f09-43bb-bc4b-56162b9fcf69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37907, 956, 972, 23, 81, InheritFromParent,ExpressionUUID->"19e9ed3f-c481-497e-afc6-f7da2c4bafe9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[38882, 981, 799, 17, 25, "Print",ExpressionUUID->"6906580a-4558-4bbe-bf0e-7c16ba99ab3d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[39684, 1000, 7613, 266, 92, InheritFromParent,ExpressionUUID->"74aac581-908d-4aa2-b5b2-fef7cc572235",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[47300, 1268, 951, 23, 81, InheritFromParent,ExpressionUUID->"494dd010-24a9-45a0-a465-eff3b3de769d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48254, 1293, 685, 19, 41, InheritFromParent,ExpressionUUID->"d840fcaf-aaa7-4b67-8321-14f0c79c712c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48942, 1314, 818, 21, 58, InheritFromParent,ExpressionUUID->"1a6e2d40-ed52-407e-8f50-e0b9455ead24",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[49785, 1339, 892, 19, 25, "Print",ExpressionUUID->"efbc3a1e-25c8-4110-aa87-f4b2c401161a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[50680, 1360, 943, 21, 25, "Print",ExpressionUUID->"ee72a628-8b2b-4587-ad28-a3b98ad0298c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[51638, 1384, 649, 17, 35, InheritFromParent,ExpressionUUID->"2dcbb549-93f3-44bf-b839-10d5215e6a09",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[52290, 1403, 1352, 37, 52, InheritFromParent,ExpressionUUID->"7ae24dfc-66ae-4a53-8f20-5a6022436885",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[53645, 1442, 424, 8, 41, InheritFromParent,ExpressionUUID->"eba1453e-4f9a-42e2-8c3f-5e6062f326ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54072, 1452, 646, 17, 35, InheritFromParent,ExpressionUUID->"5f64a805-243d-42e5-bc87-a2782c2cdd0b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54721, 1471, 1396, 38, 52, InheritFromParent,ExpressionUUID->"60156e09-a022-4b81-9697-a3e819a5673c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[56120, 1511, 26201, 816, 93, InheritFromParent,ExpressionUUID->"8cdf4af9-b767-472b-84fc-d82a415ab18b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[82324, 2329, 1252, 27, 150, InheritFromParent,ExpressionUUID->"69e59fb4-5c2f-4c22-9474-3b397b96e83b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[83579, 2358, 1068, 24, 104, InheritFromParent,ExpressionUUID->"9d78e71d-e0fc-47ea-8b40-1f0c35936d2a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[84650, 2384, 688, 19, 41, InheritFromParent,ExpressionUUID->"a702087f-7f0a-4a29-afa9-8595374e609c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[85341, 2405, 833, 21, 58, InheritFromParent,ExpressionUUID->"d22212a8-7e21-400c-a7c4-6154d10577ea",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[86177, 2428, 970, 23, 81, InheritFromParent,ExpressionUUID->"fb602348-7013-4bc7-a060-71ecd67a7b1d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[87150, 2453, 117941, 3523, 312, InheritFromParent,ExpressionUUID->"0cd8973f-3019-433f-91e0-fb859654f7e2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[205094, 5978, 918, 23, 81, InheritFromParent,ExpressionUUID->"f2575653-814a-4991-a2de-9ce7ed722149",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[206015, 6003, 26653, 774, 118, InheritFromParent,ExpressionUUID->"1d261ece-ab42-4b33-a7cf-22ae810c6dcc",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[232671, 6779, 1035, 24, 104, InheritFromParent,ExpressionUUID->"a86af238-0e18-4d41-a788-62e409387ad1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[233709, 6805, 1124, 25, 127, InheritFromParent,ExpressionUUID->"97a46e92-275a-47a1-a901-467264d86f54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[234836, 6832, 910, 20, 25, "Print",ExpressionUUID->"9ca02f3c-a9ba-4b26-9633-0117c1b9c7a6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[235749, 6854, 1332, 36, 52, InheritFromParent,ExpressionUUID->"cb4d3995-bf8b-4ca6-9ce1-2f53df529da7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[237084, 6892, 6229, 183, 56, InheritFromParent,ExpressionUUID->"84e5208f-6d8b-4803-b36f-4d82c8bbbad6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[243316, 7077, 686, 19, 35, InheritFromParent,ExpressionUUID->"e09aef32-3cff-4a32-8413-f0cab2e0ab9f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[244005, 7098, 1279, 36, 52, InheritFromParent,ExpressionUUID->"218c7d03-6c3a-47cc-bf25-13520291791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[245287, 7136, 941, 23, 81, InheritFromParent,ExpressionUUID->"d3e25584-c3d9-4e03-89c2-44a581a6a931",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246231, 7161, 696, 20, 35, InheritFromParent,ExpressionUUID->"78f997fa-c618-4a9e-b48c-1e4fae4b04f4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246930, 7183, 910, 20, 25, "Print",ExpressionUUID->"f05579ee-6cbc-46b5-9f4f-779a59ef958f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[247843, 7205, 1203, 26, 127, InheritFromParent,ExpressionUUID->"f35e9a5b-c4dd-47e3-b2a7-9945e1d50e0e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[249049, 7233, 1169, 26, 127, InheritFromParent,ExpressionUUID->"f4b93215-c9c0-48a0-ad66-68810261018f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[250221, 7261, 930, 21, 25, "Print",ExpressionUUID->"94db25a8-ff82-49c6-9371-3b3906f4ffe5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[251154, 7284, 1333, 36, 52, InheritFromParent,ExpressionUUID->"570c9060-fb52-44a6-aa2e-389e9d5b02f6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[252490, 7322, 650, 17, 35, InheritFromParent,ExpressionUUID->"9f952f08-0179-4acb-ad53-c119682c92aa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[253143, 7341, 1319, 36, 52, InheritFromParent,ExpressionUUID->"b5bbdc2c-55b8-4870-b53d-0327b9f76fa3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[254465, 7379, 2652, 79, 49, InheritFromParent,ExpressionUUID->"96617eac-23dc-476b-9652-b1dce9217326",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257120, 7460, 722, 20, 35, InheritFromParent,ExpressionUUID->"d73d082a-4779-4c5d-9abe-ba15980c9aba",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257845, 7482, 2336, 66, 56, InheritFromParent,ExpressionUUID->"6be96410-1bf9-449b-a873-8f2892d0394d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[260184, 7550, 3631, 108, 56, InheritFromParent,ExpressionUUID->"38b4785c-5b69-4f18-ac19-480c5ae84db3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[263818, 7660, 730, 20, 35, InheritFromParent,ExpressionUUID->"0f72e7b7-7ed1-44e4-b60a-53bb0bdce2de",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[264551, 7682, 630, 17, 35, InheritFromParent,ExpressionUUID->"0982f795-e428-4d19-8d15-b8ddb256bfff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265184, 7701, 600, 15, 41, InheritFromParent,ExpressionUUID->"d7d4a64a-4e5a-4912-b9ff-f899ec1dc807",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265787, 7718, 4316, 133, 49, InheritFromParent,ExpressionUUID->"aca6ec55-9556-45e8-9c9a-845b1241b594",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270106, 7853, 629, 17, 35, InheritFromParent,ExpressionUUID->"e547d27a-2162-4ea3-ad37-2ef09e5f4c86",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270738, 7872, 596, 15, 41, InheritFromParent,ExpressionUUID->"ed922378-bd8c-4ceb-b516-8d36678b0907",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[271337, 7889, 6691, 203, 49, InheritFromParent,ExpressionUUID->"db353d9f-513f-4f9b-a0c8-aafde492e828",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278031, 8094, 635, 17, 35, InheritFromParent,ExpressionUUID->"7719cccd-757a-4763-a80f-ac47a8e9174d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278669, 8113, 1281, 36, 52, InheritFromParent,ExpressionUUID->"4d414f63-f7a4-495b-8cc6-d7055f83ad50",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[279953, 8151, 3340, 99, 52, InheritFromParent,ExpressionUUID->"d474b63f-5321-4855-b79e-084a20afd87e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[283296, 8252, 858, 22, 81, InheritFromParent,ExpressionUUID->"3dee2795-4d05-4efe-a2f8-6bccf06b2d21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[284157, 8276, 7234, 212, 56, InheritFromParent,ExpressionUUID->"f1aa6cd9-3914-4afc-8549-0e0268c04613",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[291394, 8490, 13120, 388, 56, InheritFromParent,ExpressionUUID->"f8d09264-8ab1-46dd-887b-e5ca058ee75c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[304517, 8880, 743, 20, 58, InheritFromParent,ExpressionUUID->"0c0bb409-a2f6-4fee-b8c8-3b461b842efa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[305263, 8902, 1279, 36, 52, InheritFromParent,ExpressionUUID->"f4f145a4-47cd-4c20-a77d-fb8afa3c8a77",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[306545, 8940, 13331, 395, 56, InheritFromParent,ExpressionUUID->"24fe1dd9-9f96-4acd-8ea6-bc2e71ca3f08",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[319879, 9337, 654, 17, 35, InheritFromParent,ExpressionUUID->"3ba01e8b-167b-479a-81ec-f428c62f5f81",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[320558, 9358, 456, 9, 25, "Print",ExpressionUUID->"b636a247-8891-49df-a008-20813b773799",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321017, 9369, 367, 8, 23, "Print",ExpressionUUID->"4bf2e0fa-3ba0-4464-a442-50a9cc50abdf",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321399, 9380, 1360, 38, 52, InheritFromParent,ExpressionUUID->"ef82b0f8-f076-461a-bff9-66027e60bdfe",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[322762, 9420, 13271, 394, 56, InheritFromParent,ExpressionUUID->"a57de255-7d1b-4c42-b265-7c7745be17b6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336036, 9816, 749, 20, 58, InheritFromParent,ExpressionUUID->"c303681a-55e6-4cfd-8724-f0b7162d116c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336788, 9838, 40718, 1180, 118, InheritFromParent,ExpressionUUID->"29e07eb3-976c-411b-9f94-16375400abae",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[377509, 11020, 1011, 24, 104, InheritFromParent,ExpressionUUID->"262e2a6a-5401-403a-895c-4594c6210ba7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[378523, 11046, 1872, 39, 368, InheritFromParent,ExpressionUUID->"fa281744-8557-47cc-9ab2-37c4eb2955eb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[380398, 11087, 839, 21, 58, InheritFromParent,ExpressionUUID->"6233d3d5-c5d2-42cf-8bae-2b61b7138602",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381262, 11112, 456, 9, 25, "Print",ExpressionUUID->"6e61b564-aa01-4740-974f-4651cc6f1c16",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381721, 11123, 368, 8, 23, "Print",ExpressionUUID->"c293088e-c2a0-420e-93b5-979f7126af49",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382104, 11134, 677, 19, 41, InheritFromParent,ExpressionUUID->"f2a71967-f0da-4412-8bc7-02eaf59f5458",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382784, 11155, 782, 21, 58, InheritFromParent,ExpressionUUID->"195600ce-ea6b-44b0-94da-8a294f8ad95e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[383569, 11178, 825, 21, 58, InheritFromParent,ExpressionUUID->"c9d6f1f3-f340-4933-ad76-6dcdeee462a2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[384397, 11201, 24829, 737, 81, InheritFromParent,ExpressionUUID->"6ac621ba-2f0d-4b0c-9588-6ef6799b1710",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[409229, 11940, 885, 22, 81, InheritFromParent,ExpressionUUID->"a4a2657e-e1be-43c7-b9dc-37ad9b9aa9e9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[410117, 11964, 78067, 2298, 229, InheritFromParent,ExpressionUUID->"8d289f74-704d-420a-80d8-761be6d9e1ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488187, 14264, 775, 20, 58, InheritFromParent,ExpressionUUID->"869d6edf-1a19-43ae-b937-da3fc25e528e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488965, 14286, 1606, 36, 258, InheritFromParent,ExpressionUUID->"b541844c-60ee-4b27-ad80-c9abc93a8437",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[490574, 14324, 688, 19, 41, InheritFromParent,ExpressionUUID->"c7f66d35-0768-40f4-9317-e3a2600040b8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[491265, 14345, 849, 21, 58, InheritFromParent,ExpressionUUID->"3a5f6d79-e2de-4063-a5e5-c5722df33822",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[492117, 14368, 12863, 382, 56, InheritFromParent,ExpressionUUID->"83d3926f-9e0d-4aed-a1e4-0aa3b2009d92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[504983, 14752, 810, 21, 58, InheritFromParent,ExpressionUUID->"15068d50-44a9-490e-8bbe-da6f6b0658f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[505796, 14775, 681, 19, 41, InheritFromParent,ExpressionUUID->"6012b86f-c5b5-4584-bcf3-2662a484fb69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[506480, 14796, 728, 20, 35, InheritFromParent,ExpressionUUID->"216ecab2-23d3-4088-8085-e8257fb73d07",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507211, 14818, 659, 17, 35, InheritFromParent,ExpressionUUID->"6799a4f0-567b-412f-aaff-a64c38495a67",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507873, 14837, 4361, 128, 52, InheritFromParent,ExpressionUUID->"c0f00af1-c65e-46b6-bea7-af95cee96b01",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512237, 14967, 660, 17, 35, InheritFromParent,ExpressionUUID->"d7863f6d-16db-4d15-ac48-8d32128a9b54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512900, 14986, 5405, 155, 52, InheritFromParent,ExpressionUUID->"f843b089-4a70-4161-9249-f59c662f230f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[518308, 15143, 785, 21, 58, InheritFromParent,ExpressionUUID->"b68ed01c-fdb9-4a3e-bc81-7f1617a837ce",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519096, 15166, 705, 19, 41, InheritFromParent,ExpressionUUID->"55ce4beb-ae95-4d2b-b519-c5423a1e8703",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519804, 15187, 796, 21, 58, InheritFromParent,ExpressionUUID->"50f39a67-37f1-4fa0-825d-00e049d7d06e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[520603, 15210, 723, 20, 35, InheritFromParent,ExpressionUUID->"971aec87-bbbb-4f25-9de6-b7b2fd24a27c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[521329, 15232, 124875, 3681, 391, InheritFromParent,ExpressionUUID->"62b83f51-f719-4613-b1fb-27f8830506c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646207, 18915, 695, 19, 35, InheritFromParent,ExpressionUUID->"1b4223bf-973e-44e7-b3e4-441de6e8bd44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646905, 18936, 19423, 570, 113, InheritFromParent,ExpressionUUID->"09191766-a67d-4d6e-8939-b02e692a5add",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[666331, 19508, 712, 20, 35, InheritFromParent,ExpressionUUID->"2d7971dd-7798-45ef-b4a1-01ee7ece9aef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[667046, 19530, 20284, 581, 116, InheritFromParent,ExpressionUUID->"7d4f7c77-e50a-4654-9498-79cad8026f94",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[687333, 20113, 683, 19, 35, InheritFromParent,ExpressionUUID->"7d17b821-9dda-47f6-8359-8d2788625ed8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[688019, 20134, 8540, 257, 57, InheritFromParent,ExpressionUUID->"be8309ea-16d1-4f3a-b5f7-30e460260668",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[696562, 20393, 846, 21, 58, InheritFromParent,ExpressionUUID->"d78691b9-4c55-45a8-9e3f-5020642c4d25",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[697411, 20416, 9028, 273, 57, InheritFromParent,ExpressionUUID->"79cf473e-13ee-411c-ab41-e59682891b21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[706442, 20691, 689, 19, 35, InheritFromParent,ExpressionUUID->"90f3625a-e26e-4cd7-be4b-21bb01ded13f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[707134, 20712, 2254, 65, 52, InheritFromParent,ExpressionUUID->"33fd7929-7442-4545-9960-fc9669f7f8d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[709391, 20779, 8514, 257, 57, InheritFromParent,ExpressionUUID->"fb32e72e-da5f-4405-9051-33d9a7e880f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[717908, 21038, 1322, 28, 150, InheritFromParent,ExpressionUUID->"abfbf702-3626-40d4-92f1-b685bba6b9c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[719233, 21068, 913, 22, 81, InheritFromParent,ExpressionUUID->"7f38935d-b89e-4143-bd81-a1e794a3620e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[720149, 21092, 7676, 206, 136, InheritFromParent,ExpressionUUID->"d1590147-804a-4778-a7fc-214616d69f15",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[727828, 21300, 790, 21, 58, InheritFromParent,ExpressionUUID->"143af27d-2b4e-4dac-b5ca-9bc398abb8ef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[728621, 21323, 797, 21, 58, InheritFromParent,ExpressionUUID->"d4b29d21-6334-41f2-9424-aebd2553e04f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[729421, 21346, 7903, 224, 61, InheritFromParent,ExpressionUUID->"df4416cb-5f00-4fea-8468-abbac73dd16c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[737327, 21572, 7903, 224, 61, InheritFromParent,ExpressionUUID->"d760e4b1-ced1-438e-82aa-394980ee3cf8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745233, 21798, 692, 19, 35, InheritFromParent,ExpressionUUID->"173ce9ee-ae64-42e9-9e96-9d4a40dcfef3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745928, 21819, 14383, 411, 56, InheritFromParent,ExpressionUUID->"4b203467-cb2b-46ae-8b47-71c772c3440c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760314, 22232, 678, 19, 35, InheritFromParent,ExpressionUUID->"c14e5092-7614-441f-8796-30a7a64d7499",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760995, 22253, 22477, 681, 96, InheritFromParent,ExpressionUUID->"07705ec2-49a0-4811-badb-e7afacbbcc74",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[783475, 22936, 1030, 24, 104, InheritFromParent,ExpressionUUID->"4b964916-6106-46d7-9708-3ad46712d94a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]},
 "tmp388038648070"->{
  Cell[558, 20, 946, 18, 29, "Input",ExpressionUUID->"b9384e29-ebcf-4d1e-b562-f1587dbf5da2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[1507, 40, 706, 20, 67, InheritFromParent,ExpressionUUID->"655f4e1b-1a8e-4d4a-858b-59aa7082063a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[2216, 62, 1385, 33, 170, InheritFromParent,ExpressionUUID->"e42835ff-d35e-4efe-8f43-5fa8125fbe19",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[3604, 97, 688, 19, 41, InheritFromParent,ExpressionUUID->"3b809e43-d2f6-4f4a-b810-e1659f4a791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[4295, 118, 923, 22, 81, InheritFromParent,ExpressionUUID->"26686cf6-295b-456f-8440-5cecf0e696d4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5243, 144, 437, 9, 23, "Print",ExpressionUUID->"323b0b43-1933-4a4d-8d67-cc689ab3de7e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5683, 155, 709, 17, 25, "Print",ExpressionUUID->"d6c5f485-5dc5-4431-8543-843bd39d1b58",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6395, 174, 458, 9, 25, "Print",ExpressionUUID->"b5a8c692-548b-4b15-bc8e-f1606953eb03",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6856, 185, 417, 8, 25, "Print",ExpressionUUID->"ca3e3494-a5eb-42f9-bf9c-084a6575d0f5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7276, 195, 398, 8, 25, "Print",ExpressionUUID->"dce92f5f-0b7b-4832-a094-5a29b828ef4c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7677, 205, 439, 9, 23, "Print",ExpressionUUID->"afc7b575-1f7c-427f-b676-a58e99b54b66",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8119, 216, 715, 17, 25, "Print",ExpressionUUID->"23de39fb-26b9-4d84-82e3-da0a04a1115f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8837, 235, 458, 9, 25, "Print",ExpressionUUID->"574d02c4-4d57-4750-b337-f1c46ac5862c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9298, 246, 437, 9, 23, "Print",ExpressionUUID->"48521381-9713-4ce9-864f-2b453436faf0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9738, 257, 709, 17, 25, "Print",ExpressionUUID->"23024247-584c-4c96-8b6f-c721149f15c5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10450, 276, 508, 10, 45, "Print",ExpressionUUID->"5773044e-1cdd-42e1-957b-023676b56af9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10961, 288, 679, 16, 25, "Print",ExpressionUUID->"31a3b4d1-3ec0-4321-997b-18407e25a553",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[11643, 306, 763, 17, 25, "Print",ExpressionUUID->"872a2ace-a03b-45ad-b812-2627df56dad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[12409, 325, 864, 17, 25, "Print",ExpressionUUID->"1be38cd1-3cc7-44e0-bc52-6df574d1c2b9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[13276, 344, 822, 17, 25, "Print",ExpressionUUID->"7061ace8-a728-4a87-b6e8-c70ed05fdb9c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14101, 363, 840, 17, 25, "Print",ExpressionUUID->"66be857f-bca3-4910-8e8b-bb1965f6d674",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14944, 382, 439, 9, 23, "Print",ExpressionUUID->"7aa4e98b-2b90-4a24-b206-6c8dc6252de7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[15386, 393, 706, 16, 25, "Print",ExpressionUUID->"01a2dfb3-df3e-4524-923f-193f1ee8f902",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16095, 411, 484, 9, 45, "Print",ExpressionUUID->"e524aae7-d731-4da4-b993-13b51dadae3c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16582, 422, 805, 18, 25, "Print",ExpressionUUID->"62a61f68-d160-4d30-8b50-55d247c0e779",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[17390, 442, 799, 17, 25, "Print",ExpressionUUID->"2e9f0da9-6901-493b-b37a-ef1dfe1aec8a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[18192, 461, 846, 17, 25, "Print",ExpressionUUID->"fd1dd82e-8dcd-48c3-9461-abbbe51137da",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19041, 480, 759, 17, 25, "Print",ExpressionUUID->"dcf6e6b9-3fe0-4127-98be-ecea4457fed2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19803, 499, 437, 9, 23, "Print",ExpressionUUID->"92dfb0cc-4789-482e-b696-12f7352ec09d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20243, 510, 709, 17, 25, "Print",ExpressionUUID->"d1cf077f-7149-4890-96bb-cd3adae9d216",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20955, 529, 476, 9, 25, "Print",ExpressionUUID->"ea9021ff-5cfd-4155-8028-a1585c035bfd",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21434, 540, 437, 9, 23, "Print",ExpressionUUID->"4cb132fe-915a-47f8-ba42-3fb34ee0abab",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21874, 551, 727, 17, 25, "Print",ExpressionUUID->"c13bab9e-02ca-433e-aebc-f78dcdaf592d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[22604, 570, 463, 9, 25, "Print",ExpressionUUID->"4f95d5a3-7129-406e-8568-b27ba2b8b59b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23070, 581, 437, 9, 23, "Print",ExpressionUUID->"2cd8248f-5158-464d-b269-55c1932871e0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23510, 592, 708, 16, 25, "Print",ExpressionUUID->"865cb17b-7c96-4fb6-a4d7-b1d2fe214dc9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24221, 610, 447, 9, 25, "Print",ExpressionUUID->"6f09edce-f6f6-4d28-9083-cf176e6e82d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24671, 621, 769, 18, 25, "Print",ExpressionUUID->"ca7368dd-3f4a-4b30-8b15-7618f53d721e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[25443, 641, 844, 17, 25, "Print",ExpressionUUID->"4420b90e-a632-482d-b04c-c6cc5b4024c1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26290, 660, 437, 9, 23, "Print",ExpressionUUID->"0d53df74-4ea0-45c1-bab2-6617740b19f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26730, 671, 729, 17, 25, "Print",ExpressionUUID->"a3cb39a0-e8fc-4781-af32-f4418b309b89",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27462, 690, 477, 9, 25, "Print",ExpressionUUID->"5a91617f-dbe1-4aee-a2c9-f6a22f3c8c18",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27942, 701, 436, 9, 23, "Print",ExpressionUUID->"8be6937d-ed63-4de9-94fb-08ec19588479",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28381, 712, 415, 8, 25, "Print",ExpressionUUID->"5b413eff-9b52-463e-bdd0-db947ebe7c3e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28799, 722, 437, 9, 23, "Print",ExpressionUUID->"f99ae39d-53b8-448a-82ff-7b0faa0ddd7c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29239, 733, 715, 17, 25, "Print",ExpressionUUID->"41d159ee-f66b-4ec8-ba2a-989f3f1487f1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29957, 752, 507, 10, 45, "Print",ExpressionUUID->"dd938ca7-6cbf-4871-b2cd-40f5d5e82ad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30467, 764, 439, 9, 23, "Print",ExpressionUUID->"7c3d6dcd-1bc3-45ce-9428-b4fb990ce33e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30909, 775, 710, 16, 25, "Print",ExpressionUUID->"6cdaf39b-fc2d-48b3-805f-8826f49bb899",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[31622, 793, 474, 9, 25, "Print",ExpressionUUID->"65aa0dc6-fa75-4e5a-9e72-bda776caf6f2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32099, 804, 486, 9, 25, "Print",ExpressionUUID->"244f0ac0-b1fa-4b7f-828a-99eed080d3bb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32588, 815, 757, 17, 25, "Print",ExpressionUUID->"77e59c75-0569-4c5b-88f4-8a3bc242ed27",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33348, 834, 439, 9, 23, "Print",ExpressionUUID->"6b90bd70-24d1-47bc-8e49-e597a39ba247",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33790, 845, 738, 18, 25, "Print",ExpressionUUID->"04e62656-e161-4e61-bda3-7e75717e8c92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34531, 865, 460, 9, 25, "Print",ExpressionUUID->"383567e6-b4a8-4966-8ac9-c0ccaf084a44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34994, 876, 437, 9, 23, "Print",ExpressionUUID->"19fd2032-d9b2-47b8-9169-9f457881a9a8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[35434, 887, 592, 11, 65, "Print",ExpressionUUID->"336ac5be-41b1-4631-ad29-bcd5ef3f3764",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36029, 900, 437, 9, 23, "Print",ExpressionUUID->"ed21db18-371d-4c65-8d93-f560c4e43105",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36481, 912, 708, 20, 35, InheritFromParent,ExpressionUUID->"7640975b-0fe9-4643-b47c-be5b016d6f9e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37192, 934, 712, 20, 54, InheritFromParent,ExpressionUUID->"b84d46a0-8f09-43bb-bc4b-56162b9fcf69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37907, 956, 972, 23, 81, InheritFromParent,ExpressionUUID->"19e9ed3f-c481-497e-afc6-f7da2c4bafe9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[38882, 981, 799, 17, 25, "Print",ExpressionUUID->"6906580a-4558-4bbe-bf0e-7c16ba99ab3d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[39684, 1000, 7613, 266, 92, InheritFromParent,ExpressionUUID->"74aac581-908d-4aa2-b5b2-fef7cc572235",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[47300, 1268, 951, 23, 81, InheritFromParent,ExpressionUUID->"494dd010-24a9-45a0-a465-eff3b3de769d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48254, 1293, 685, 19, 41, InheritFromParent,ExpressionUUID->"d840fcaf-aaa7-4b67-8321-14f0c79c712c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48942, 1314, 818, 21, 58, InheritFromParent,ExpressionUUID->"1a6e2d40-ed52-407e-8f50-e0b9455ead24",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[49785, 1339, 892, 19, 25, "Print",ExpressionUUID->"efbc3a1e-25c8-4110-aa87-f4b2c401161a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[50680, 1360, 943, 21, 25, "Print",ExpressionUUID->"ee72a628-8b2b-4587-ad28-a3b98ad0298c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[51638, 1384, 649, 17, 35, InheritFromParent,ExpressionUUID->"2dcbb549-93f3-44bf-b839-10d5215e6a09",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[52290, 1403, 1352, 37, 52, InheritFromParent,ExpressionUUID->"7ae24dfc-66ae-4a53-8f20-5a6022436885",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[53645, 1442, 424, 8, 41, InheritFromParent,ExpressionUUID->"eba1453e-4f9a-42e2-8c3f-5e6062f326ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54072, 1452, 646, 17, 35, InheritFromParent,ExpressionUUID->"5f64a805-243d-42e5-bc87-a2782c2cdd0b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54721, 1471, 1396, 38, 52, InheritFromParent,ExpressionUUID->"60156e09-a022-4b81-9697-a3e819a5673c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[56120, 1511, 26201, 816, 93, InheritFromParent,ExpressionUUID->"8cdf4af9-b767-472b-84fc-d82a415ab18b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[82324, 2329, 1252, 27, 150, InheritFromParent,ExpressionUUID->"69e59fb4-5c2f-4c22-9474-3b397b96e83b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[83579, 2358, 1068, 24, 104, InheritFromParent,ExpressionUUID->"9d78e71d-e0fc-47ea-8b40-1f0c35936d2a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[84650, 2384, 688, 19, 41, InheritFromParent,ExpressionUUID->"a702087f-7f0a-4a29-afa9-8595374e609c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[85341, 2405, 833, 21, 58, InheritFromParent,ExpressionUUID->"d22212a8-7e21-400c-a7c4-6154d10577ea",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[86177, 2428, 970, 23, 81, InheritFromParent,ExpressionUUID->"fb602348-7013-4bc7-a060-71ecd67a7b1d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[87150, 2453, 117941, 3523, 312, InheritFromParent,ExpressionUUID->"0cd8973f-3019-433f-91e0-fb859654f7e2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[205094, 5978, 918, 23, 81, InheritFromParent,ExpressionUUID->"f2575653-814a-4991-a2de-9ce7ed722149",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[206015, 6003, 26653, 774, 118, InheritFromParent,ExpressionUUID->"1d261ece-ab42-4b33-a7cf-22ae810c6dcc",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[232671, 6779, 1035, 24, 104, InheritFromParent,ExpressionUUID->"a86af238-0e18-4d41-a788-62e409387ad1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[233709, 6805, 1124, 25, 127, InheritFromParent,ExpressionUUID->"97a46e92-275a-47a1-a901-467264d86f54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[234836, 6832, 910, 20, 25, "Print",ExpressionUUID->"9ca02f3c-a9ba-4b26-9633-0117c1b9c7a6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[235749, 6854, 1332, 36, 52, InheritFromParent,ExpressionUUID->"cb4d3995-bf8b-4ca6-9ce1-2f53df529da7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[237084, 6892, 6229, 183, 56, InheritFromParent,ExpressionUUID->"84e5208f-6d8b-4803-b36f-4d82c8bbbad6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[243316, 7077, 686, 19, 35, InheritFromParent,ExpressionUUID->"e09aef32-3cff-4a32-8413-f0cab2e0ab9f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[244005, 7098, 1279, 36, 52, InheritFromParent,ExpressionUUID->"218c7d03-6c3a-47cc-bf25-13520291791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[245287, 7136, 941, 23, 81, InheritFromParent,ExpressionUUID->"d3e25584-c3d9-4e03-89c2-44a581a6a931",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246231, 7161, 696, 20, 35, InheritFromParent,ExpressionUUID->"78f997fa-c618-4a9e-b48c-1e4fae4b04f4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246930, 7183, 910, 20, 25, "Print",ExpressionUUID->"f05579ee-6cbc-46b5-9f4f-779a59ef958f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[247843, 7205, 1203, 26, 127, InheritFromParent,ExpressionUUID->"f35e9a5b-c4dd-47e3-b2a7-9945e1d50e0e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[249049, 7233, 1169, 26, 127, InheritFromParent,ExpressionUUID->"f4b93215-c9c0-48a0-ad66-68810261018f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[250221, 7261, 930, 21, 25, "Print",ExpressionUUID->"94db25a8-ff82-49c6-9371-3b3906f4ffe5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[251154, 7284, 1333, 36, 52, InheritFromParent,ExpressionUUID->"570c9060-fb52-44a6-aa2e-389e9d5b02f6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[252490, 7322, 650, 17, 35, InheritFromParent,ExpressionUUID->"9f952f08-0179-4acb-ad53-c119682c92aa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[253143, 7341, 1319, 36, 52, InheritFromParent,ExpressionUUID->"b5bbdc2c-55b8-4870-b53d-0327b9f76fa3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[254465, 7379, 2652, 79, 49, InheritFromParent,ExpressionUUID->"96617eac-23dc-476b-9652-b1dce9217326",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257120, 7460, 722, 20, 35, InheritFromParent,ExpressionUUID->"d73d082a-4779-4c5d-9abe-ba15980c9aba",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257845, 7482, 2336, 66, 56, InheritFromParent,ExpressionUUID->"6be96410-1bf9-449b-a873-8f2892d0394d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[260184, 7550, 3631, 108, 56, InheritFromParent,ExpressionUUID->"38b4785c-5b69-4f18-ac19-480c5ae84db3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[263818, 7660, 730, 20, 35, InheritFromParent,ExpressionUUID->"0f72e7b7-7ed1-44e4-b60a-53bb0bdce2de",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[264551, 7682, 630, 17, 35, InheritFromParent,ExpressionUUID->"0982f795-e428-4d19-8d15-b8ddb256bfff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265184, 7701, 600, 15, 41, InheritFromParent,ExpressionUUID->"d7d4a64a-4e5a-4912-b9ff-f899ec1dc807",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265787, 7718, 4316, 133, 49, InheritFromParent,ExpressionUUID->"aca6ec55-9556-45e8-9c9a-845b1241b594",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270106, 7853, 629, 17, 35, InheritFromParent,ExpressionUUID->"e547d27a-2162-4ea3-ad37-2ef09e5f4c86",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270738, 7872, 596, 15, 41, InheritFromParent,ExpressionUUID->"ed922378-bd8c-4ceb-b516-8d36678b0907",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[271337, 7889, 6691, 203, 49, InheritFromParent,ExpressionUUID->"db353d9f-513f-4f9b-a0c8-aafde492e828",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278031, 8094, 635, 17, 35, InheritFromParent,ExpressionUUID->"7719cccd-757a-4763-a80f-ac47a8e9174d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278669, 8113, 1281, 36, 52, InheritFromParent,ExpressionUUID->"4d414f63-f7a4-495b-8cc6-d7055f83ad50",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[279953, 8151, 3340, 99, 52, InheritFromParent,ExpressionUUID->"d474b63f-5321-4855-b79e-084a20afd87e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[283296, 8252, 858, 22, 81, InheritFromParent,ExpressionUUID->"3dee2795-4d05-4efe-a2f8-6bccf06b2d21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[284157, 8276, 7234, 212, 56, InheritFromParent,ExpressionUUID->"f1aa6cd9-3914-4afc-8549-0e0268c04613",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[291394, 8490, 13120, 388, 56, InheritFromParent,ExpressionUUID->"f8d09264-8ab1-46dd-887b-e5ca058ee75c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[304517, 8880, 743, 20, 58, InheritFromParent,ExpressionUUID->"0c0bb409-a2f6-4fee-b8c8-3b461b842efa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[305263, 8902, 1279, 36, 52, InheritFromParent,ExpressionUUID->"f4f145a4-47cd-4c20-a77d-fb8afa3c8a77",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[306545, 8940, 13331, 395, 56, InheritFromParent,ExpressionUUID->"24fe1dd9-9f96-4acd-8ea6-bc2e71ca3f08",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[319879, 9337, 654, 17, 35, InheritFromParent,ExpressionUUID->"3ba01e8b-167b-479a-81ec-f428c62f5f81",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[320558, 9358, 456, 9, 25, "Print",ExpressionUUID->"b636a247-8891-49df-a008-20813b773799",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321017, 9369, 367, 8, 23, "Print",ExpressionUUID->"4bf2e0fa-3ba0-4464-a442-50a9cc50abdf",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321399, 9380, 1360, 38, 52, InheritFromParent,ExpressionUUID->"ef82b0f8-f076-461a-bff9-66027e60bdfe",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[322762, 9420, 13271, 394, 56, InheritFromParent,ExpressionUUID->"a57de255-7d1b-4c42-b265-7c7745be17b6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336036, 9816, 749, 20, 58, InheritFromParent,ExpressionUUID->"c303681a-55e6-4cfd-8724-f0b7162d116c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336788, 9838, 40718, 1180, 118, InheritFromParent,ExpressionUUID->"29e07eb3-976c-411b-9f94-16375400abae",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[377509, 11020, 1011, 24, 104, InheritFromParent,ExpressionUUID->"262e2a6a-5401-403a-895c-4594c6210ba7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[378523, 11046, 1872, 39, 368, InheritFromParent,ExpressionUUID->"fa281744-8557-47cc-9ab2-37c4eb2955eb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[380398, 11087, 839, 21, 58, InheritFromParent,ExpressionUUID->"6233d3d5-c5d2-42cf-8bae-2b61b7138602",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381262, 11112, 456, 9, 25, "Print",ExpressionUUID->"6e61b564-aa01-4740-974f-4651cc6f1c16",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381721, 11123, 368, 8, 23, "Print",ExpressionUUID->"c293088e-c2a0-420e-93b5-979f7126af49",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382104, 11134, 677, 19, 41, InheritFromParent,ExpressionUUID->"f2a71967-f0da-4412-8bc7-02eaf59f5458",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382784, 11155, 782, 21, 58, InheritFromParent,ExpressionUUID->"195600ce-ea6b-44b0-94da-8a294f8ad95e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[383569, 11178, 825, 21, 58, InheritFromParent,ExpressionUUID->"c9d6f1f3-f340-4933-ad76-6dcdeee462a2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[384397, 11201, 24829, 737, 81, InheritFromParent,ExpressionUUID->"6ac621ba-2f0d-4b0c-9588-6ef6799b1710",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[409229, 11940, 885, 22, 81, InheritFromParent,ExpressionUUID->"a4a2657e-e1be-43c7-b9dc-37ad9b9aa9e9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[410117, 11964, 78067, 2298, 229, InheritFromParent,ExpressionUUID->"8d289f74-704d-420a-80d8-761be6d9e1ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488187, 14264, 775, 20, 58, InheritFromParent,ExpressionUUID->"869d6edf-1a19-43ae-b937-da3fc25e528e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488965, 14286, 1606, 36, 258, InheritFromParent,ExpressionUUID->"b541844c-60ee-4b27-ad80-c9abc93a8437",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[490574, 14324, 688, 19, 41, InheritFromParent,ExpressionUUID->"c7f66d35-0768-40f4-9317-e3a2600040b8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[491265, 14345, 849, 21, 58, InheritFromParent,ExpressionUUID->"3a5f6d79-e2de-4063-a5e5-c5722df33822",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[492117, 14368, 12863, 382, 56, InheritFromParent,ExpressionUUID->"83d3926f-9e0d-4aed-a1e4-0aa3b2009d92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[504983, 14752, 810, 21, 58, InheritFromParent,ExpressionUUID->"15068d50-44a9-490e-8bbe-da6f6b0658f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[505796, 14775, 681, 19, 41, InheritFromParent,ExpressionUUID->"6012b86f-c5b5-4584-bcf3-2662a484fb69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[506480, 14796, 728, 20, 35, InheritFromParent,ExpressionUUID->"216ecab2-23d3-4088-8085-e8257fb73d07",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507211, 14818, 659, 17, 35, InheritFromParent,ExpressionUUID->"6799a4f0-567b-412f-aaff-a64c38495a67",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507873, 14837, 4361, 128, 52, InheritFromParent,ExpressionUUID->"c0f00af1-c65e-46b6-bea7-af95cee96b01",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512237, 14967, 660, 17, 35, InheritFromParent,ExpressionUUID->"d7863f6d-16db-4d15-ac48-8d32128a9b54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512900, 14986, 5405, 155, 52, InheritFromParent,ExpressionUUID->"f843b089-4a70-4161-9249-f59c662f230f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[518308, 15143, 785, 21, 58, InheritFromParent,ExpressionUUID->"b68ed01c-fdb9-4a3e-bc81-7f1617a837ce",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519096, 15166, 705, 19, 41, InheritFromParent,ExpressionUUID->"55ce4beb-ae95-4d2b-b519-c5423a1e8703",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519804, 15187, 796, 21, 58, InheritFromParent,ExpressionUUID->"50f39a67-37f1-4fa0-825d-00e049d7d06e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[520603, 15210, 723, 20, 35, InheritFromParent,ExpressionUUID->"971aec87-bbbb-4f25-9de6-b7b2fd24a27c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[521329, 15232, 124875, 3681, 391, InheritFromParent,ExpressionUUID->"62b83f51-f719-4613-b1fb-27f8830506c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646207, 18915, 695, 19, 35, InheritFromParent,ExpressionUUID->"1b4223bf-973e-44e7-b3e4-441de6e8bd44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646905, 18936, 19423, 570, 113, InheritFromParent,ExpressionUUID->"09191766-a67d-4d6e-8939-b02e692a5add",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[666331, 19508, 712, 20, 35, InheritFromParent,ExpressionUUID->"2d7971dd-7798-45ef-b4a1-01ee7ece9aef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[667046, 19530, 20284, 581, 116, InheritFromParent,ExpressionUUID->"7d4f7c77-e50a-4654-9498-79cad8026f94",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[687333, 20113, 683, 19, 35, InheritFromParent,ExpressionUUID->"7d17b821-9dda-47f6-8359-8d2788625ed8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[688019, 20134, 8540, 257, 57, InheritFromParent,ExpressionUUID->"be8309ea-16d1-4f3a-b5f7-30e460260668",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[696562, 20393, 846, 21, 58, InheritFromParent,ExpressionUUID->"d78691b9-4c55-45a8-9e3f-5020642c4d25",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[697411, 20416, 9028, 273, 57, InheritFromParent,ExpressionUUID->"79cf473e-13ee-411c-ab41-e59682891b21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[706442, 20691, 689, 19, 35, InheritFromParent,ExpressionUUID->"90f3625a-e26e-4cd7-be4b-21bb01ded13f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[707134, 20712, 2254, 65, 52, InheritFromParent,ExpressionUUID->"33fd7929-7442-4545-9960-fc9669f7f8d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[709391, 20779, 8514, 257, 57, InheritFromParent,ExpressionUUID->"fb32e72e-da5f-4405-9051-33d9a7e880f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[717908, 21038, 1322, 28, 150, InheritFromParent,ExpressionUUID->"abfbf702-3626-40d4-92f1-b685bba6b9c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[719233, 21068, 913, 22, 81, InheritFromParent,ExpressionUUID->"7f38935d-b89e-4143-bd81-a1e794a3620e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[720149, 21092, 7676, 206, 136, InheritFromParent,ExpressionUUID->"d1590147-804a-4778-a7fc-214616d69f15",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[727828, 21300, 790, 21, 58, InheritFromParent,ExpressionUUID->"143af27d-2b4e-4dac-b5ca-9bc398abb8ef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[728621, 21323, 797, 21, 58, InheritFromParent,ExpressionUUID->"d4b29d21-6334-41f2-9424-aebd2553e04f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[729421, 21346, 7903, 224, 61, InheritFromParent,ExpressionUUID->"df4416cb-5f00-4fea-8468-abbac73dd16c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[737327, 21572, 7903, 224, 61, InheritFromParent,ExpressionUUID->"d760e4b1-ced1-438e-82aa-394980ee3cf8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745233, 21798, 692, 19, 35, InheritFromParent,ExpressionUUID->"173ce9ee-ae64-42e9-9e96-9d4a40dcfef3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745928, 21819, 14383, 411, 56, InheritFromParent,ExpressionUUID->"4b203467-cb2b-46ae-8b47-71c772c3440c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760314, 22232, 678, 19, 35, InheritFromParent,ExpressionUUID->"c14e5092-7614-441f-8796-30a7a64d7499",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760995, 22253, 22477, 681, 96, InheritFromParent,ExpressionUUID->"07705ec2-49a0-4811-badb-e7afacbbcc74",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[783475, 22936, 1030, 24, 104, InheritFromParent,ExpressionUUID->"4b964916-6106-46d7-9708-3ad46712d94a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]},
 "tmp388039495531"->{
  Cell[558, 20, 946, 18, 29, "Input",ExpressionUUID->"b9384e29-ebcf-4d1e-b562-f1587dbf5da2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[1507, 40, 706, 20, 67, InheritFromParent,ExpressionUUID->"655f4e1b-1a8e-4d4a-858b-59aa7082063a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[2216, 62, 1385, 33, 170, InheritFromParent,ExpressionUUID->"e42835ff-d35e-4efe-8f43-5fa8125fbe19",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[3604, 97, 688, 19, 41, InheritFromParent,ExpressionUUID->"3b809e43-d2f6-4f4a-b810-e1659f4a791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[4295, 118, 923, 22, 81, InheritFromParent,ExpressionUUID->"26686cf6-295b-456f-8440-5cecf0e696d4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5243, 144, 437, 9, 23, "Print",ExpressionUUID->"323b0b43-1933-4a4d-8d67-cc689ab3de7e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5683, 155, 709, 17, 25, "Print",ExpressionUUID->"d6c5f485-5dc5-4431-8543-843bd39d1b58",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6395, 174, 458, 9, 25, "Print",ExpressionUUID->"b5a8c692-548b-4b15-bc8e-f1606953eb03",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6856, 185, 417, 8, 25, "Print",ExpressionUUID->"ca3e3494-a5eb-42f9-bf9c-084a6575d0f5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7276, 195, 398, 8, 25, "Print",ExpressionUUID->"dce92f5f-0b7b-4832-a094-5a29b828ef4c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7677, 205, 439, 9, 23, "Print",ExpressionUUID->"afc7b575-1f7c-427f-b676-a58e99b54b66",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8119, 216, 715, 17, 25, "Print",ExpressionUUID->"23de39fb-26b9-4d84-82e3-da0a04a1115f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8837, 235, 458, 9, 25, "Print",ExpressionUUID->"574d02c4-4d57-4750-b337-f1c46ac5862c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9298, 246, 437, 9, 23, "Print",ExpressionUUID->"48521381-9713-4ce9-864f-2b453436faf0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9738, 257, 709, 17, 25, "Print",ExpressionUUID->"23024247-584c-4c96-8b6f-c721149f15c5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10450, 276, 508, 10, 45, "Print",ExpressionUUID->"5773044e-1cdd-42e1-957b-023676b56af9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10961, 288, 679, 16, 25, "Print",ExpressionUUID->"31a3b4d1-3ec0-4321-997b-18407e25a553",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[11643, 306, 763, 17, 25, "Print",ExpressionUUID->"872a2ace-a03b-45ad-b812-2627df56dad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[12409, 325, 864, 17, 25, "Print",ExpressionUUID->"1be38cd1-3cc7-44e0-bc52-6df574d1c2b9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[13276, 344, 822, 17, 25, "Print",ExpressionUUID->"7061ace8-a728-4a87-b6e8-c70ed05fdb9c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14101, 363, 840, 17, 25, "Print",ExpressionUUID->"66be857f-bca3-4910-8e8b-bb1965f6d674",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14944, 382, 439, 9, 23, "Print",ExpressionUUID->"7aa4e98b-2b90-4a24-b206-6c8dc6252de7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[15386, 393, 706, 16, 25, "Print",ExpressionUUID->"01a2dfb3-df3e-4524-923f-193f1ee8f902",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16095, 411, 484, 9, 45, "Print",ExpressionUUID->"e524aae7-d731-4da4-b993-13b51dadae3c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16582, 422, 805, 18, 25, "Print",ExpressionUUID->"62a61f68-d160-4d30-8b50-55d247c0e779",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[17390, 442, 799, 17, 25, "Print",ExpressionUUID->"2e9f0da9-6901-493b-b37a-ef1dfe1aec8a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[18192, 461, 846, 17, 25, "Print",ExpressionUUID->"fd1dd82e-8dcd-48c3-9461-abbbe51137da",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19041, 480, 759, 17, 25, "Print",ExpressionUUID->"dcf6e6b9-3fe0-4127-98be-ecea4457fed2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19803, 499, 437, 9, 23, "Print",ExpressionUUID->"92dfb0cc-4789-482e-b696-12f7352ec09d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20243, 510, 709, 17, 25, "Print",ExpressionUUID->"d1cf077f-7149-4890-96bb-cd3adae9d216",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20955, 529, 476, 9, 25, "Print",ExpressionUUID->"ea9021ff-5cfd-4155-8028-a1585c035bfd",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21434, 540, 437, 9, 23, "Print",ExpressionUUID->"4cb132fe-915a-47f8-ba42-3fb34ee0abab",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21874, 551, 727, 17, 25, "Print",ExpressionUUID->"c13bab9e-02ca-433e-aebc-f78dcdaf592d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[22604, 570, 463, 9, 25, "Print",ExpressionUUID->"4f95d5a3-7129-406e-8568-b27ba2b8b59b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23070, 581, 437, 9, 23, "Print",ExpressionUUID->"2cd8248f-5158-464d-b269-55c1932871e0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23510, 592, 708, 16, 25, "Print",ExpressionUUID->"865cb17b-7c96-4fb6-a4d7-b1d2fe214dc9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24221, 610, 447, 9, 25, "Print",ExpressionUUID->"6f09edce-f6f6-4d28-9083-cf176e6e82d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24671, 621, 769, 18, 25, "Print",ExpressionUUID->"ca7368dd-3f4a-4b30-8b15-7618f53d721e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[25443, 641, 844, 17, 25, "Print",ExpressionUUID->"4420b90e-a632-482d-b04c-c6cc5b4024c1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26290, 660, 437, 9, 23, "Print",ExpressionUUID->"0d53df74-4ea0-45c1-bab2-6617740b19f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26730, 671, 729, 17, 25, "Print",ExpressionUUID->"a3cb39a0-e8fc-4781-af32-f4418b309b89",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27462, 690, 477, 9, 25, "Print",ExpressionUUID->"5a91617f-dbe1-4aee-a2c9-f6a22f3c8c18",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27942, 701, 436, 9, 23, "Print",ExpressionUUID->"8be6937d-ed63-4de9-94fb-08ec19588479",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28381, 712, 415, 8, 25, "Print",ExpressionUUID->"5b413eff-9b52-463e-bdd0-db947ebe7c3e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28799, 722, 437, 9, 23, "Print",ExpressionUUID->"f99ae39d-53b8-448a-82ff-7b0faa0ddd7c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29239, 733, 715, 17, 25, "Print",ExpressionUUID->"41d159ee-f66b-4ec8-ba2a-989f3f1487f1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29957, 752, 507, 10, 45, "Print",ExpressionUUID->"dd938ca7-6cbf-4871-b2cd-40f5d5e82ad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30467, 764, 439, 9, 23, "Print",ExpressionUUID->"7c3d6dcd-1bc3-45ce-9428-b4fb990ce33e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30909, 775, 710, 16, 25, "Print",ExpressionUUID->"6cdaf39b-fc2d-48b3-805f-8826f49bb899",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[31622, 793, 474, 9, 25, "Print",ExpressionUUID->"65aa0dc6-fa75-4e5a-9e72-bda776caf6f2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32099, 804, 486, 9, 25, "Print",ExpressionUUID->"244f0ac0-b1fa-4b7f-828a-99eed080d3bb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32588, 815, 757, 17, 25, "Print",ExpressionUUID->"77e59c75-0569-4c5b-88f4-8a3bc242ed27",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33348, 834, 439, 9, 23, "Print",ExpressionUUID->"6b90bd70-24d1-47bc-8e49-e597a39ba247",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33790, 845, 738, 18, 25, "Print",ExpressionUUID->"04e62656-e161-4e61-bda3-7e75717e8c92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34531, 865, 460, 9, 25, "Print",ExpressionUUID->"383567e6-b4a8-4966-8ac9-c0ccaf084a44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34994, 876, 437, 9, 23, "Print",ExpressionUUID->"19fd2032-d9b2-47b8-9169-9f457881a9a8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[35434, 887, 592, 11, 65, "Print",ExpressionUUID->"336ac5be-41b1-4631-ad29-bcd5ef3f3764",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36029, 900, 437, 9, 23, "Print",ExpressionUUID->"ed21db18-371d-4c65-8d93-f560c4e43105",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36481, 912, 708, 20, 35, InheritFromParent,ExpressionUUID->"7640975b-0fe9-4643-b47c-be5b016d6f9e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37192, 934, 712, 20, 54, InheritFromParent,ExpressionUUID->"b84d46a0-8f09-43bb-bc4b-56162b9fcf69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37907, 956, 972, 23, 81, InheritFromParent,ExpressionUUID->"19e9ed3f-c481-497e-afc6-f7da2c4bafe9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[38882, 981, 799, 17, 25, "Print",ExpressionUUID->"6906580a-4558-4bbe-bf0e-7c16ba99ab3d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[39684, 1000, 7613, 266, 92, InheritFromParent,ExpressionUUID->"74aac581-908d-4aa2-b5b2-fef7cc572235",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[47300, 1268, 951, 23, 81, InheritFromParent,ExpressionUUID->"494dd010-24a9-45a0-a465-eff3b3de769d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48254, 1293, 685, 19, 41, InheritFromParent,ExpressionUUID->"d840fcaf-aaa7-4b67-8321-14f0c79c712c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48942, 1314, 818, 21, 58, InheritFromParent,ExpressionUUID->"1a6e2d40-ed52-407e-8f50-e0b9455ead24",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[49785, 1339, 892, 19, 25, "Print",ExpressionUUID->"efbc3a1e-25c8-4110-aa87-f4b2c401161a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[50680, 1360, 943, 21, 25, "Print",ExpressionUUID->"ee72a628-8b2b-4587-ad28-a3b98ad0298c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[51638, 1384, 649, 17, 35, InheritFromParent,ExpressionUUID->"2dcbb549-93f3-44bf-b839-10d5215e6a09",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[52290, 1403, 1352, 37, 52, InheritFromParent,ExpressionUUID->"7ae24dfc-66ae-4a53-8f20-5a6022436885",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[53645, 1442, 424, 8, 41, InheritFromParent,ExpressionUUID->"eba1453e-4f9a-42e2-8c3f-5e6062f326ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54072, 1452, 646, 17, 35, InheritFromParent,ExpressionUUID->"5f64a805-243d-42e5-bc87-a2782c2cdd0b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54721, 1471, 1396, 38, 52, InheritFromParent,ExpressionUUID->"60156e09-a022-4b81-9697-a3e819a5673c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[56120, 1511, 26201, 816, 93, InheritFromParent,ExpressionUUID->"8cdf4af9-b767-472b-84fc-d82a415ab18b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[82324, 2329, 1252, 27, 150, InheritFromParent,ExpressionUUID->"69e59fb4-5c2f-4c22-9474-3b397b96e83b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[83579, 2358, 1068, 24, 104, InheritFromParent,ExpressionUUID->"9d78e71d-e0fc-47ea-8b40-1f0c35936d2a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[84650, 2384, 688, 19, 41, InheritFromParent,ExpressionUUID->"a702087f-7f0a-4a29-afa9-8595374e609c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[85341, 2405, 833, 21, 58, InheritFromParent,ExpressionUUID->"d22212a8-7e21-400c-a7c4-6154d10577ea",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[86177, 2428, 970, 23, 81, InheritFromParent,ExpressionUUID->"fb602348-7013-4bc7-a060-71ecd67a7b1d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[87150, 2453, 117941, 3523, 312, InheritFromParent,ExpressionUUID->"0cd8973f-3019-433f-91e0-fb859654f7e2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[205094, 5978, 918, 23, 81, InheritFromParent,ExpressionUUID->"f2575653-814a-4991-a2de-9ce7ed722149",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[206015, 6003, 26653, 774, 118, InheritFromParent,ExpressionUUID->"1d261ece-ab42-4b33-a7cf-22ae810c6dcc",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[232671, 6779, 1035, 24, 104, InheritFromParent,ExpressionUUID->"a86af238-0e18-4d41-a788-62e409387ad1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[233709, 6805, 1124, 25, 127, InheritFromParent,ExpressionUUID->"97a46e92-275a-47a1-a901-467264d86f54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[234836, 6832, 910, 20, 25, "Print",ExpressionUUID->"9ca02f3c-a9ba-4b26-9633-0117c1b9c7a6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[235749, 6854, 1332, 36, 52, InheritFromParent,ExpressionUUID->"cb4d3995-bf8b-4ca6-9ce1-2f53df529da7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[237084, 6892, 6229, 183, 56, InheritFromParent,ExpressionUUID->"84e5208f-6d8b-4803-b36f-4d82c8bbbad6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[243316, 7077, 686, 19, 35, InheritFromParent,ExpressionUUID->"e09aef32-3cff-4a32-8413-f0cab2e0ab9f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[244005, 7098, 1279, 36, 52, InheritFromParent,ExpressionUUID->"218c7d03-6c3a-47cc-bf25-13520291791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[245287, 7136, 941, 23, 81, InheritFromParent,ExpressionUUID->"d3e25584-c3d9-4e03-89c2-44a581a6a931",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246231, 7161, 696, 20, 35, InheritFromParent,ExpressionUUID->"78f997fa-c618-4a9e-b48c-1e4fae4b04f4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246930, 7183, 910, 20, 25, "Print",ExpressionUUID->"f05579ee-6cbc-46b5-9f4f-779a59ef958f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[247843, 7205, 1203, 26, 127, InheritFromParent,ExpressionUUID->"f35e9a5b-c4dd-47e3-b2a7-9945e1d50e0e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[249049, 7233, 1169, 26, 127, InheritFromParent,ExpressionUUID->"f4b93215-c9c0-48a0-ad66-68810261018f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[250221, 7261, 930, 21, 25, "Print",ExpressionUUID->"94db25a8-ff82-49c6-9371-3b3906f4ffe5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[251154, 7284, 1333, 36, 52, InheritFromParent,ExpressionUUID->"570c9060-fb52-44a6-aa2e-389e9d5b02f6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[252490, 7322, 650, 17, 35, InheritFromParent,ExpressionUUID->"9f952f08-0179-4acb-ad53-c119682c92aa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[253143, 7341, 1319, 36, 52, InheritFromParent,ExpressionUUID->"b5bbdc2c-55b8-4870-b53d-0327b9f76fa3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[254465, 7379, 2652, 79, 49, InheritFromParent,ExpressionUUID->"96617eac-23dc-476b-9652-b1dce9217326",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257120, 7460, 722, 20, 35, InheritFromParent,ExpressionUUID->"d73d082a-4779-4c5d-9abe-ba15980c9aba",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257845, 7482, 2336, 66, 56, InheritFromParent,ExpressionUUID->"6be96410-1bf9-449b-a873-8f2892d0394d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[260184, 7550, 3631, 108, 56, InheritFromParent,ExpressionUUID->"38b4785c-5b69-4f18-ac19-480c5ae84db3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[263818, 7660, 730, 20, 35, InheritFromParent,ExpressionUUID->"0f72e7b7-7ed1-44e4-b60a-53bb0bdce2de",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[264551, 7682, 630, 17, 35, InheritFromParent,ExpressionUUID->"0982f795-e428-4d19-8d15-b8ddb256bfff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265184, 7701, 600, 15, 41, InheritFromParent,ExpressionUUID->"d7d4a64a-4e5a-4912-b9ff-f899ec1dc807",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265787, 7718, 4316, 133, 49, InheritFromParent,ExpressionUUID->"aca6ec55-9556-45e8-9c9a-845b1241b594",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270106, 7853, 629, 17, 35, InheritFromParent,ExpressionUUID->"e547d27a-2162-4ea3-ad37-2ef09e5f4c86",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270738, 7872, 596, 15, 41, InheritFromParent,ExpressionUUID->"ed922378-bd8c-4ceb-b516-8d36678b0907",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[271337, 7889, 6691, 203, 49, InheritFromParent,ExpressionUUID->"db353d9f-513f-4f9b-a0c8-aafde492e828",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278031, 8094, 635, 17, 35, InheritFromParent,ExpressionUUID->"7719cccd-757a-4763-a80f-ac47a8e9174d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278669, 8113, 1281, 36, 52, InheritFromParent,ExpressionUUID->"4d414f63-f7a4-495b-8cc6-d7055f83ad50",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[279953, 8151, 3340, 99, 52, InheritFromParent,ExpressionUUID->"d474b63f-5321-4855-b79e-084a20afd87e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[283296, 8252, 858, 22, 81, InheritFromParent,ExpressionUUID->"3dee2795-4d05-4efe-a2f8-6bccf06b2d21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[284157, 8276, 7234, 212, 56, InheritFromParent,ExpressionUUID->"f1aa6cd9-3914-4afc-8549-0e0268c04613",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[291394, 8490, 13120, 388, 56, InheritFromParent,ExpressionUUID->"f8d09264-8ab1-46dd-887b-e5ca058ee75c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[304517, 8880, 743, 20, 58, InheritFromParent,ExpressionUUID->"0c0bb409-a2f6-4fee-b8c8-3b461b842efa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[305263, 8902, 1279, 36, 52, InheritFromParent,ExpressionUUID->"f4f145a4-47cd-4c20-a77d-fb8afa3c8a77",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[306545, 8940, 13331, 395, 56, InheritFromParent,ExpressionUUID->"24fe1dd9-9f96-4acd-8ea6-bc2e71ca3f08",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[319879, 9337, 654, 17, 35, InheritFromParent,ExpressionUUID->"3ba01e8b-167b-479a-81ec-f428c62f5f81",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[320558, 9358, 456, 9, 25, "Print",ExpressionUUID->"b636a247-8891-49df-a008-20813b773799",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321017, 9369, 367, 8, 23, "Print",ExpressionUUID->"4bf2e0fa-3ba0-4464-a442-50a9cc50abdf",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321399, 9380, 1360, 38, 52, InheritFromParent,ExpressionUUID->"ef82b0f8-f076-461a-bff9-66027e60bdfe",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[322762, 9420, 13271, 394, 56, InheritFromParent,ExpressionUUID->"a57de255-7d1b-4c42-b265-7c7745be17b6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336036, 9816, 749, 20, 58, InheritFromParent,ExpressionUUID->"c303681a-55e6-4cfd-8724-f0b7162d116c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336788, 9838, 40718, 1180, 118, InheritFromParent,ExpressionUUID->"29e07eb3-976c-411b-9f94-16375400abae",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[377509, 11020, 1011, 24, 104, InheritFromParent,ExpressionUUID->"262e2a6a-5401-403a-895c-4594c6210ba7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[378523, 11046, 1872, 39, 368, InheritFromParent,ExpressionUUID->"fa281744-8557-47cc-9ab2-37c4eb2955eb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[380398, 11087, 839, 21, 58, InheritFromParent,ExpressionUUID->"6233d3d5-c5d2-42cf-8bae-2b61b7138602",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381262, 11112, 456, 9, 25, "Print",ExpressionUUID->"6e61b564-aa01-4740-974f-4651cc6f1c16",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381721, 11123, 368, 8, 23, "Print",ExpressionUUID->"c293088e-c2a0-420e-93b5-979f7126af49",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382104, 11134, 677, 19, 41, InheritFromParent,ExpressionUUID->"f2a71967-f0da-4412-8bc7-02eaf59f5458",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382784, 11155, 782, 21, 58, InheritFromParent,ExpressionUUID->"195600ce-ea6b-44b0-94da-8a294f8ad95e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[383569, 11178, 825, 21, 58, InheritFromParent,ExpressionUUID->"c9d6f1f3-f340-4933-ad76-6dcdeee462a2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[384397, 11201, 24829, 737, 81, InheritFromParent,ExpressionUUID->"6ac621ba-2f0d-4b0c-9588-6ef6799b1710",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[409229, 11940, 885, 22, 81, InheritFromParent,ExpressionUUID->"a4a2657e-e1be-43c7-b9dc-37ad9b9aa9e9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[410117, 11964, 78067, 2298, 229, InheritFromParent,ExpressionUUID->"8d289f74-704d-420a-80d8-761be6d9e1ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488187, 14264, 775, 20, 58, InheritFromParent,ExpressionUUID->"869d6edf-1a19-43ae-b937-da3fc25e528e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488965, 14286, 1606, 36, 258, InheritFromParent,ExpressionUUID->"b541844c-60ee-4b27-ad80-c9abc93a8437",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[490574, 14324, 688, 19, 41, InheritFromParent,ExpressionUUID->"c7f66d35-0768-40f4-9317-e3a2600040b8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[491265, 14345, 849, 21, 58, InheritFromParent,ExpressionUUID->"3a5f6d79-e2de-4063-a5e5-c5722df33822",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[492117, 14368, 12863, 382, 56, InheritFromParent,ExpressionUUID->"83d3926f-9e0d-4aed-a1e4-0aa3b2009d92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[504983, 14752, 810, 21, 58, InheritFromParent,ExpressionUUID->"15068d50-44a9-490e-8bbe-da6f6b0658f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[505796, 14775, 681, 19, 41, InheritFromParent,ExpressionUUID->"6012b86f-c5b5-4584-bcf3-2662a484fb69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[506480, 14796, 728, 20, 35, InheritFromParent,ExpressionUUID->"216ecab2-23d3-4088-8085-e8257fb73d07",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507211, 14818, 659, 17, 35, InheritFromParent,ExpressionUUID->"6799a4f0-567b-412f-aaff-a64c38495a67",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507873, 14837, 4361, 128, 52, InheritFromParent,ExpressionUUID->"c0f00af1-c65e-46b6-bea7-af95cee96b01",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512237, 14967, 660, 17, 35, InheritFromParent,ExpressionUUID->"d7863f6d-16db-4d15-ac48-8d32128a9b54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512900, 14986, 5405, 155, 52, InheritFromParent,ExpressionUUID->"f843b089-4a70-4161-9249-f59c662f230f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[518308, 15143, 785, 21, 58, InheritFromParent,ExpressionUUID->"b68ed01c-fdb9-4a3e-bc81-7f1617a837ce",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519096, 15166, 705, 19, 41, InheritFromParent,ExpressionUUID->"55ce4beb-ae95-4d2b-b519-c5423a1e8703",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519804, 15187, 796, 21, 58, InheritFromParent,ExpressionUUID->"50f39a67-37f1-4fa0-825d-00e049d7d06e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[520603, 15210, 723, 20, 35, InheritFromParent,ExpressionUUID->"971aec87-bbbb-4f25-9de6-b7b2fd24a27c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[521329, 15232, 124875, 3681, 391, InheritFromParent,ExpressionUUID->"62b83f51-f719-4613-b1fb-27f8830506c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646207, 18915, 695, 19, 35, InheritFromParent,ExpressionUUID->"1b4223bf-973e-44e7-b3e4-441de6e8bd44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646905, 18936, 19423, 570, 113, InheritFromParent,ExpressionUUID->"09191766-a67d-4d6e-8939-b02e692a5add",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[666331, 19508, 712, 20, 35, InheritFromParent,ExpressionUUID->"2d7971dd-7798-45ef-b4a1-01ee7ece9aef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[667046, 19530, 20284, 581, 116, InheritFromParent,ExpressionUUID->"7d4f7c77-e50a-4654-9498-79cad8026f94",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[687333, 20113, 683, 19, 35, InheritFromParent,ExpressionUUID->"7d17b821-9dda-47f6-8359-8d2788625ed8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[688019, 20134, 8540, 257, 57, InheritFromParent,ExpressionUUID->"be8309ea-16d1-4f3a-b5f7-30e460260668",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[696562, 20393, 846, 21, 58, InheritFromParent,ExpressionUUID->"d78691b9-4c55-45a8-9e3f-5020642c4d25",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[697411, 20416, 9028, 273, 57, InheritFromParent,ExpressionUUID->"79cf473e-13ee-411c-ab41-e59682891b21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[706442, 20691, 689, 19, 35, InheritFromParent,ExpressionUUID->"90f3625a-e26e-4cd7-be4b-21bb01ded13f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[707134, 20712, 2254, 65, 52, InheritFromParent,ExpressionUUID->"33fd7929-7442-4545-9960-fc9669f7f8d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[709391, 20779, 8514, 257, 57, InheritFromParent,ExpressionUUID->"fb32e72e-da5f-4405-9051-33d9a7e880f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[717908, 21038, 1322, 28, 150, InheritFromParent,ExpressionUUID->"abfbf702-3626-40d4-92f1-b685bba6b9c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[719233, 21068, 913, 22, 81, InheritFromParent,ExpressionUUID->"7f38935d-b89e-4143-bd81-a1e794a3620e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[720149, 21092, 7676, 206, 136, InheritFromParent,ExpressionUUID->"d1590147-804a-4778-a7fc-214616d69f15",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[727828, 21300, 790, 21, 58, InheritFromParent,ExpressionUUID->"143af27d-2b4e-4dac-b5ca-9bc398abb8ef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[728621, 21323, 797, 21, 58, InheritFromParent,ExpressionUUID->"d4b29d21-6334-41f2-9424-aebd2553e04f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[729421, 21346, 7903, 224, 61, InheritFromParent,ExpressionUUID->"df4416cb-5f00-4fea-8468-abbac73dd16c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[737327, 21572, 7903, 224, 61, InheritFromParent,ExpressionUUID->"d760e4b1-ced1-438e-82aa-394980ee3cf8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745233, 21798, 692, 19, 35, InheritFromParent,ExpressionUUID->"173ce9ee-ae64-42e9-9e96-9d4a40dcfef3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745928, 21819, 14383, 411, 56, InheritFromParent,ExpressionUUID->"4b203467-cb2b-46ae-8b47-71c772c3440c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760314, 22232, 678, 19, 35, InheritFromParent,ExpressionUUID->"c14e5092-7614-441f-8796-30a7a64d7499",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760995, 22253, 22477, 681, 96, InheritFromParent,ExpressionUUID->"07705ec2-49a0-4811-badb-e7afacbbcc74",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[783475, 22936, 1030, 24, 104, InheritFromParent,ExpressionUUID->"4b964916-6106-46d7-9708-3ad46712d94a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]},
 "tmp388064659070"->{
  Cell[558, 20, 946, 18, 29, "Input",ExpressionUUID->"b9384e29-ebcf-4d1e-b562-f1587dbf5da2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[1507, 40, 706, 20, 67, InheritFromParent,ExpressionUUID->"655f4e1b-1a8e-4d4a-858b-59aa7082063a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[2216, 62, 1385, 33, 170, InheritFromParent,ExpressionUUID->"e42835ff-d35e-4efe-8f43-5fa8125fbe19",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[3604, 97, 688, 19, 41, InheritFromParent,ExpressionUUID->"3b809e43-d2f6-4f4a-b810-e1659f4a791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[4295, 118, 923, 22, 81, InheritFromParent,ExpressionUUID->"26686cf6-295b-456f-8440-5cecf0e696d4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5243, 144, 437, 9, 23, "Print",ExpressionUUID->"323b0b43-1933-4a4d-8d67-cc689ab3de7e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5683, 155, 709, 17, 25, "Print",ExpressionUUID->"d6c5f485-5dc5-4431-8543-843bd39d1b58",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6395, 174, 458, 9, 25, "Print",ExpressionUUID->"b5a8c692-548b-4b15-bc8e-f1606953eb03",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6856, 185, 417, 8, 25, "Print",ExpressionUUID->"ca3e3494-a5eb-42f9-bf9c-084a6575d0f5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7276, 195, 398, 8, 25, "Print",ExpressionUUID->"dce92f5f-0b7b-4832-a094-5a29b828ef4c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7677, 205, 439, 9, 23, "Print",ExpressionUUID->"afc7b575-1f7c-427f-b676-a58e99b54b66",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8119, 216, 715, 17, 25, "Print",ExpressionUUID->"23de39fb-26b9-4d84-82e3-da0a04a1115f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8837, 235, 458, 9, 25, "Print",ExpressionUUID->"574d02c4-4d57-4750-b337-f1c46ac5862c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9298, 246, 437, 9, 23, "Print",ExpressionUUID->"48521381-9713-4ce9-864f-2b453436faf0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9738, 257, 709, 17, 25, "Print",ExpressionUUID->"23024247-584c-4c96-8b6f-c721149f15c5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10450, 276, 508, 10, 45, "Print",ExpressionUUID->"5773044e-1cdd-42e1-957b-023676b56af9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10961, 288, 679, 16, 25, "Print",ExpressionUUID->"31a3b4d1-3ec0-4321-997b-18407e25a553",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[11643, 306, 763, 17, 25, "Print",ExpressionUUID->"872a2ace-a03b-45ad-b812-2627df56dad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[12409, 325, 864, 17, 25, "Print",ExpressionUUID->"1be38cd1-3cc7-44e0-bc52-6df574d1c2b9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[13276, 344, 822, 17, 25, "Print",ExpressionUUID->"7061ace8-a728-4a87-b6e8-c70ed05fdb9c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14101, 363, 840, 17, 25, "Print",ExpressionUUID->"66be857f-bca3-4910-8e8b-bb1965f6d674",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14944, 382, 439, 9, 23, "Print",ExpressionUUID->"7aa4e98b-2b90-4a24-b206-6c8dc6252de7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[15386, 393, 706, 16, 25, "Print",ExpressionUUID->"01a2dfb3-df3e-4524-923f-193f1ee8f902",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16095, 411, 484, 9, 45, "Print",ExpressionUUID->"e524aae7-d731-4da4-b993-13b51dadae3c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16582, 422, 805, 18, 25, "Print",ExpressionUUID->"62a61f68-d160-4d30-8b50-55d247c0e779",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[17390, 442, 799, 17, 25, "Print",ExpressionUUID->"2e9f0da9-6901-493b-b37a-ef1dfe1aec8a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[18192, 461, 846, 17, 25, "Print",ExpressionUUID->"fd1dd82e-8dcd-48c3-9461-abbbe51137da",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19041, 480, 759, 17, 25, "Print",ExpressionUUID->"dcf6e6b9-3fe0-4127-98be-ecea4457fed2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19803, 499, 437, 9, 23, "Print",ExpressionUUID->"92dfb0cc-4789-482e-b696-12f7352ec09d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20243, 510, 709, 17, 25, "Print",ExpressionUUID->"d1cf077f-7149-4890-96bb-cd3adae9d216",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20955, 529, 476, 9, 25, "Print",ExpressionUUID->"ea9021ff-5cfd-4155-8028-a1585c035bfd",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21434, 540, 437, 9, 23, "Print",ExpressionUUID->"4cb132fe-915a-47f8-ba42-3fb34ee0abab",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21874, 551, 727, 17, 25, "Print",ExpressionUUID->"c13bab9e-02ca-433e-aebc-f78dcdaf592d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[22604, 570, 463, 9, 25, "Print",ExpressionUUID->"4f95d5a3-7129-406e-8568-b27ba2b8b59b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23070, 581, 437, 9, 23, "Print",ExpressionUUID->"2cd8248f-5158-464d-b269-55c1932871e0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23510, 592, 708, 16, 25, "Print",ExpressionUUID->"865cb17b-7c96-4fb6-a4d7-b1d2fe214dc9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24221, 610, 447, 9, 25, "Print",ExpressionUUID->"6f09edce-f6f6-4d28-9083-cf176e6e82d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24671, 621, 769, 18, 25, "Print",ExpressionUUID->"ca7368dd-3f4a-4b30-8b15-7618f53d721e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[25443, 641, 844, 17, 25, "Print",ExpressionUUID->"4420b90e-a632-482d-b04c-c6cc5b4024c1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26290, 660, 437, 9, 23, "Print",ExpressionUUID->"0d53df74-4ea0-45c1-bab2-6617740b19f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26730, 671, 729, 17, 25, "Print",ExpressionUUID->"a3cb39a0-e8fc-4781-af32-f4418b309b89",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27462, 690, 477, 9, 25, "Print",ExpressionUUID->"5a91617f-dbe1-4aee-a2c9-f6a22f3c8c18",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27942, 701, 436, 9, 23, "Print",ExpressionUUID->"8be6937d-ed63-4de9-94fb-08ec19588479",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28381, 712, 415, 8, 25, "Print",ExpressionUUID->"5b413eff-9b52-463e-bdd0-db947ebe7c3e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28799, 722, 437, 9, 23, "Print",ExpressionUUID->"f99ae39d-53b8-448a-82ff-7b0faa0ddd7c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29239, 733, 715, 17, 25, "Print",ExpressionUUID->"41d159ee-f66b-4ec8-ba2a-989f3f1487f1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29957, 752, 507, 10, 45, "Print",ExpressionUUID->"dd938ca7-6cbf-4871-b2cd-40f5d5e82ad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30467, 764, 439, 9, 23, "Print",ExpressionUUID->"7c3d6dcd-1bc3-45ce-9428-b4fb990ce33e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30909, 775, 710, 16, 25, "Print",ExpressionUUID->"6cdaf39b-fc2d-48b3-805f-8826f49bb899",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[31622, 793, 474, 9, 25, "Print",ExpressionUUID->"65aa0dc6-fa75-4e5a-9e72-bda776caf6f2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32099, 804, 486, 9, 25, "Print",ExpressionUUID->"244f0ac0-b1fa-4b7f-828a-99eed080d3bb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32588, 815, 757, 17, 25, "Print",ExpressionUUID->"77e59c75-0569-4c5b-88f4-8a3bc242ed27",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33348, 834, 439, 9, 23, "Print",ExpressionUUID->"6b90bd70-24d1-47bc-8e49-e597a39ba247",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33790, 845, 738, 18, 25, "Print",ExpressionUUID->"04e62656-e161-4e61-bda3-7e75717e8c92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34531, 865, 460, 9, 25, "Print",ExpressionUUID->"383567e6-b4a8-4966-8ac9-c0ccaf084a44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34994, 876, 437, 9, 23, "Print",ExpressionUUID->"19fd2032-d9b2-47b8-9169-9f457881a9a8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[35434, 887, 592, 11, 65, "Print",ExpressionUUID->"336ac5be-41b1-4631-ad29-bcd5ef3f3764",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36029, 900, 437, 9, 23, "Print",ExpressionUUID->"ed21db18-371d-4c65-8d93-f560c4e43105",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36481, 912, 708, 20, 35, InheritFromParent,ExpressionUUID->"7640975b-0fe9-4643-b47c-be5b016d6f9e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37192, 934, 712, 20, 54, InheritFromParent,ExpressionUUID->"b84d46a0-8f09-43bb-bc4b-56162b9fcf69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37907, 956, 972, 23, 81, InheritFromParent,ExpressionUUID->"19e9ed3f-c481-497e-afc6-f7da2c4bafe9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[38882, 981, 799, 17, 25, "Print",ExpressionUUID->"6906580a-4558-4bbe-bf0e-7c16ba99ab3d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[39684, 1000, 7613, 266, 92, InheritFromParent,ExpressionUUID->"74aac581-908d-4aa2-b5b2-fef7cc572235",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[47300, 1268, 951, 23, 81, InheritFromParent,ExpressionUUID->"494dd010-24a9-45a0-a465-eff3b3de769d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48254, 1293, 685, 19, 41, InheritFromParent,ExpressionUUID->"d840fcaf-aaa7-4b67-8321-14f0c79c712c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48942, 1314, 818, 21, 58, InheritFromParent,ExpressionUUID->"1a6e2d40-ed52-407e-8f50-e0b9455ead24",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[49785, 1339, 892, 19, 25, "Print",ExpressionUUID->"efbc3a1e-25c8-4110-aa87-f4b2c401161a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[50680, 1360, 943, 21, 25, "Print",ExpressionUUID->"ee72a628-8b2b-4587-ad28-a3b98ad0298c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[51638, 1384, 649, 17, 35, InheritFromParent,ExpressionUUID->"2dcbb549-93f3-44bf-b839-10d5215e6a09",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[52290, 1403, 1352, 37, 52, InheritFromParent,ExpressionUUID->"7ae24dfc-66ae-4a53-8f20-5a6022436885",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[53645, 1442, 424, 8, 41, InheritFromParent,ExpressionUUID->"eba1453e-4f9a-42e2-8c3f-5e6062f326ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54072, 1452, 646, 17, 35, InheritFromParent,ExpressionUUID->"5f64a805-243d-42e5-bc87-a2782c2cdd0b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54721, 1471, 1396, 38, 52, InheritFromParent,ExpressionUUID->"60156e09-a022-4b81-9697-a3e819a5673c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[56120, 1511, 26201, 816, 93, InheritFromParent,ExpressionUUID->"8cdf4af9-b767-472b-84fc-d82a415ab18b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[82324, 2329, 1252, 27, 150, InheritFromParent,ExpressionUUID->"69e59fb4-5c2f-4c22-9474-3b397b96e83b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[83579, 2358, 1068, 24, 104, InheritFromParent,ExpressionUUID->"9d78e71d-e0fc-47ea-8b40-1f0c35936d2a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[84650, 2384, 688, 19, 41, InheritFromParent,ExpressionUUID->"a702087f-7f0a-4a29-afa9-8595374e609c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[85341, 2405, 833, 21, 58, InheritFromParent,ExpressionUUID->"d22212a8-7e21-400c-a7c4-6154d10577ea",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[86177, 2428, 970, 23, 81, InheritFromParent,ExpressionUUID->"fb602348-7013-4bc7-a060-71ecd67a7b1d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[87150, 2453, 117941, 3523, 312, InheritFromParent,ExpressionUUID->"0cd8973f-3019-433f-91e0-fb859654f7e2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[205094, 5978, 918, 23, 81, InheritFromParent,ExpressionUUID->"f2575653-814a-4991-a2de-9ce7ed722149",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[206015, 6003, 26653, 774, 118, InheritFromParent,ExpressionUUID->"1d261ece-ab42-4b33-a7cf-22ae810c6dcc",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[232671, 6779, 1035, 24, 104, InheritFromParent,ExpressionUUID->"a86af238-0e18-4d41-a788-62e409387ad1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[233709, 6805, 1124, 25, 127, InheritFromParent,ExpressionUUID->"97a46e92-275a-47a1-a901-467264d86f54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[234836, 6832, 910, 20, 25, "Print",ExpressionUUID->"9ca02f3c-a9ba-4b26-9633-0117c1b9c7a6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[235749, 6854, 1332, 36, 52, InheritFromParent,ExpressionUUID->"cb4d3995-bf8b-4ca6-9ce1-2f53df529da7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[237084, 6892, 6229, 183, 56, InheritFromParent,ExpressionUUID->"84e5208f-6d8b-4803-b36f-4d82c8bbbad6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[243316, 7077, 686, 19, 35, InheritFromParent,ExpressionUUID->"e09aef32-3cff-4a32-8413-f0cab2e0ab9f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[244005, 7098, 1279, 36, 52, InheritFromParent,ExpressionUUID->"218c7d03-6c3a-47cc-bf25-13520291791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[245287, 7136, 941, 23, 81, InheritFromParent,ExpressionUUID->"d3e25584-c3d9-4e03-89c2-44a581a6a931",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246231, 7161, 696, 20, 35, InheritFromParent,ExpressionUUID->"78f997fa-c618-4a9e-b48c-1e4fae4b04f4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246930, 7183, 910, 20, 25, "Print",ExpressionUUID->"f05579ee-6cbc-46b5-9f4f-779a59ef958f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[247843, 7205, 1203, 26, 127, InheritFromParent,ExpressionUUID->"f35e9a5b-c4dd-47e3-b2a7-9945e1d50e0e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[249049, 7233, 1169, 26, 127, InheritFromParent,ExpressionUUID->"f4b93215-c9c0-48a0-ad66-68810261018f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[250221, 7261, 930, 21, 25, "Print",ExpressionUUID->"94db25a8-ff82-49c6-9371-3b3906f4ffe5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[251154, 7284, 1333, 36, 52, InheritFromParent,ExpressionUUID->"570c9060-fb52-44a6-aa2e-389e9d5b02f6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[252490, 7322, 650, 17, 35, InheritFromParent,ExpressionUUID->"9f952f08-0179-4acb-ad53-c119682c92aa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[253143, 7341, 1319, 36, 52, InheritFromParent,ExpressionUUID->"b5bbdc2c-55b8-4870-b53d-0327b9f76fa3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[254465, 7379, 2652, 79, 49, InheritFromParent,ExpressionUUID->"96617eac-23dc-476b-9652-b1dce9217326",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257120, 7460, 722, 20, 35, InheritFromParent,ExpressionUUID->"d73d082a-4779-4c5d-9abe-ba15980c9aba",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257845, 7482, 2336, 66, 56, InheritFromParent,ExpressionUUID->"6be96410-1bf9-449b-a873-8f2892d0394d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[260184, 7550, 3631, 108, 56, InheritFromParent,ExpressionUUID->"38b4785c-5b69-4f18-ac19-480c5ae84db3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[263818, 7660, 730, 20, 35, InheritFromParent,ExpressionUUID->"0f72e7b7-7ed1-44e4-b60a-53bb0bdce2de",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[264551, 7682, 630, 17, 35, InheritFromParent,ExpressionUUID->"0982f795-e428-4d19-8d15-b8ddb256bfff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265184, 7701, 600, 15, 41, InheritFromParent,ExpressionUUID->"d7d4a64a-4e5a-4912-b9ff-f899ec1dc807",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265787, 7718, 4316, 133, 49, InheritFromParent,ExpressionUUID->"aca6ec55-9556-45e8-9c9a-845b1241b594",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270106, 7853, 629, 17, 35, InheritFromParent,ExpressionUUID->"e547d27a-2162-4ea3-ad37-2ef09e5f4c86",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270738, 7872, 596, 15, 41, InheritFromParent,ExpressionUUID->"ed922378-bd8c-4ceb-b516-8d36678b0907",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[271337, 7889, 6691, 203, 49, InheritFromParent,ExpressionUUID->"db353d9f-513f-4f9b-a0c8-aafde492e828",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278031, 8094, 635, 17, 35, InheritFromParent,ExpressionUUID->"7719cccd-757a-4763-a80f-ac47a8e9174d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278669, 8113, 1281, 36, 52, InheritFromParent,ExpressionUUID->"4d414f63-f7a4-495b-8cc6-d7055f83ad50",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[279953, 8151, 3340, 99, 52, InheritFromParent,ExpressionUUID->"d474b63f-5321-4855-b79e-084a20afd87e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[283296, 8252, 858, 22, 81, InheritFromParent,ExpressionUUID->"3dee2795-4d05-4efe-a2f8-6bccf06b2d21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[284157, 8276, 7234, 212, 56, InheritFromParent,ExpressionUUID->"f1aa6cd9-3914-4afc-8549-0e0268c04613",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[291394, 8490, 13120, 388, 56, InheritFromParent,ExpressionUUID->"f8d09264-8ab1-46dd-887b-e5ca058ee75c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[304517, 8880, 743, 20, 58, InheritFromParent,ExpressionUUID->"0c0bb409-a2f6-4fee-b8c8-3b461b842efa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[305263, 8902, 1279, 36, 52, InheritFromParent,ExpressionUUID->"f4f145a4-47cd-4c20-a77d-fb8afa3c8a77",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[306545, 8940, 13331, 395, 56, InheritFromParent,ExpressionUUID->"24fe1dd9-9f96-4acd-8ea6-bc2e71ca3f08",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[319879, 9337, 654, 17, 35, InheritFromParent,ExpressionUUID->"3ba01e8b-167b-479a-81ec-f428c62f5f81",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[320558, 9358, 456, 9, 25, "Print",ExpressionUUID->"b636a247-8891-49df-a008-20813b773799",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321017, 9369, 367, 8, 23, "Print",ExpressionUUID->"4bf2e0fa-3ba0-4464-a442-50a9cc50abdf",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321399, 9380, 1360, 38, 52, InheritFromParent,ExpressionUUID->"ef82b0f8-f076-461a-bff9-66027e60bdfe",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[322762, 9420, 13271, 394, 56, InheritFromParent,ExpressionUUID->"a57de255-7d1b-4c42-b265-7c7745be17b6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336036, 9816, 749, 20, 58, InheritFromParent,ExpressionUUID->"c303681a-55e6-4cfd-8724-f0b7162d116c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336788, 9838, 40718, 1180, 118, InheritFromParent,ExpressionUUID->"29e07eb3-976c-411b-9f94-16375400abae",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[377509, 11020, 1011, 24, 104, InheritFromParent,ExpressionUUID->"262e2a6a-5401-403a-895c-4594c6210ba7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[378523, 11046, 1872, 39, 368, InheritFromParent,ExpressionUUID->"fa281744-8557-47cc-9ab2-37c4eb2955eb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[380398, 11087, 839, 21, 58, InheritFromParent,ExpressionUUID->"6233d3d5-c5d2-42cf-8bae-2b61b7138602",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381262, 11112, 456, 9, 25, "Print",ExpressionUUID->"6e61b564-aa01-4740-974f-4651cc6f1c16",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381721, 11123, 368, 8, 23, "Print",ExpressionUUID->"c293088e-c2a0-420e-93b5-979f7126af49",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382104, 11134, 677, 19, 41, InheritFromParent,ExpressionUUID->"f2a71967-f0da-4412-8bc7-02eaf59f5458",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382784, 11155, 782, 21, 58, InheritFromParent,ExpressionUUID->"195600ce-ea6b-44b0-94da-8a294f8ad95e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[383569, 11178, 825, 21, 58, InheritFromParent,ExpressionUUID->"c9d6f1f3-f340-4933-ad76-6dcdeee462a2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[384397, 11201, 24829, 737, 81, InheritFromParent,ExpressionUUID->"6ac621ba-2f0d-4b0c-9588-6ef6799b1710",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[409229, 11940, 885, 22, 81, InheritFromParent,ExpressionUUID->"a4a2657e-e1be-43c7-b9dc-37ad9b9aa9e9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[410117, 11964, 78067, 2298, 229, InheritFromParent,ExpressionUUID->"8d289f74-704d-420a-80d8-761be6d9e1ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488187, 14264, 775, 20, 58, InheritFromParent,ExpressionUUID->"869d6edf-1a19-43ae-b937-da3fc25e528e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488965, 14286, 1606, 36, 258, InheritFromParent,ExpressionUUID->"b541844c-60ee-4b27-ad80-c9abc93a8437",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[490574, 14324, 688, 19, 41, InheritFromParent,ExpressionUUID->"c7f66d35-0768-40f4-9317-e3a2600040b8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[491265, 14345, 849, 21, 58, InheritFromParent,ExpressionUUID->"3a5f6d79-e2de-4063-a5e5-c5722df33822",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[492117, 14368, 12863, 382, 56, InheritFromParent,ExpressionUUID->"83d3926f-9e0d-4aed-a1e4-0aa3b2009d92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[504983, 14752, 810, 21, 58, InheritFromParent,ExpressionUUID->"15068d50-44a9-490e-8bbe-da6f6b0658f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[505796, 14775, 681, 19, 41, InheritFromParent,ExpressionUUID->"6012b86f-c5b5-4584-bcf3-2662a484fb69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[506480, 14796, 728, 20, 35, InheritFromParent,ExpressionUUID->"216ecab2-23d3-4088-8085-e8257fb73d07",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507211, 14818, 659, 17, 35, InheritFromParent,ExpressionUUID->"6799a4f0-567b-412f-aaff-a64c38495a67",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507873, 14837, 4361, 128, 52, InheritFromParent,ExpressionUUID->"c0f00af1-c65e-46b6-bea7-af95cee96b01",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512237, 14967, 660, 17, 35, InheritFromParent,ExpressionUUID->"d7863f6d-16db-4d15-ac48-8d32128a9b54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512900, 14986, 5405, 155, 52, InheritFromParent,ExpressionUUID->"f843b089-4a70-4161-9249-f59c662f230f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[518308, 15143, 785, 21, 58, InheritFromParent,ExpressionUUID->"b68ed01c-fdb9-4a3e-bc81-7f1617a837ce",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519096, 15166, 705, 19, 41, InheritFromParent,ExpressionUUID->"55ce4beb-ae95-4d2b-b519-c5423a1e8703",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519804, 15187, 796, 21, 58, InheritFromParent,ExpressionUUID->"50f39a67-37f1-4fa0-825d-00e049d7d06e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[520603, 15210, 723, 20, 35, InheritFromParent,ExpressionUUID->"971aec87-bbbb-4f25-9de6-b7b2fd24a27c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[521329, 15232, 124875, 3681, 391, InheritFromParent,ExpressionUUID->"62b83f51-f719-4613-b1fb-27f8830506c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646207, 18915, 695, 19, 35, InheritFromParent,ExpressionUUID->"1b4223bf-973e-44e7-b3e4-441de6e8bd44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646905, 18936, 19423, 570, 113, InheritFromParent,ExpressionUUID->"09191766-a67d-4d6e-8939-b02e692a5add",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[666331, 19508, 712, 20, 35, InheritFromParent,ExpressionUUID->"2d7971dd-7798-45ef-b4a1-01ee7ece9aef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[667046, 19530, 20284, 581, 116, InheritFromParent,ExpressionUUID->"7d4f7c77-e50a-4654-9498-79cad8026f94",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[687333, 20113, 683, 19, 35, InheritFromParent,ExpressionUUID->"7d17b821-9dda-47f6-8359-8d2788625ed8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[688019, 20134, 8540, 257, 57, InheritFromParent,ExpressionUUID->"be8309ea-16d1-4f3a-b5f7-30e460260668",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[696562, 20393, 846, 21, 58, InheritFromParent,ExpressionUUID->"d78691b9-4c55-45a8-9e3f-5020642c4d25",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[697411, 20416, 9028, 273, 57, InheritFromParent,ExpressionUUID->"79cf473e-13ee-411c-ab41-e59682891b21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[706442, 20691, 689, 19, 35, InheritFromParent,ExpressionUUID->"90f3625a-e26e-4cd7-be4b-21bb01ded13f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[707134, 20712, 2254, 65, 52, InheritFromParent,ExpressionUUID->"33fd7929-7442-4545-9960-fc9669f7f8d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[709391, 20779, 8514, 257, 57, InheritFromParent,ExpressionUUID->"fb32e72e-da5f-4405-9051-33d9a7e880f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[717908, 21038, 1322, 28, 150, InheritFromParent,ExpressionUUID->"abfbf702-3626-40d4-92f1-b685bba6b9c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[719233, 21068, 913, 22, 81, InheritFromParent,ExpressionUUID->"7f38935d-b89e-4143-bd81-a1e794a3620e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[720149, 21092, 7676, 206, 136, InheritFromParent,ExpressionUUID->"d1590147-804a-4778-a7fc-214616d69f15",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[727828, 21300, 790, 21, 58, InheritFromParent,ExpressionUUID->"143af27d-2b4e-4dac-b5ca-9bc398abb8ef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[728621, 21323, 797, 21, 58, InheritFromParent,ExpressionUUID->"d4b29d21-6334-41f2-9424-aebd2553e04f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[729421, 21346, 7903, 224, 61, InheritFromParent,ExpressionUUID->"df4416cb-5f00-4fea-8468-abbac73dd16c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[737327, 21572, 7903, 224, 61, InheritFromParent,ExpressionUUID->"d760e4b1-ced1-438e-82aa-394980ee3cf8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745233, 21798, 692, 19, 35, InheritFromParent,ExpressionUUID->"173ce9ee-ae64-42e9-9e96-9d4a40dcfef3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745928, 21819, 14383, 411, 56, InheritFromParent,ExpressionUUID->"4b203467-cb2b-46ae-8b47-71c772c3440c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760314, 22232, 678, 19, 35, InheritFromParent,ExpressionUUID->"c14e5092-7614-441f-8796-30a7a64d7499",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760995, 22253, 22477, 681, 96, InheritFromParent,ExpressionUUID->"07705ec2-49a0-4811-badb-e7afacbbcc74",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[783475, 22936, 1030, 24, 104, InheritFromParent,ExpressionUUID->"4b964916-6106-46d7-9708-3ad46712d94a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]},
 "tmp388064697992"->{
  Cell[558, 20, 946, 18, 29, "Input",ExpressionUUID->"b9384e29-ebcf-4d1e-b562-f1587dbf5da2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[1507, 40, 706, 20, 67, InheritFromParent,ExpressionUUID->"655f4e1b-1a8e-4d4a-858b-59aa7082063a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[2216, 62, 1385, 33, 170, InheritFromParent,ExpressionUUID->"e42835ff-d35e-4efe-8f43-5fa8125fbe19",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[3604, 97, 688, 19, 41, InheritFromParent,ExpressionUUID->"3b809e43-d2f6-4f4a-b810-e1659f4a791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[4295, 118, 923, 22, 81, InheritFromParent,ExpressionUUID->"26686cf6-295b-456f-8440-5cecf0e696d4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5243, 144, 437, 9, 23, "Print",ExpressionUUID->"323b0b43-1933-4a4d-8d67-cc689ab3de7e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[5683, 155, 709, 17, 25, "Print",ExpressionUUID->"d6c5f485-5dc5-4431-8543-843bd39d1b58",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6395, 174, 458, 9, 25, "Print",ExpressionUUID->"b5a8c692-548b-4b15-bc8e-f1606953eb03",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[6856, 185, 417, 8, 25, "Print",ExpressionUUID->"ca3e3494-a5eb-42f9-bf9c-084a6575d0f5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7276, 195, 398, 8, 25, "Print",ExpressionUUID->"dce92f5f-0b7b-4832-a094-5a29b828ef4c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[7677, 205, 439, 9, 23, "Print",ExpressionUUID->"afc7b575-1f7c-427f-b676-a58e99b54b66",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8119, 216, 715, 17, 25, "Print",ExpressionUUID->"23de39fb-26b9-4d84-82e3-da0a04a1115f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[8837, 235, 458, 9, 25, "Print",ExpressionUUID->"574d02c4-4d57-4750-b337-f1c46ac5862c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9298, 246, 437, 9, 23, "Print",ExpressionUUID->"48521381-9713-4ce9-864f-2b453436faf0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[9738, 257, 709, 17, 25, "Print",ExpressionUUID->"23024247-584c-4c96-8b6f-c721149f15c5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10450, 276, 508, 10, 45, "Print",ExpressionUUID->"5773044e-1cdd-42e1-957b-023676b56af9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[10961, 288, 679, 16, 25, "Print",ExpressionUUID->"31a3b4d1-3ec0-4321-997b-18407e25a553",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[11643, 306, 763, 17, 25, "Print",ExpressionUUID->"872a2ace-a03b-45ad-b812-2627df56dad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[12409, 325, 864, 17, 25, "Print",ExpressionUUID->"1be38cd1-3cc7-44e0-bc52-6df574d1c2b9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[13276, 344, 822, 17, 25, "Print",ExpressionUUID->"7061ace8-a728-4a87-b6e8-c70ed05fdb9c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14101, 363, 840, 17, 25, "Print",ExpressionUUID->"66be857f-bca3-4910-8e8b-bb1965f6d674",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[14944, 382, 439, 9, 23, "Print",ExpressionUUID->"7aa4e98b-2b90-4a24-b206-6c8dc6252de7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[15386, 393, 706, 16, 25, "Print",ExpressionUUID->"01a2dfb3-df3e-4524-923f-193f1ee8f902",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16095, 411, 484, 9, 45, "Print",ExpressionUUID->"e524aae7-d731-4da4-b993-13b51dadae3c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[16582, 422, 805, 18, 25, "Print",ExpressionUUID->"62a61f68-d160-4d30-8b50-55d247c0e779",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[17390, 442, 799, 17, 25, "Print",ExpressionUUID->"2e9f0da9-6901-493b-b37a-ef1dfe1aec8a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[18192, 461, 846, 17, 25, "Print",ExpressionUUID->"fd1dd82e-8dcd-48c3-9461-abbbe51137da",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19041, 480, 759, 17, 25, "Print",ExpressionUUID->"dcf6e6b9-3fe0-4127-98be-ecea4457fed2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[19803, 499, 437, 9, 23, "Print",ExpressionUUID->"92dfb0cc-4789-482e-b696-12f7352ec09d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20243, 510, 709, 17, 25, "Print",ExpressionUUID->"d1cf077f-7149-4890-96bb-cd3adae9d216",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[20955, 529, 476, 9, 25, "Print",ExpressionUUID->"ea9021ff-5cfd-4155-8028-a1585c035bfd",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21434, 540, 437, 9, 23, "Print",ExpressionUUID->"4cb132fe-915a-47f8-ba42-3fb34ee0abab",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[21874, 551, 727, 17, 25, "Print",ExpressionUUID->"c13bab9e-02ca-433e-aebc-f78dcdaf592d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[22604, 570, 463, 9, 25, "Print",ExpressionUUID->"4f95d5a3-7129-406e-8568-b27ba2b8b59b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23070, 581, 437, 9, 23, "Print",ExpressionUUID->"2cd8248f-5158-464d-b269-55c1932871e0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[23510, 592, 708, 16, 25, "Print",ExpressionUUID->"865cb17b-7c96-4fb6-a4d7-b1d2fe214dc9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24221, 610, 447, 9, 25, "Print",ExpressionUUID->"6f09edce-f6f6-4d28-9083-cf176e6e82d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[24671, 621, 769, 18, 25, "Print",ExpressionUUID->"ca7368dd-3f4a-4b30-8b15-7618f53d721e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[25443, 641, 844, 17, 25, "Print",ExpressionUUID->"4420b90e-a632-482d-b04c-c6cc5b4024c1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26290, 660, 437, 9, 23, "Print",ExpressionUUID->"0d53df74-4ea0-45c1-bab2-6617740b19f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[26730, 671, 729, 17, 25, "Print",ExpressionUUID->"a3cb39a0-e8fc-4781-af32-f4418b309b89",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27462, 690, 477, 9, 25, "Print",ExpressionUUID->"5a91617f-dbe1-4aee-a2c9-f6a22f3c8c18",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[27942, 701, 436, 9, 23, "Print",ExpressionUUID->"8be6937d-ed63-4de9-94fb-08ec19588479",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28381, 712, 415, 8, 25, "Print",ExpressionUUID->"5b413eff-9b52-463e-bdd0-db947ebe7c3e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[28799, 722, 437, 9, 23, "Print",ExpressionUUID->"f99ae39d-53b8-448a-82ff-7b0faa0ddd7c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29239, 733, 715, 17, 25, "Print",ExpressionUUID->"41d159ee-f66b-4ec8-ba2a-989f3f1487f1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[29957, 752, 507, 10, 45, "Print",ExpressionUUID->"dd938ca7-6cbf-4871-b2cd-40f5d5e82ad5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30467, 764, 439, 9, 23, "Print",ExpressionUUID->"7c3d6dcd-1bc3-45ce-9428-b4fb990ce33e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[30909, 775, 710, 16, 25, "Print",ExpressionUUID->"6cdaf39b-fc2d-48b3-805f-8826f49bb899",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[31622, 793, 474, 9, 25, "Print",ExpressionUUID->"65aa0dc6-fa75-4e5a-9e72-bda776caf6f2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32099, 804, 486, 9, 25, "Print",ExpressionUUID->"244f0ac0-b1fa-4b7f-828a-99eed080d3bb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[32588, 815, 757, 17, 25, "Print",ExpressionUUID->"77e59c75-0569-4c5b-88f4-8a3bc242ed27",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33348, 834, 439, 9, 23, "Print",ExpressionUUID->"6b90bd70-24d1-47bc-8e49-e597a39ba247",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[33790, 845, 738, 18, 25, "Print",ExpressionUUID->"04e62656-e161-4e61-bda3-7e75717e8c92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34531, 865, 460, 9, 25, "Print",ExpressionUUID->"383567e6-b4a8-4966-8ac9-c0ccaf084a44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[34994, 876, 437, 9, 23, "Print",ExpressionUUID->"19fd2032-d9b2-47b8-9169-9f457881a9a8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[35434, 887, 592, 11, 65, "Print",ExpressionUUID->"336ac5be-41b1-4631-ad29-bcd5ef3f3764",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36029, 900, 437, 9, 23, "Print",ExpressionUUID->"ed21db18-371d-4c65-8d93-f560c4e43105",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[36481, 912, 708, 20, 35, InheritFromParent,ExpressionUUID->"7640975b-0fe9-4643-b47c-be5b016d6f9e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37192, 934, 712, 20, 54, InheritFromParent,ExpressionUUID->"b84d46a0-8f09-43bb-bc4b-56162b9fcf69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[37907, 956, 972, 23, 81, InheritFromParent,ExpressionUUID->"19e9ed3f-c481-497e-afc6-f7da2c4bafe9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[38882, 981, 799, 17, 25, "Print",ExpressionUUID->"6906580a-4558-4bbe-bf0e-7c16ba99ab3d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[39684, 1000, 7613, 266, 92, InheritFromParent,ExpressionUUID->"74aac581-908d-4aa2-b5b2-fef7cc572235",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[47300, 1268, 951, 23, 81, InheritFromParent,ExpressionUUID->"494dd010-24a9-45a0-a465-eff3b3de769d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48254, 1293, 685, 19, 41, InheritFromParent,ExpressionUUID->"d840fcaf-aaa7-4b67-8321-14f0c79c712c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[48942, 1314, 818, 21, 58, InheritFromParent,ExpressionUUID->"1a6e2d40-ed52-407e-8f50-e0b9455ead24",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[49785, 1339, 892, 19, 25, "Print",ExpressionUUID->"efbc3a1e-25c8-4110-aa87-f4b2c401161a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[50680, 1360, 943, 21, 25, "Print",ExpressionUUID->"ee72a628-8b2b-4587-ad28-a3b98ad0298c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[51638, 1384, 649, 17, 35, InheritFromParent,ExpressionUUID->"2dcbb549-93f3-44bf-b839-10d5215e6a09",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[52290, 1403, 1352, 37, 52, InheritFromParent,ExpressionUUID->"7ae24dfc-66ae-4a53-8f20-5a6022436885",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[53645, 1442, 424, 8, 41, InheritFromParent,ExpressionUUID->"eba1453e-4f9a-42e2-8c3f-5e6062f326ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54072, 1452, 646, 17, 35, InheritFromParent,ExpressionUUID->"5f64a805-243d-42e5-bc87-a2782c2cdd0b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[54721, 1471, 1396, 38, 52, InheritFromParent,ExpressionUUID->"60156e09-a022-4b81-9697-a3e819a5673c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[56120, 1511, 26201, 816, 93, InheritFromParent,ExpressionUUID->"8cdf4af9-b767-472b-84fc-d82a415ab18b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[82324, 2329, 1252, 27, 150, InheritFromParent,ExpressionUUID->"69e59fb4-5c2f-4c22-9474-3b397b96e83b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[83579, 2358, 1068, 24, 104, InheritFromParent,ExpressionUUID->"9d78e71d-e0fc-47ea-8b40-1f0c35936d2a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[84650, 2384, 688, 19, 41, InheritFromParent,ExpressionUUID->"a702087f-7f0a-4a29-afa9-8595374e609c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[85341, 2405, 833, 21, 58, InheritFromParent,ExpressionUUID->"d22212a8-7e21-400c-a7c4-6154d10577ea",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[86177, 2428, 970, 23, 81, InheritFromParent,ExpressionUUID->"fb602348-7013-4bc7-a060-71ecd67a7b1d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[87150, 2453, 117941, 3523, 312, InheritFromParent,ExpressionUUID->"0cd8973f-3019-433f-91e0-fb859654f7e2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[205094, 5978, 918, 23, 81, InheritFromParent,ExpressionUUID->"f2575653-814a-4991-a2de-9ce7ed722149",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[206015, 6003, 26653, 774, 118, InheritFromParent,ExpressionUUID->"1d261ece-ab42-4b33-a7cf-22ae810c6dcc",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[232671, 6779, 1035, 24, 104, InheritFromParent,ExpressionUUID->"a86af238-0e18-4d41-a788-62e409387ad1",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[233709, 6805, 1124, 25, 127, InheritFromParent,ExpressionUUID->"97a46e92-275a-47a1-a901-467264d86f54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[234836, 6832, 910, 20, 25, "Print",ExpressionUUID->"9ca02f3c-a9ba-4b26-9633-0117c1b9c7a6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[235749, 6854, 1332, 36, 52, InheritFromParent,ExpressionUUID->"cb4d3995-bf8b-4ca6-9ce1-2f53df529da7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[237084, 6892, 6229, 183, 56, InheritFromParent,ExpressionUUID->"84e5208f-6d8b-4803-b36f-4d82c8bbbad6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[243316, 7077, 686, 19, 35, InheritFromParent,ExpressionUUID->"e09aef32-3cff-4a32-8413-f0cab2e0ab9f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[244005, 7098, 1279, 36, 52, InheritFromParent,ExpressionUUID->"218c7d03-6c3a-47cc-bf25-13520291791b",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[245287, 7136, 941, 23, 81, InheritFromParent,ExpressionUUID->"d3e25584-c3d9-4e03-89c2-44a581a6a931",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246231, 7161, 696, 20, 35, InheritFromParent,ExpressionUUID->"78f997fa-c618-4a9e-b48c-1e4fae4b04f4",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[246930, 7183, 910, 20, 25, "Print",ExpressionUUID->"f05579ee-6cbc-46b5-9f4f-779a59ef958f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[247843, 7205, 1203, 26, 127, InheritFromParent,ExpressionUUID->"f35e9a5b-c4dd-47e3-b2a7-9945e1d50e0e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[249049, 7233, 1169, 26, 127, InheritFromParent,ExpressionUUID->"f4b93215-c9c0-48a0-ad66-68810261018f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[250221, 7261, 930, 21, 25, "Print",ExpressionUUID->"94db25a8-ff82-49c6-9371-3b3906f4ffe5",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[251154, 7284, 1333, 36, 52, InheritFromParent,ExpressionUUID->"570c9060-fb52-44a6-aa2e-389e9d5b02f6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[252490, 7322, 650, 17, 35, InheritFromParent,ExpressionUUID->"9f952f08-0179-4acb-ad53-c119682c92aa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[253143, 7341, 1319, 36, 52, InheritFromParent,ExpressionUUID->"b5bbdc2c-55b8-4870-b53d-0327b9f76fa3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[254465, 7379, 2652, 79, 49, InheritFromParent,ExpressionUUID->"96617eac-23dc-476b-9652-b1dce9217326",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257120, 7460, 722, 20, 35, InheritFromParent,ExpressionUUID->"d73d082a-4779-4c5d-9abe-ba15980c9aba",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[257845, 7482, 2336, 66, 56, InheritFromParent,ExpressionUUID->"6be96410-1bf9-449b-a873-8f2892d0394d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[260184, 7550, 3631, 108, 56, InheritFromParent,ExpressionUUID->"38b4785c-5b69-4f18-ac19-480c5ae84db3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[263818, 7660, 730, 20, 35, InheritFromParent,ExpressionUUID->"0f72e7b7-7ed1-44e4-b60a-53bb0bdce2de",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[264551, 7682, 630, 17, 35, InheritFromParent,ExpressionUUID->"0982f795-e428-4d19-8d15-b8ddb256bfff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265184, 7701, 600, 15, 41, InheritFromParent,ExpressionUUID->"d7d4a64a-4e5a-4912-b9ff-f899ec1dc807",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[265787, 7718, 4316, 133, 49, InheritFromParent,ExpressionUUID->"aca6ec55-9556-45e8-9c9a-845b1241b594",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270106, 7853, 629, 17, 35, InheritFromParent,ExpressionUUID->"e547d27a-2162-4ea3-ad37-2ef09e5f4c86",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[270738, 7872, 596, 15, 41, InheritFromParent,ExpressionUUID->"ed922378-bd8c-4ceb-b516-8d36678b0907",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[271337, 7889, 6691, 203, 49, InheritFromParent,ExpressionUUID->"db353d9f-513f-4f9b-a0c8-aafde492e828",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278031, 8094, 635, 17, 35, InheritFromParent,ExpressionUUID->"7719cccd-757a-4763-a80f-ac47a8e9174d",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[278669, 8113, 1281, 36, 52, InheritFromParent,ExpressionUUID->"4d414f63-f7a4-495b-8cc6-d7055f83ad50",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[279953, 8151, 3340, 99, 52, InheritFromParent,ExpressionUUID->"d474b63f-5321-4855-b79e-084a20afd87e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[283296, 8252, 858, 22, 81, InheritFromParent,ExpressionUUID->"3dee2795-4d05-4efe-a2f8-6bccf06b2d21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[284157, 8276, 7234, 212, 56, InheritFromParent,ExpressionUUID->"f1aa6cd9-3914-4afc-8549-0e0268c04613",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[291394, 8490, 13120, 388, 56, InheritFromParent,ExpressionUUID->"f8d09264-8ab1-46dd-887b-e5ca058ee75c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[304517, 8880, 743, 20, 58, InheritFromParent,ExpressionUUID->"0c0bb409-a2f6-4fee-b8c8-3b461b842efa",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[305263, 8902, 1279, 36, 52, InheritFromParent,ExpressionUUID->"f4f145a4-47cd-4c20-a77d-fb8afa3c8a77",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[306545, 8940, 13331, 395, 56, InheritFromParent,ExpressionUUID->"24fe1dd9-9f96-4acd-8ea6-bc2e71ca3f08",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[319879, 9337, 654, 17, 35, InheritFromParent,ExpressionUUID->"3ba01e8b-167b-479a-81ec-f428c62f5f81",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[320558, 9358, 456, 9, 25, "Print",ExpressionUUID->"b636a247-8891-49df-a008-20813b773799",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321017, 9369, 367, 8, 23, "Print",ExpressionUUID->"4bf2e0fa-3ba0-4464-a442-50a9cc50abdf",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[321399, 9380, 1360, 38, 52, InheritFromParent,ExpressionUUID->"ef82b0f8-f076-461a-bff9-66027e60bdfe",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[322762, 9420, 13271, 394, 56, InheritFromParent,ExpressionUUID->"a57de255-7d1b-4c42-b265-7c7745be17b6",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336036, 9816, 749, 20, 58, InheritFromParent,ExpressionUUID->"c303681a-55e6-4cfd-8724-f0b7162d116c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[336788, 9838, 40718, 1180, 118, InheritFromParent,ExpressionUUID->"29e07eb3-976c-411b-9f94-16375400abae",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[377509, 11020, 1011, 24, 104, InheritFromParent,ExpressionUUID->"262e2a6a-5401-403a-895c-4594c6210ba7",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[378523, 11046, 1872, 39, 368, InheritFromParent,ExpressionUUID->"fa281744-8557-47cc-9ab2-37c4eb2955eb",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[380398, 11087, 839, 21, 58, InheritFromParent,ExpressionUUID->"6233d3d5-c5d2-42cf-8bae-2b61b7138602",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381262, 11112, 456, 9, 25, "Print",ExpressionUUID->"6e61b564-aa01-4740-974f-4651cc6f1c16",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[381721, 11123, 368, 8, 23, "Print",ExpressionUUID->"c293088e-c2a0-420e-93b5-979f7126af49",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382104, 11134, 677, 19, 41, InheritFromParent,ExpressionUUID->"f2a71967-f0da-4412-8bc7-02eaf59f5458",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[382784, 11155, 782, 21, 58, InheritFromParent,ExpressionUUID->"195600ce-ea6b-44b0-94da-8a294f8ad95e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[383569, 11178, 825, 21, 58, InheritFromParent,ExpressionUUID->"c9d6f1f3-f340-4933-ad76-6dcdeee462a2",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[384397, 11201, 24829, 737, 81, InheritFromParent,ExpressionUUID->"6ac621ba-2f0d-4b0c-9588-6ef6799b1710",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[409229, 11940, 885, 22, 81, InheritFromParent,ExpressionUUID->"a4a2657e-e1be-43c7-b9dc-37ad9b9aa9e9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[410117, 11964, 78067, 2298, 229, InheritFromParent,ExpressionUUID->"8d289f74-704d-420a-80d8-761be6d9e1ff",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488187, 14264, 775, 20, 58, InheritFromParent,ExpressionUUID->"869d6edf-1a19-43ae-b937-da3fc25e528e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[488965, 14286, 1606, 36, 258, InheritFromParent,ExpressionUUID->"b541844c-60ee-4b27-ad80-c9abc93a8437",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[490574, 14324, 688, 19, 41, InheritFromParent,ExpressionUUID->"c7f66d35-0768-40f4-9317-e3a2600040b8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[491265, 14345, 849, 21, 58, InheritFromParent,ExpressionUUID->"3a5f6d79-e2de-4063-a5e5-c5722df33822",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[492117, 14368, 12863, 382, 56, InheritFromParent,ExpressionUUID->"83d3926f-9e0d-4aed-a1e4-0aa3b2009d92",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[504983, 14752, 810, 21, 58, InheritFromParent,ExpressionUUID->"15068d50-44a9-490e-8bbe-da6f6b0658f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[505796, 14775, 681, 19, 41, InheritFromParent,ExpressionUUID->"6012b86f-c5b5-4584-bcf3-2662a484fb69",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[506480, 14796, 728, 20, 35, InheritFromParent,ExpressionUUID->"216ecab2-23d3-4088-8085-e8257fb73d07",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507211, 14818, 659, 17, 35, InheritFromParent,ExpressionUUID->"6799a4f0-567b-412f-aaff-a64c38495a67",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[507873, 14837, 4361, 128, 52, InheritFromParent,ExpressionUUID->"c0f00af1-c65e-46b6-bea7-af95cee96b01",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512237, 14967, 660, 17, 35, InheritFromParent,ExpressionUUID->"d7863f6d-16db-4d15-ac48-8d32128a9b54",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[512900, 14986, 5405, 155, 52, InheritFromParent,ExpressionUUID->"f843b089-4a70-4161-9249-f59c662f230f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[518308, 15143, 785, 21, 58, InheritFromParent,ExpressionUUID->"b68ed01c-fdb9-4a3e-bc81-7f1617a837ce",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519096, 15166, 705, 19, 41, InheritFromParent,ExpressionUUID->"55ce4beb-ae95-4d2b-b519-c5423a1e8703",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[519804, 15187, 796, 21, 58, InheritFromParent,ExpressionUUID->"50f39a67-37f1-4fa0-825d-00e049d7d06e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[520603, 15210, 723, 20, 35, InheritFromParent,ExpressionUUID->"971aec87-bbbb-4f25-9de6-b7b2fd24a27c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[521329, 15232, 124875, 3681, 391, InheritFromParent,ExpressionUUID->"62b83f51-f719-4613-b1fb-27f8830506c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646207, 18915, 695, 19, 35, InheritFromParent,ExpressionUUID->"1b4223bf-973e-44e7-b3e4-441de6e8bd44",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[646905, 18936, 19423, 570, 113, InheritFromParent,ExpressionUUID->"09191766-a67d-4d6e-8939-b02e692a5add",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[666331, 19508, 712, 20, 35, InheritFromParent,ExpressionUUID->"2d7971dd-7798-45ef-b4a1-01ee7ece9aef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[667046, 19530, 20284, 581, 116, InheritFromParent,ExpressionUUID->"7d4f7c77-e50a-4654-9498-79cad8026f94",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[687333, 20113, 683, 19, 35, InheritFromParent,ExpressionUUID->"7d17b821-9dda-47f6-8359-8d2788625ed8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[688019, 20134, 8540, 257, 57, InheritFromParent,ExpressionUUID->"be8309ea-16d1-4f3a-b5f7-30e460260668",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[696562, 20393, 846, 21, 58, InheritFromParent,ExpressionUUID->"d78691b9-4c55-45a8-9e3f-5020642c4d25",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[697411, 20416, 9028, 273, 57, InheritFromParent,ExpressionUUID->"79cf473e-13ee-411c-ab41-e59682891b21",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[706442, 20691, 689, 19, 35, InheritFromParent,ExpressionUUID->"90f3625a-e26e-4cd7-be4b-21bb01ded13f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[707134, 20712, 2254, 65, 52, InheritFromParent,ExpressionUUID->"33fd7929-7442-4545-9960-fc9669f7f8d9",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[709391, 20779, 8514, 257, 57, InheritFromParent,ExpressionUUID->"fb32e72e-da5f-4405-9051-33d9a7e880f3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[717908, 21038, 1322, 28, 150, InheritFromParent,ExpressionUUID->"abfbf702-3626-40d4-92f1-b685bba6b9c0",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[719233, 21068, 913, 22, 81, InheritFromParent,ExpressionUUID->"7f38935d-b89e-4143-bd81-a1e794a3620e",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[720149, 21092, 7676, 206, 136, InheritFromParent,ExpressionUUID->"d1590147-804a-4778-a7fc-214616d69f15",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[727828, 21300, 790, 21, 58, InheritFromParent,ExpressionUUID->"143af27d-2b4e-4dac-b5ca-9bc398abb8ef",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[728621, 21323, 797, 21, 58, InheritFromParent,ExpressionUUID->"d4b29d21-6334-41f2-9424-aebd2553e04f",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[729421, 21346, 7903, 224, 61, InheritFromParent,ExpressionUUID->"df4416cb-5f00-4fea-8468-abbac73dd16c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[737327, 21572, 7903, 224, 61, InheritFromParent,ExpressionUUID->"d760e4b1-ced1-438e-82aa-394980ee3cf8",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745233, 21798, 692, 19, 35, InheritFromParent,ExpressionUUID->"173ce9ee-ae64-42e9-9e96-9d4a40dcfef3",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[745928, 21819, 14383, 411, 56, InheritFromParent,ExpressionUUID->"4b203467-cb2b-46ae-8b47-71c772c3440c",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760314, 22232, 678, 19, 35, InheritFromParent,ExpressionUUID->"c14e5092-7614-441f-8796-30a7a64d7499",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[760995, 22253, 22477, 681, 96, InheritFromParent,ExpressionUUID->"07705ec2-49a0-4811-badb-e7afacbbcc74",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
  Cell[783475, 22936, 1030, 24, 104, InheritFromParent,ExpressionUUID->"4b964916-6106-46d7-9708-3ad46712d94a",
   CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"tmp387881731476", 785044, 22977},
 {"tmp387881759548", 836328, 23330},
 {"tmp387881774099", 887612, 23683},
 {"tmp387881790868", 938896, 24036},
 {"tmp387881843924", 990180, 24389},
 {"tmp388038648070", 1041464, 24742},
 {"tmp388039495531", 1092748, 25095},
 {"tmp388064659070", 1144032, 25448},
 {"tmp388064697992", 1195316, 25801}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[558, 20, 946, 18, 29, "Input",ExpressionUUID->"b9384e29-ebcf-4d1e-b562-f1587dbf5da2",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[1507, 40, 706, 20, 67, InheritFromParent,ExpressionUUID->"655f4e1b-1a8e-4d4a-858b-59aa7082063a",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[2216, 62, 1385, 33, 170, InheritFromParent,ExpressionUUID->"e42835ff-d35e-4efe-8f43-5fa8125fbe19",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[3604, 97, 688, 19, 41, InheritFromParent,ExpressionUUID->"3b809e43-d2f6-4f4a-b810-e1659f4a791b",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[4295, 118, 923, 22, 81, InheritFromParent,ExpressionUUID->"26686cf6-295b-456f-8440-5cecf0e696d4",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[CellGroupData[{
Cell[5243, 144, 437, 9, 23, "Print",ExpressionUUID->"323b0b43-1933-4a4d-8d67-cc689ab3de7e",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[5683, 155, 709, 17, 25, "Print",ExpressionUUID->"d6c5f485-5dc5-4431-8543-843bd39d1b58",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[6395, 174, 458, 9, 25, "Print",ExpressionUUID->"b5a8c692-548b-4b15-bc8e-f1606953eb03",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[6856, 185, 417, 8, 25, "Print",ExpressionUUID->"ca3e3494-a5eb-42f9-bf9c-084a6575d0f5",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[7276, 195, 398, 8, 25, "Print",ExpressionUUID->"dce92f5f-0b7b-4832-a094-5a29b828ef4c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[7677, 205, 439, 9, 23, "Print",ExpressionUUID->"afc7b575-1f7c-427f-b676-a58e99b54b66",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[8119, 216, 715, 17, 25, "Print",ExpressionUUID->"23de39fb-26b9-4d84-82e3-da0a04a1115f",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[8837, 235, 458, 9, 25, "Print",ExpressionUUID->"574d02c4-4d57-4750-b337-f1c46ac5862c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[9298, 246, 437, 9, 23, "Print",ExpressionUUID->"48521381-9713-4ce9-864f-2b453436faf0",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[9738, 257, 709, 17, 25, "Print",ExpressionUUID->"23024247-584c-4c96-8b6f-c721149f15c5",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[10450, 276, 508, 10, 45, "Print",ExpressionUUID->"5773044e-1cdd-42e1-957b-023676b56af9",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[10961, 288, 679, 16, 25, "Print",ExpressionUUID->"31a3b4d1-3ec0-4321-997b-18407e25a553",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[11643, 306, 763, 17, 25, "Print",ExpressionUUID->"872a2ace-a03b-45ad-b812-2627df56dad5",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[12409, 325, 864, 17, 25, "Print",ExpressionUUID->"1be38cd1-3cc7-44e0-bc52-6df574d1c2b9",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[13276, 344, 822, 17, 25, "Print",ExpressionUUID->"7061ace8-a728-4a87-b6e8-c70ed05fdb9c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[14101, 363, 840, 17, 25, "Print",ExpressionUUID->"66be857f-bca3-4910-8e8b-bb1965f6d674",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[14944, 382, 439, 9, 23, "Print",ExpressionUUID->"7aa4e98b-2b90-4a24-b206-6c8dc6252de7",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[15386, 393, 706, 16, 25, "Print",ExpressionUUID->"01a2dfb3-df3e-4524-923f-193f1ee8f902",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[16095, 411, 484, 9, 45, "Print",ExpressionUUID->"e524aae7-d731-4da4-b993-13b51dadae3c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[16582, 422, 805, 18, 25, "Print",ExpressionUUID->"62a61f68-d160-4d30-8b50-55d247c0e779",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[17390, 442, 799, 17, 25, "Print",ExpressionUUID->"2e9f0da9-6901-493b-b37a-ef1dfe1aec8a",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[18192, 461, 846, 17, 25, "Print",ExpressionUUID->"fd1dd82e-8dcd-48c3-9461-abbbe51137da",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[19041, 480, 759, 17, 25, "Print",ExpressionUUID->"dcf6e6b9-3fe0-4127-98be-ecea4457fed2",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[19803, 499, 437, 9, 23, "Print",ExpressionUUID->"92dfb0cc-4789-482e-b696-12f7352ec09d",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[20243, 510, 709, 17, 25, "Print",ExpressionUUID->"d1cf077f-7149-4890-96bb-cd3adae9d216",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[20955, 529, 476, 9, 25, "Print",ExpressionUUID->"ea9021ff-5cfd-4155-8028-a1585c035bfd",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[21434, 540, 437, 9, 23, "Print",ExpressionUUID->"4cb132fe-915a-47f8-ba42-3fb34ee0abab",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[21874, 551, 727, 17, 25, "Print",ExpressionUUID->"c13bab9e-02ca-433e-aebc-f78dcdaf592d",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[22604, 570, 463, 9, 25, "Print",ExpressionUUID->"4f95d5a3-7129-406e-8568-b27ba2b8b59b",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[23070, 581, 437, 9, 23, "Print",ExpressionUUID->"2cd8248f-5158-464d-b269-55c1932871e0",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[23510, 592, 708, 16, 25, "Print",ExpressionUUID->"865cb17b-7c96-4fb6-a4d7-b1d2fe214dc9",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[24221, 610, 447, 9, 25, "Print",ExpressionUUID->"6f09edce-f6f6-4d28-9083-cf176e6e82d9",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[24671, 621, 769, 18, 25, "Print",ExpressionUUID->"ca7368dd-3f4a-4b30-8b15-7618f53d721e",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[25443, 641, 844, 17, 25, "Print",ExpressionUUID->"4420b90e-a632-482d-b04c-c6cc5b4024c1",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[26290, 660, 437, 9, 23, "Print",ExpressionUUID->"0d53df74-4ea0-45c1-bab2-6617740b19f3",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[26730, 671, 729, 17, 25, "Print",ExpressionUUID->"a3cb39a0-e8fc-4781-af32-f4418b309b89",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[27462, 690, 477, 9, 25, "Print",ExpressionUUID->"5a91617f-dbe1-4aee-a2c9-f6a22f3c8c18",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[27942, 701, 436, 9, 23, "Print",ExpressionUUID->"8be6937d-ed63-4de9-94fb-08ec19588479",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[28381, 712, 415, 8, 25, "Print",ExpressionUUID->"5b413eff-9b52-463e-bdd0-db947ebe7c3e",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[28799, 722, 437, 9, 23, "Print",ExpressionUUID->"f99ae39d-53b8-448a-82ff-7b0faa0ddd7c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[29239, 733, 715, 17, 25, "Print",ExpressionUUID->"41d159ee-f66b-4ec8-ba2a-989f3f1487f1",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[29957, 752, 507, 10, 45, "Print",ExpressionUUID->"dd938ca7-6cbf-4871-b2cd-40f5d5e82ad5",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[30467, 764, 439, 9, 23, "Print",ExpressionUUID->"7c3d6dcd-1bc3-45ce-9428-b4fb990ce33e",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[30909, 775, 710, 16, 25, "Print",ExpressionUUID->"6cdaf39b-fc2d-48b3-805f-8826f49bb899",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[31622, 793, 474, 9, 25, "Print",ExpressionUUID->"65aa0dc6-fa75-4e5a-9e72-bda776caf6f2",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[32099, 804, 486, 9, 25, "Print",ExpressionUUID->"244f0ac0-b1fa-4b7f-828a-99eed080d3bb",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[32588, 815, 757, 17, 25, "Print",ExpressionUUID->"77e59c75-0569-4c5b-88f4-8a3bc242ed27",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[33348, 834, 439, 9, 23, "Print",ExpressionUUID->"6b90bd70-24d1-47bc-8e49-e597a39ba247",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[33790, 845, 738, 18, 25, "Print",ExpressionUUID->"04e62656-e161-4e61-bda3-7e75717e8c92",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[34531, 865, 460, 9, 25, "Print",ExpressionUUID->"383567e6-b4a8-4966-8ac9-c0ccaf084a44",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[34994, 876, 437, 9, 23, "Print",ExpressionUUID->"19fd2032-d9b2-47b8-9169-9f457881a9a8",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[35434, 887, 592, 11, 65, "Print",ExpressionUUID->"336ac5be-41b1-4631-ad29-bcd5ef3f3764",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[36029, 900, 437, 9, 23, "Print",ExpressionUUID->"ed21db18-371d-4c65-8d93-f560c4e43105",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]
}, Open  ]],
Cell[36481, 912, 708, 20, 35, InheritFromParent,ExpressionUUID->"7640975b-0fe9-4643-b47c-be5b016d6f9e",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[37192, 934, 712, 20, 54, InheritFromParent,ExpressionUUID->"b84d46a0-8f09-43bb-bc4b-56162b9fcf69",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[37907, 956, 972, 23, 81, InheritFromParent,ExpressionUUID->"19e9ed3f-c481-497e-afc6-f7da2c4bafe9",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[38882, 981, 799, 17, 25, "Print",ExpressionUUID->"6906580a-4558-4bbe-bf0e-7c16ba99ab3d",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[39684, 1000, 7613, 266, 92, InheritFromParent,ExpressionUUID->"74aac581-908d-4aa2-b5b2-fef7cc572235",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[47300, 1268, 951, 23, 81, InheritFromParent,ExpressionUUID->"494dd010-24a9-45a0-a465-eff3b3de769d",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[48254, 1293, 685, 19, 41, InheritFromParent,ExpressionUUID->"d840fcaf-aaa7-4b67-8321-14f0c79c712c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[48942, 1314, 818, 21, 58, InheritFromParent,ExpressionUUID->"1a6e2d40-ed52-407e-8f50-e0b9455ead24",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[CellGroupData[{
Cell[49785, 1339, 892, 19, 25, "Print",ExpressionUUID->"efbc3a1e-25c8-4110-aa87-f4b2c401161a",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[50680, 1360, 943, 21, 25, "Print",ExpressionUUID->"ee72a628-8b2b-4587-ad28-a3b98ad0298c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]
}, Open  ]],
Cell[51638, 1384, 649, 17, 35, InheritFromParent,ExpressionUUID->"2dcbb549-93f3-44bf-b839-10d5215e6a09",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[52290, 1403, 1352, 37, 52, InheritFromParent,ExpressionUUID->"7ae24dfc-66ae-4a53-8f20-5a6022436885",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[53645, 1442, 424, 8, 41, InheritFromParent,ExpressionUUID->"eba1453e-4f9a-42e2-8c3f-5e6062f326ff",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[54072, 1452, 646, 17, 35, InheritFromParent,ExpressionUUID->"5f64a805-243d-42e5-bc87-a2782c2cdd0b",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[54721, 1471, 1396, 38, 52, InheritFromParent,ExpressionUUID->"60156e09-a022-4b81-9697-a3e819a5673c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[56120, 1511, 26201, 816, 93, InheritFromParent,ExpressionUUID->"8cdf4af9-b767-472b-84fc-d82a415ab18b",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[82324, 2329, 1252, 27, 150, InheritFromParent,ExpressionUUID->"69e59fb4-5c2f-4c22-9474-3b397b96e83b",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[83579, 2358, 1068, 24, 104, InheritFromParent,ExpressionUUID->"9d78e71d-e0fc-47ea-8b40-1f0c35936d2a",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[84650, 2384, 688, 19, 41, InheritFromParent,ExpressionUUID->"a702087f-7f0a-4a29-afa9-8595374e609c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[85341, 2405, 833, 21, 58, InheritFromParent,ExpressionUUID->"d22212a8-7e21-400c-a7c4-6154d10577ea",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[86177, 2428, 970, 23, 81, InheritFromParent,ExpressionUUID->"fb602348-7013-4bc7-a060-71ecd67a7b1d",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[87150, 2453, 117941, 3523, 312, InheritFromParent,ExpressionUUID->"0cd8973f-3019-433f-91e0-fb859654f7e2",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[205094, 5978, 918, 23, 81, InheritFromParent,ExpressionUUID->"f2575653-814a-4991-a2de-9ce7ed722149",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[206015, 6003, 26653, 774, 118, InheritFromParent,ExpressionUUID->"1d261ece-ab42-4b33-a7cf-22ae810c6dcc",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[232671, 6779, 1035, 24, 104, InheritFromParent,ExpressionUUID->"a86af238-0e18-4d41-a788-62e409387ad1",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[233709, 6805, 1124, 25, 127, InheritFromParent,ExpressionUUID->"97a46e92-275a-47a1-a901-467264d86f54",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[234836, 6832, 910, 20, 25, "Print",ExpressionUUID->"9ca02f3c-a9ba-4b26-9633-0117c1b9c7a6",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[235749, 6854, 1332, 36, 52, InheritFromParent,ExpressionUUID->"cb4d3995-bf8b-4ca6-9ce1-2f53df529da7",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[237084, 6892, 6229, 183, 56, InheritFromParent,ExpressionUUID->"84e5208f-6d8b-4803-b36f-4d82c8bbbad6",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[243316, 7077, 686, 19, 35, InheritFromParent,ExpressionUUID->"e09aef32-3cff-4a32-8413-f0cab2e0ab9f",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[244005, 7098, 1279, 36, 52, InheritFromParent,ExpressionUUID->"218c7d03-6c3a-47cc-bf25-13520291791b",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[245287, 7136, 941, 23, 81, InheritFromParent,ExpressionUUID->"d3e25584-c3d9-4e03-89c2-44a581a6a931",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[246231, 7161, 696, 20, 35, InheritFromParent,ExpressionUUID->"78f997fa-c618-4a9e-b48c-1e4fae4b04f4",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[246930, 7183, 910, 20, 25, "Print",ExpressionUUID->"f05579ee-6cbc-46b5-9f4f-779a59ef958f",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[247843, 7205, 1203, 26, 127, InheritFromParent,ExpressionUUID->"f35e9a5b-c4dd-47e3-b2a7-9945e1d50e0e",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[249049, 7233, 1169, 26, 127, InheritFromParent,ExpressionUUID->"f4b93215-c9c0-48a0-ad66-68810261018f",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[250221, 7261, 930, 21, 25, "Print",ExpressionUUID->"94db25a8-ff82-49c6-9371-3b3906f4ffe5",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[251154, 7284, 1333, 36, 52, InheritFromParent,ExpressionUUID->"570c9060-fb52-44a6-aa2e-389e9d5b02f6",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[252490, 7322, 650, 17, 35, InheritFromParent,ExpressionUUID->"9f952f08-0179-4acb-ad53-c119682c92aa",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[253143, 7341, 1319, 36, 52, InheritFromParent,ExpressionUUID->"b5bbdc2c-55b8-4870-b53d-0327b9f76fa3",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[254465, 7379, 2652, 79, 49, InheritFromParent,ExpressionUUID->"96617eac-23dc-476b-9652-b1dce9217326",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[257120, 7460, 722, 20, 35, InheritFromParent,ExpressionUUID->"d73d082a-4779-4c5d-9abe-ba15980c9aba",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[257845, 7482, 2336, 66, 56, InheritFromParent,ExpressionUUID->"6be96410-1bf9-449b-a873-8f2892d0394d",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[260184, 7550, 3631, 108, 56, InheritFromParent,ExpressionUUID->"38b4785c-5b69-4f18-ac19-480c5ae84db3",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[263818, 7660, 730, 20, 35, InheritFromParent,ExpressionUUID->"0f72e7b7-7ed1-44e4-b60a-53bb0bdce2de",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[264551, 7682, 630, 17, 35, InheritFromParent,ExpressionUUID->"0982f795-e428-4d19-8d15-b8ddb256bfff",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[265184, 7701, 600, 15, 41, InheritFromParent,ExpressionUUID->"d7d4a64a-4e5a-4912-b9ff-f899ec1dc807",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[265787, 7718, 4316, 133, 49, InheritFromParent,ExpressionUUID->"aca6ec55-9556-45e8-9c9a-845b1241b594",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[270106, 7853, 629, 17, 35, InheritFromParent,ExpressionUUID->"e547d27a-2162-4ea3-ad37-2ef09e5f4c86",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[270738, 7872, 596, 15, 41, InheritFromParent,ExpressionUUID->"ed922378-bd8c-4ceb-b516-8d36678b0907",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[271337, 7889, 6691, 203, 49, InheritFromParent,ExpressionUUID->"db353d9f-513f-4f9b-a0c8-aafde492e828",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[278031, 8094, 635, 17, 35, InheritFromParent,ExpressionUUID->"7719cccd-757a-4763-a80f-ac47a8e9174d",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[278669, 8113, 1281, 36, 52, InheritFromParent,ExpressionUUID->"4d414f63-f7a4-495b-8cc6-d7055f83ad50",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[279953, 8151, 3340, 99, 52, InheritFromParent,ExpressionUUID->"d474b63f-5321-4855-b79e-084a20afd87e",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[283296, 8252, 858, 22, 81, InheritFromParent,ExpressionUUID->"3dee2795-4d05-4efe-a2f8-6bccf06b2d21",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[284157, 8276, 7234, 212, 56, InheritFromParent,ExpressionUUID->"f1aa6cd9-3914-4afc-8549-0e0268c04613",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[291394, 8490, 13120, 388, 56, InheritFromParent,ExpressionUUID->"f8d09264-8ab1-46dd-887b-e5ca058ee75c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[304517, 8880, 743, 20, 58, InheritFromParent,ExpressionUUID->"0c0bb409-a2f6-4fee-b8c8-3b461b842efa",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[305263, 8902, 1279, 36, 52, InheritFromParent,ExpressionUUID->"f4f145a4-47cd-4c20-a77d-fb8afa3c8a77",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[306545, 8940, 13331, 395, 56, InheritFromParent,ExpressionUUID->"24fe1dd9-9f96-4acd-8ea6-bc2e71ca3f08",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[319879, 9337, 654, 17, 35, InheritFromParent,ExpressionUUID->"3ba01e8b-167b-479a-81ec-f428c62f5f81",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[CellGroupData[{
Cell[320558, 9358, 456, 9, 25, "Print",ExpressionUUID->"b636a247-8891-49df-a008-20813b773799",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[321017, 9369, 367, 8, 23, "Print",ExpressionUUID->"4bf2e0fa-3ba0-4464-a442-50a9cc50abdf",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]
}, Open  ]],
Cell[321399, 9380, 1360, 38, 52, InheritFromParent,ExpressionUUID->"ef82b0f8-f076-461a-bff9-66027e60bdfe",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[322762, 9420, 13271, 394, 56, InheritFromParent,ExpressionUUID->"a57de255-7d1b-4c42-b265-7c7745be17b6",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[336036, 9816, 749, 20, 58, InheritFromParent,ExpressionUUID->"c303681a-55e6-4cfd-8724-f0b7162d116c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[336788, 9838, 40718, 1180, 118, InheritFromParent,ExpressionUUID->"29e07eb3-976c-411b-9f94-16375400abae",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[377509, 11020, 1011, 24, 104, InheritFromParent,ExpressionUUID->"262e2a6a-5401-403a-895c-4594c6210ba7",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[378523, 11046, 1872, 39, 368, InheritFromParent,ExpressionUUID->"fa281744-8557-47cc-9ab2-37c4eb2955eb",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[380398, 11087, 839, 21, 58, InheritFromParent,ExpressionUUID->"6233d3d5-c5d2-42cf-8bae-2b61b7138602",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[CellGroupData[{
Cell[381262, 11112, 456, 9, 25, "Print",ExpressionUUID->"6e61b564-aa01-4740-974f-4651cc6f1c16",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[381721, 11123, 368, 8, 23, "Print",ExpressionUUID->"c293088e-c2a0-420e-93b5-979f7126af49",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]
}, Open  ]],
Cell[382104, 11134, 677, 19, 41, InheritFromParent,ExpressionUUID->"f2a71967-f0da-4412-8bc7-02eaf59f5458",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[382784, 11155, 782, 21, 58, InheritFromParent,ExpressionUUID->"195600ce-ea6b-44b0-94da-8a294f8ad95e",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[383569, 11178, 825, 21, 58, InheritFromParent,ExpressionUUID->"c9d6f1f3-f340-4933-ad76-6dcdeee462a2",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[384397, 11201, 24829, 737, 81, InheritFromParent,ExpressionUUID->"6ac621ba-2f0d-4b0c-9588-6ef6799b1710",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[409229, 11940, 885, 22, 81, InheritFromParent,ExpressionUUID->"a4a2657e-e1be-43c7-b9dc-37ad9b9aa9e9",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[410117, 11964, 78067, 2298, 229, InheritFromParent,ExpressionUUID->"8d289f74-704d-420a-80d8-761be6d9e1ff",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[488187, 14264, 775, 20, 58, InheritFromParent,ExpressionUUID->"869d6edf-1a19-43ae-b937-da3fc25e528e",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[488965, 14286, 1606, 36, 258, InheritFromParent,ExpressionUUID->"b541844c-60ee-4b27-ad80-c9abc93a8437",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[490574, 14324, 688, 19, 41, InheritFromParent,ExpressionUUID->"c7f66d35-0768-40f4-9317-e3a2600040b8",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[491265, 14345, 849, 21, 58, InheritFromParent,ExpressionUUID->"3a5f6d79-e2de-4063-a5e5-c5722df33822",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[492117, 14368, 12863, 382, 56, InheritFromParent,ExpressionUUID->"83d3926f-9e0d-4aed-a1e4-0aa3b2009d92",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[504983, 14752, 810, 21, 58, InheritFromParent,ExpressionUUID->"15068d50-44a9-490e-8bbe-da6f6b0658f3",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[505796, 14775, 681, 19, 41, InheritFromParent,ExpressionUUID->"6012b86f-c5b5-4584-bcf3-2662a484fb69",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[506480, 14796, 728, 20, 35, InheritFromParent,ExpressionUUID->"216ecab2-23d3-4088-8085-e8257fb73d07",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[507211, 14818, 659, 17, 35, InheritFromParent,ExpressionUUID->"6799a4f0-567b-412f-aaff-a64c38495a67",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[507873, 14837, 4361, 128, 52, InheritFromParent,ExpressionUUID->"c0f00af1-c65e-46b6-bea7-af95cee96b01",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[512237, 14967, 660, 17, 35, InheritFromParent,ExpressionUUID->"d7863f6d-16db-4d15-ac48-8d32128a9b54",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[512900, 14986, 5405, 155, 52, InheritFromParent,ExpressionUUID->"f843b089-4a70-4161-9249-f59c662f230f",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[518308, 15143, 785, 21, 58, InheritFromParent,ExpressionUUID->"b68ed01c-fdb9-4a3e-bc81-7f1617a837ce",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[519096, 15166, 705, 19, 41, InheritFromParent,ExpressionUUID->"55ce4beb-ae95-4d2b-b519-c5423a1e8703",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[519804, 15187, 796, 21, 58, InheritFromParent,ExpressionUUID->"50f39a67-37f1-4fa0-825d-00e049d7d06e",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[520603, 15210, 723, 20, 35, InheritFromParent,ExpressionUUID->"971aec87-bbbb-4f25-9de6-b7b2fd24a27c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[521329, 15232, 124875, 3681, 391, InheritFromParent,ExpressionUUID->"62b83f51-f719-4613-b1fb-27f8830506c0",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[646207, 18915, 695, 19, 35, InheritFromParent,ExpressionUUID->"1b4223bf-973e-44e7-b3e4-441de6e8bd44",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[646905, 18936, 19423, 570, 113, InheritFromParent,ExpressionUUID->"09191766-a67d-4d6e-8939-b02e692a5add",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[666331, 19508, 712, 20, 35, InheritFromParent,ExpressionUUID->"2d7971dd-7798-45ef-b4a1-01ee7ece9aef",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[667046, 19530, 20284, 581, 116, InheritFromParent,ExpressionUUID->"7d4f7c77-e50a-4654-9498-79cad8026f94",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[687333, 20113, 683, 19, 35, InheritFromParent,ExpressionUUID->"7d17b821-9dda-47f6-8359-8d2788625ed8",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[688019, 20134, 8540, 257, 57, InheritFromParent,ExpressionUUID->"be8309ea-16d1-4f3a-b5f7-30e460260668",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[696562, 20393, 846, 21, 58, InheritFromParent,ExpressionUUID->"d78691b9-4c55-45a8-9e3f-5020642c4d25",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[697411, 20416, 9028, 273, 57, InheritFromParent,ExpressionUUID->"79cf473e-13ee-411c-ab41-e59682891b21",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[706442, 20691, 689, 19, 35, InheritFromParent,ExpressionUUID->"90f3625a-e26e-4cd7-be4b-21bb01ded13f",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[707134, 20712, 2254, 65, 52, InheritFromParent,ExpressionUUID->"33fd7929-7442-4545-9960-fc9669f7f8d9",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[709391, 20779, 8514, 257, 57, InheritFromParent,ExpressionUUID->"fb32e72e-da5f-4405-9051-33d9a7e880f3",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[717908, 21038, 1322, 28, 150, InheritFromParent,ExpressionUUID->"abfbf702-3626-40d4-92f1-b685bba6b9c0",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[719233, 21068, 913, 22, 81, InheritFromParent,ExpressionUUID->"7f38935d-b89e-4143-bd81-a1e794a3620e",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[720149, 21092, 7676, 206, 136, InheritFromParent,ExpressionUUID->"d1590147-804a-4778-a7fc-214616d69f15",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[727828, 21300, 790, 21, 58, InheritFromParent,ExpressionUUID->"143af27d-2b4e-4dac-b5ca-9bc398abb8ef",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[728621, 21323, 797, 21, 58, InheritFromParent,ExpressionUUID->"d4b29d21-6334-41f2-9424-aebd2553e04f",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[729421, 21346, 7903, 224, 61, InheritFromParent,ExpressionUUID->"df4416cb-5f00-4fea-8468-abbac73dd16c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[737327, 21572, 7903, 224, 61, InheritFromParent,ExpressionUUID->"d760e4b1-ced1-438e-82aa-394980ee3cf8",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[745233, 21798, 692, 19, 35, InheritFromParent,ExpressionUUID->"173ce9ee-ae64-42e9-9e96-9d4a40dcfef3",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[745928, 21819, 14383, 411, 56, InheritFromParent,ExpressionUUID->"4b203467-cb2b-46ae-8b47-71c772c3440c",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[760314, 22232, 678, 19, 35, InheritFromParent,ExpressionUUID->"c14e5092-7614-441f-8796-30a7a64d7499",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[760995, 22253, 22477, 681, 96, InheritFromParent,ExpressionUUID->"07705ec2-49a0-4811-badb-e7afacbbcc74",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}],
Cell[783475, 22936, 1030, 24, 104, InheritFromParent,ExpressionUUID->"4b964916-6106-46d7-9708-3ad46712d94a",
 CellTags->{"tmp387881731476", "tmp387881759548", "tmp387881774099", "tmp387881790868", "tmp387881843924", "tmp388038648070", "tmp388039495531", "tmp388064659070", "tmp388064697992"}]
}
]
*)

